<?php

	if (!(php_sapi_name() == 'cli')) {
	
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN"
        "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
	<title>Molly Installer</title>
	<link rel="stylesheet" href="docs/installer/docs.css" />
	<link rel="stylesheet" href="docs/installer/docs_print.css" media="print" />
</head>
<body>
<div class="content" style="margin-right:30px;left:30px;">

<div style="font-size: 18px; width:100%; text-align:right; color:#CC0000;">This installer 
must be run from the command line!<br /></div>

<h1>Molly Installer</h1>

	<div class="header">Description<br /></div>
	<div class="text">
		The Molly installer is is designed to automate the installation of Molly.  It will
		ask you several questions, then attempt to create the files and databases 
		necessary for Molly to function.  Creating these files and databases by   
		hand is not difficult, and is documented in the <a href="docs/#installing">Molly 
		installation docs</a>,  
		however this script should save you some time and effort.                 
		<br /><br />												  
		<em><strong>Note:</strong> The installer is new to this release (17.8.3) of Molly and has 
		<strong>not</strong> been extensively tested. It should be considered beta-level software.</em>
	</div>
	
	<div class="header">Installer Instructions<br /></div>
	<div class="text">
		The installer will only work if your PHP installation has the Command Line 
		Interface (CLI) enabled. You will need shell access, either via SSH or your
		local console.  To run the installer log in to your server, change to the 
		directory containing this installer, which will become your Molly web site, 
		and type "php install.php":
	</div>
	
		<pre class="code" style="padding-top:5px;"> 
[Ronald-Vullos-Computer:~/public_html] rvullo% <strong>php install.php</strong> <span style="border: 1px solid; border-color:#888888;"> &crarr; </span>
	 </pre>
	<div class="text">

			<blockquote>	
			<!-- Security Warning -->		
			<div class="warning_windoid">	
			<div class="warning_windoid_title">Security Warnings</div>
			<div class="windoidBody">
			
				<blockquote>
					<p>Because this script writes files and creates databases using your account 
					settings and database password it could pose a potential security risk.   
					We suggest you remove this script from your web directory <em>immediately after</em>
					you have successfully installed Molly.</p>
					
					<p>Molly is distributed using a single directory structure to facilitate installation. 
					It is fine to leave Molly's directory structure as you find it for convenience of 
					development on your local machine, however, on a live server it is <strong>very important</strong> 
					that you consider relocating the system directory such that it is <strong>not served to the web.</strong>
					The molly.ini file contains usernames and passwords and making these visible to the web
					is an extreme security risk. Molly does prevent this from happening, but can't do so if misconfigured.</p>
					
					<p>The installer will ask you if you want to relocate sensitive files and 
					directories, and to where you want to move them.</p>
					
					<p>By default, Molly creates a user 'Admin' with a password of 'clear' so    
					that you can log in and access administrative functionality immediately.  
					This is obviously a security risk, and you should either edit the appropriate
					database tables or use the registration module to set up your own secure administrative
					account(s).</p>
				</blockquote>
			</div>
			</div>
			<!-- Security Warning -->
			</blockquote>
	</div>
</div>
</body>
</html>

<?php
	} else { // We're on the Command Line, so we can proceed
	// UTILITY FUNCTIONS
	global $g_PathLoader, $g_PathParser, $g_PathMollyIni, $g_FileMollyIni;
        
	function MultipleChoice($p_QuestionString, $p_ChoicesArray) {
		$v_Answer = 0;
		$v_ErrorMessage = '';
		$v_NumChoices = count($p_ChoicesArray);
		
		while ($v_Answer < 1 or $v_Answer > $v_NumChoices) {
			echo $v_ErrorMessage;
			echo "$p_QuestionString\n";
			foreach ($p_ChoicesArray as $v_indexNum => $v_TheChoice) {
				$v_ChoiceNum = $v_indexNum + 1;
				echo "    $v_ChoiceNum. $v_TheChoice\n";
			}
			echo "> ";
			// wait for some input here
			fscanf(STDIN, "%d\n", $v_Answer);
			$v_ErrorMessage = "*** Please select a choice between 1 and $v_NumChoices. ***\n\n";
		}
		return $v_Answer;
	}

	function textQuestion($p_QuestionString, $p_Format, $p_ErrorMessage) {
		$v_ErrorMessage = '';
		$v_Answer = 0;
		
		if ($p_Format=='') { $p_Format="%[a-zA-Z0-9]\n";}
		while (!$v_Answer) {
			echo $v_ErrorMessage;
			echo "$p_QuestionString\n";
			echo "> ";
			fscanf(STDIN, $p_Format, $v_Answer);
			$v_ErrorMessage = "$p_ErrorMessage\n\n";
		}
		return rtrim($v_Answer);
	}
	
	function RelativePath($p_FromPath, $p_ToPath) {

		//split each path into directories
		$v_FromPathArray = explode("/",$p_FromPath);
		$v_ToPathArray  = explode("/",$p_ToPath);
		$i=0;
        $v_RelativePath="";
		//find at what level paths first differ
		while($i<count($v_FromPathArray) && $i<count($v_ToPathArray) && $v_FromPathArray[$i] == $v_ToPathArray[$i]) $i++;
		//travel up appropriate number of directories
		for($j=$i;$j<count($v_FromPathArray)-1;$j++) $v_RelativePath .= "../";
		//travel down appropriate directories
		for($j=$i;$j<count($v_ToPathArray); $j++) $v_RelativePath .= $v_ToPathArray[$j]."/";
		
		return $v_RelativePath;
	}
	
	function mysql_source($p_File) {
		$lines = file($p_File);
		$sql = explode(";",implode($lines));
		foreach($sql as $query) {
            mysqli_query($query);
          
		  }
        
	}

	function clear_screen() {
		if(strtoupper(substr(PHP_OS,0,3)) == "WIN") {
			system('cls');
		} else {
			system('clear');
		}
	}

	function choose_directory($p_Question,$p_Security=true) {
		global $g_isWin;
		if($g_isWin)
			$choices[] = "In the root directory of my drive (" . $_ENV["SystemDrive"] . ")";
		else
			$choices[] = "In my home Directory (" . $_SERVER["HOME"] . ")";
		$choices[] = "In another directory I will specify";
		if($p_Security)
			$choices[] = "Security is not an issue, leave it where it is.";
		else
			$choices[] = "Leave it in the system directory.";
		return  MultipleChoice($p_Question, $choices);
	}

	function enter_directory($p_Question) {
		do {
			$v_NewDir = textQuestion($p_Question, "%[^.\n]", "*** Not a valid directory name ***");
			$v_NewDir = rtrim($v_NewDir);
			$v_NewDir = str_replace("\\","/",$v_NewDir);
		} while (!is_dir($v_NewDir) && print("Error: directory does not exist.\n\n"));
		$v_NewDir = preg_replace("/^c:/","C:",$v_NewDir);
		return rtrim($v_NewDir,"/");
	}






/* ------------------- Main Program --------------------- */	
clear_screen(); // Clear the screen

//Make sure user is in the molly folder when running install script
//we don't want user doing php /pathtomolly/install.php
if(!(file_exists(getcwd().'/install.php')))
{
echo <<<ENDSCREEN
+---------------------------------------------------------------------------+
| Molly Installation Script: Error                                          |
+---------------------------------------------------------------------------+
| You must first cd to your molly directory before running the install      |
| script.  No files or databases have been changed.                         |
+---------------------------------------------------------------------------+

ENDSCREEN;
die();
}
	
echo <<<ENDSCREEN
+---------------------------------------------------------------------------+
| Molly Installation Script: Introduction                                   |
+---------------------------------------------------------------------------+
| This script is designed to automate the installation of Molly.  It will   |
| ask you several questions, then attempt to create the files and databases |
| necessary for Molly to function.  Creating these files and databases by   |
| hand is not difficult, and is documented in the Molly installation docs,  |
| however this script could save you some time and effort.                  |
|                                                                           |
| Because this script writes files and creates databases using your account |
| settings and database password it could pose a potential security risk.   |
| We suggest you remove this script from your web directory as soon as you  |
| have successfully installed Molly.                                        |
|                                                                           |
| Before proceeding you will need the username(s) and password(s) to create |
| (if neccessary) and access your MySQL database.  Because you will be      |
| entering those here you should make sure that you do not have anyone      |
| looking over your shoulder and that you are using a secure connection     |
| (SSH) before proceeding.                                                  |
+---------------------------------------------------------------------------+

ENDSCREEN;

		if(strtoupper(substr(PHP_OS,0,3)) == "WIN") {
			$g_isWin = true;
		} else {
			$g_isWin = false;
		}
	
		$g_ScriptDir = dirname($_SERVER["PHP_SELF"]) == "."?getcwd():getcwd()."/".dirname($_SERVER["PHP_SELF"]);
		$g_ScriptDir = str_replace("\\","/",$g_ScriptDir);
		$g_CurrentFile = basename($_SERVER["PHP_SELF"]);	

		// DEFAULTS (mainly used by the simple install)
		$g_PathSystem=$g_ScriptDir . "/system/";
		$g_Status ['system']='default';
		$g_PathTemplates='$g_PathSystem$g_TemplateName';
		$g_SystemDirName = "system/";
		$g_iniFileName = 'molly.ini';
		$g_LocalDirName = 'local';
		$g_TemplateName = 'templates';
		$g_PathMollyIni = '$g_PathSystem';
        //$g_Status['local'] = 'default';
        $g_Status['ErrReport']='default';

        $g_Status['templates'] = 'default';
        $g_ErrReport = "7";


		$g_doInstall = textQuestion("Would you like to install Molly now? (Y or N)", "%[yYnN]", "*** Not a valid answer, Y or N only please ***");
		if ($g_doInstall == "n" or $g_doInstall == "N") {
	
			clear_screen(); // Clear the screen


echo <<<ENDSCREEN
+---------------------------------------------------------------------------+
| Molly Installation Script: Aborted                                        |
+---------------------------------------------------------------------------+
| No files or databases have been changed.                                  |
+---------------------------------------------------------------------------+


ENDSCREEN;

			die();
		}
		$g_installType = MultipleChoice("Choose an installation method:",array("Custom Install","Simple Install"));
		switch($g_installType) {
			case 1:
				$g_simple = false;
				break;
			case 2:
				$g_simple = true;
				break;
		}		
		
		clear_screen(); // Clear the screen
		
echo <<<ENDSCREEN
+---------------------------------------------------------------------------+
| Molly Installation Script: Paths and Files                                |
+---------------------------------------------------------------------------+
| The first part of the installation process determines where your Molly    |
| files are currently located and where you want various parts of the system|
| to be.  This information will be used to create a .htaccess server        |
| configuration file in your Molly directory containing the path information|
| Molly needs, as well as creating a .ini file used to configure the other  |
| important Molly settings.                                                 |
+---------------------------------------------------------------------------+

ENDSCREEN;
		if (is_dir($g_PathSystem)) {
			$g_Answer = choose_directory("Your Molly system directory should be located in a directory which can not be\nserved to the web.  Where would you like your system directory to be located?");
			
			$move_ini_flag = false;
			switch ($g_Answer) {
			
				case 1:
					if($g_isWin) {
						echo "Move to root Dir.\n";
						// 4 backslashes so we end up with 2,
						// so when we eval the code we only have one
						$g_PathSystem=$_ENV["SystemDrive"] . '/$g_SystemDirName';
					} else {
						echo "Move to home Dir.\n";
						$g_PathSystem=$_SERVER["HOME"] . '/$g_SystemDirName';
					}
					$g_Status ['system']='moved';
					if(!$g_simple) $g_Answer = choose_directory("Your molly.ini file is placed in your system directory by default.  Where would you like your molly.ini file to be located?",false);
				break;
				
				case 2:
					echo "Move to Specified Dir.\n";
					$g_NewDir = enter_directory("Please enter the full path to the directory where you \nwant the system directory moved:");
					$g_PathSystem = $g_NewDir . '/$g_SystemDirName';
					$g_Status ['system']='moved';
					if(!$g_simple) $g_Answer = choose_directory("Your molly.ini file is placed in your system directory by default.  Where would you like your molly.ini file to be located?",false);
				break;
				
				case 3:
					echo "I will leave the system directory where it is.\n\n";
					if($g_simple) $move_ini_flag = true;
					$g_Answer = choose_directory("Your molly.ini file should be located in a directory which can not be served\nto the web.  Where would you like your molly.ini file to be located?");
				break;
			}
			if(!$g_simple or ($g_simple and $move_ini_flag)){
				switch ($g_Answer) {
					case 1:
						if($g_isWin) {
							echo "Move to root Dir.\n";
							$g_PathMollyIni = $_ENV["SystemDrive"];//.	$g_iniFileName;
						} else {
							echo "Move to home Dir.\n";
							$g_PathMollyIni=$_SERVER["HOME"];//.	$g_iniFileName; //. '/$g_iniName';
						}
						$g_Status['mollyini']='moved';
						break;
				
					case 2:
						echo "Move to Specified Dir.\n";
						$g_NewDir = enter_directory("Please enter the full path to the directory where you \nwant the molly.ini file moved (directory must exist):");
						$g_PathMollyIni=$g_NewDir;//.	$g_iniFileName; //. '/$g_iniName';
						$g_Status ['mollyini']='moved';
						break;
					
					case 3:
						$g_PathMollyIni=$g_PathSystem;//.	$g_iniFileName; //.'$g_iniName';

						break;						
				}
			} // end if move_ini_flag
		} // end if system dir exists
		
		if(!$g_simple) {
            
            
            ///TEMPLATE LOCATION????
			/*$g_Answer = choose_directory("By default Molly's templates are stored inside \nthe system directory.  \nIf you are installing Molly in a 'multiportal' configuration \nyou may wish to change this. \nWhere do you want your templates directory?",false);
		
			switch ($g_Answer) {
				case 1:
					if($g_isWin) {
						echo "Move to root Dir.\n";
						$g_PathTemplates=$_ENV["SystemDrive"] . '/$g_TemplateName';
					} else {
						echo "Move to home Dir.\n";
						$g_PathTemplates=$_SERVER["HOME"] . '/$g_TemplateName';
					}
					$g_Status['templates']='moved';
					break;
			
				case 2:
					echo "Move to Specified Dir.\n";
					$g_NewDir = enter_directory("Please enter the full path to the directory where you \nwant the templates directory moved (directory must exist):");
					$g_PathTemplates=$g_NewDir . '/$g_TemplateName';
					$g_Status['templates']='moved';
					break;
			
				case 3:
					$g_PathTemplates=$g_PathSystem . '$g_TemplateName';
					break;						
			}
            
		        //rename templates directory
			$g_RenameTemplates = textQuestion("By default Molly keeps all templates in a directory named 'templates'. \nWould you like to rename the templates directory? (Y or N)", "%[yYnN]", "*** Not a valid answer, Y or N only please ***");
			if ($g_RenameTemplates == "y" or $g_RenameTemplates == "Y") {
				$g_TemplateName = textQuestion("Please enter the new name for your templates directory:", "%[^. \n]", "*** Not a valid directory name ***");
				$g_Status['templates']='moved';
			}*/
            
            //rename system directory
			$g_RenameSystem = textQuestion("Would you like to rename the system directory? (Y or N)", "%[yYnN]", "*** Not a valid answer, Y or N only please ***");
			if ($g_RenameSystem == "y" or $g_RenameSystem == "Y") {
		
				$g_SystemDirName = textQuestion("Please enter the new name for your system directory:", "%[^. \n]", "*** Not a valid directory name ***");
				$g_SystemDirName .= "/";
				$g_Status['system']='moved';
			}
		
		  //rename molly.ini
			$g_RenameIni = textQuestion("Would you like to rename the 'molly.ini' file? (Y or N)", "%[yYnN]", "*** Not a valid answer, Y or N only please ***");
			if ($g_RenameIni == "y" or $g_RenameIni == "Y") {
		
				$g_iniFileName = textQuestion("Please enter the new name for your 'molly.ini' file:", "%[^ \n]", "*** Not a valid filename ***");
				$g_Status['mollyini']='moved';
			}
            
		$g_ChangeError = textQuestion("Would you like to adjust the error reporting level from the default of 7? (Y or N)", "%[yYnN]", "*** Not a valid answer, Y or N only please ***");
			if ($g_ChangeError == "y" or $g_ChangeError == "Y") {
		
				$g_ErrReport = textQuestion("Please enter the error reporting level that you prefer:", "%[1234567]", "*** Not a valid Error Reporting Level ***");
				$g_Status['ErrReport']='moved';
			}
//            //rename content directory
//			$g_RenameLocal = textQuestion("Molly keeps all site-specific content pages in a \nsepatate directory to facilitate upgrading to future versions.\nBy default this directory is named 'local' but it can be changed. \nWould you like to rename the content directory? (Y or N)", "%[yYnN]", "*** Not a valid answer, Y or N only please ***");
//			if ($g_RenameLocal == "y" or $g_RenameLocal == "Y") {
//				$g_LocalDirName = textQuestion("Please enter the new name for your content directory:", "%[^. \n]", "*** Not a valid directory name ***");
//				$g_Status['local']='moved';
//			}
		
            //rename templates directory
//			$g_RenameTemplates = textQuestion("By default Molly keeps all templates in a directory named 'templates'. \nWould you like to rename the templates directory? (Y or N)", "%[yYnN]", "*** Not a valid answer, Y or N only please ***");
//			if ($g_RenameTemplates == "y" or $g_RenameLocal == "Y") {
//				$g_TemplateName = textQuestion("Please enter the new name for your templates directory:", "%[^. \n]", "*** Not a valid directory name ***");
//				$g_Status['templates']='moved';
//			}
		} // end if not simple

		$g_Server = textQuestion("What is the (sub-)domain that Molly is being installed on (e.g. molly.rit.edu)", "%[a-zA-Z0-9\-.]", "*** Not a valid domain ***");
		$g_WebmasterEmail = textQuestion("What is the webmaster's email (e.g. admin@example.com)", "%[a-zA-Z0-9\-@/\.]", "*** Not a valid email ***");
		$g_WebPath = textQuestion("To set up the path for Molly's default 404 ErrorDocument, we need to know the web URL to your Molly install. Please enter the absolute server path for the root of the Molly install (e.g. /~you/m2r10/ or /m2r10/)", "%[a-zA-Z0-9\-~/\.]", "*** Not a valid path ***");
		$g_PathError = rtrim($g_WebPath,'/')."/error/404.maml";
		
		// Finalize all the paths
		$g_PathMollyIni .='$g_iniFileName';
    
		eval ("\$g_PathSystem = \"" . $g_PathSystem . '";');
		eval ("\$g_PathMollyIni = \"" . $g_PathMollyIni . '";');
		//eval ("\$g_PathTemplates = \"" . $g_PathTemplates . '";');
		$g_PathLoader = $g_PathSystem . 'loader.php';
        $g_PathParser = $g_PathSystem . 'parser.php';
        
        	$g_HTAccess = <<<ENDHTACCESS
### Apache (httpd) Configuration ###
### Apache is the name of the software that is the web server 
### (But it runs as a program called "httpd" which stands for
### HyperText Transfer Protocol Daemon

AddType application/x-httpd-php .maml .html .php .tplt .ini .inc .txt .css .mss .php4 .php3 .phtml 
DirectoryIndex index.maml index.html index.php

IndexIgnore .htaccess

Options -Indexes

SetEnv MOLLY_INI $g_iniFileName

### PHP Module Configuration ###

# E_PARSE | E_ERROR | E_WARNING
php_value error_reporting $g_ErrReport
# No Error Reporting (Production Server)
#php_value error_reporting 0

php_flag register_globals off
php_value short_open_tag off

php_value auto_prepend_file $g_PathLoader
php_value auto_append_file $g_PathParser


ENDHTACCESS;
        

        
		eval ("\$g_HTAccess = \"" . $g_HTAccess . '";');


		// move system dir
		if($g_Status['system']=='moved') {
			rename($g_ScriptDir."/system",$g_PathSystem);
		}
		// move local dir
	//	if($g_Status['local']=='moved') {
	//		rename($g_ScriptDir."/local",$g_ScriptDir."/".$g_LocalDirName);
	//	}
		// move template dir
		/*if($g_Status['templates']=='moved') {
			rename($g_PathSystem."templates",$g_PathTemplates);
		}*/
		
		
		// write .htaccess
		$fp = fopen("$g_ScriptDir/.htaccess",'w');
		fwrite($fp,$g_HTAccess);
		fclose($fp);

		echo "Summary of File Information:\n\n";
		echo "System directory will be located at: " . $g_PathSystem . "\n";
		echo "Content directory will be located at: $g_ScriptDir/$g_LocalDirName\n";
		echo "ini file will be located at: " . $g_PathMollyIni . "\n";
		//echo "Template directory will be located at: " . $g_PathTemplates . "\n";
		

		
		
//		echo "\n\n------------------------------------------------------------------";
//		echo "\n$g_HTAccess";
//		echo "\n------------------------------------------------------------------\n\n";

		clear_screen(); // Clear the screen

echo <<<ENDSCREEN
+---------------------------------------------------------------------------+
| Molly Installation Script: Database and Tables                            |
+---------------------------------------------------------------------------+
| While Molly supports several database applications, this initial version  |
| of the installer can only assist with MySQL databases.                    |
|                                                                           |
| If you are going to create the database from scratch, you will need the   |
| MySQL administrator username and password to create the database.  You    |
| can skip the database creation step if your system administrator has      |
| already created a database for you, and you merely need to create Molly's |
| tables within that database.  Either way, you will need the username and  |
| password that Molly will be using to access the database.                 |
+---------------------------------------------------------------------------+

ENDSCREEN;

		$g_doDBInstall = textQuestion("Would you like to Install Molly's database & tables now? (Y or N)\n(If you choose 'N', you will need to edit molly.ini and change\nthe database-related info.)", "%[yYnN]", "*** Not a valid answer, Y or N only please ***");
		if ($g_doDBInstall == "y" or $g_doDBInstall == "Y") {
			// load mysql extension
			// PHP_SHLIB_SUFFIX is only available in PHP 4.3.0+, so this will fail otherwise
			if (!extension_loaded('mysqli')) {
				//$prefix = (PHP_SHLIB_SUFFIX === 'dll') ? 'php_' : '';
				//dl($prefix . 'mysql.' . PHP_SHLIB_SUFFIX);
				echo("The MySQLi extension has not been loaded; cannot configure database");
				return;
			}
			clear_screen(); // Clear the screen
echo <<<ENDSCREEN
+---------------------------------------------------------------------------+
| Molly Installation Script: Database                                       |
+---------------------------------------------------------------------------+
| The first part of the database installation process creates a database    |
| for all of Molly's tables.  If your system administrator has already      |
| created this database, then you should skip this step.                    |
|                                                                           |
| WARNING: If you re-use an existing database, Molly will erase any tables  |
| with the same names as any of its own tables! All of Molly's default table|
| names begin with 'molly_' so this should not be a problem.                |
+---------------------------------------------------------------------------+

ENDSCREEN;
			$g_doCreateDatabase = textQuestion("Would you like to create a database for Molly? (Y or N)", "%[yYnN]", "*** Not a valid answer, Y or N only please ***");
			if ($g_doCreateDatabase == "y" or $g_doCreateDatabase == "Y") {
			$g_DBName = textQuestion("Please enter a name for the new database:","%[^.\n]","*** Not a valid db name ***");
				do {
					$g_DBCreateUserName = textQuestion("Please enter a username who is permitted to create databases (like root):", "%[^.\n]", "*** Not a valid user name ***");
					$g_DBCreateUserPass = textQuestion("Please enter the password for '$g_DBCreateUserName':", "%[^.\n]", "*** Not a valid password ***");
				} while(!@mysqli_connect("127.0.0.1",$g_DBCreateUserName,$g_DBCreateUserPass) && print("ERROR: Failed to connect to MySQL on localhost. Please try again.\n"));
				if(!@mysqli_query("create database $g_DBName")) {
					echo "ERROR: Failed to create database '$g_DBName'\n";
				} else {
					echo "Database created.\n";
				}
				if(!@mysqli_query("GRANT ALL PRIVILEGES ON $g_DBName.* TO $g_DBCreateUserName@localhost IDENTIFIED BY '$g_DBCreateUserPass'")) {
					echo "ERROR: Unable to grant privileges\n";
				}
			} else {
				$g_DBName = textQuestion("Please enter the name of an existing MySQL database for molly to use:","%[^.\n]","*** Not a valid database name ***");
			}
			
			do {
				$g_DBMollyUserName = textQuestion("Please enter the username Molly will use to access the database:", "%[^.\n]", "*** Not a valid user name ***");
				$g_DBMollyUserPass = textQuestion("Please enter the password Molly (as '$g_DBMollyUserName') will use to access the database:", "%[^.\n]", "*** Not a valid user name ***");
			} while( !@mysqli_connect("127.0.0.1",$g_DBMollyUserName,$g_DBMollyUserPass)
				&& print("ERROR: Failed to connect to MySQL on localhost with '$g_DBMollyUserName' and '$g_DBMollyUserPass'. Please try again.\n") );
            
            
            mysqli_select_db($g_DBName);
			echo "\nCreating the database tables...\n\n";
            
            //SELECT TABLE_NAME FROM INFORMATION_SCHEMA.TABLES WHERE TABLE_TYPE = 'BASE TABLE' AND  TABLE_SCHEMA='molly' and TABLE_NAME LIKE 'molly_%' 
            mysql_source($g_PathSystem."molly.sql");

echo <<<ENDSCREEN
+---------------------------------------------------------------------------+
| Molly Installation Script: Writing molly.ini                              |
+---------------------------------------------------------------------------+
| We will now write your molly.ini file to the location you specified       |
| earlier. You make make your own changes to the file if you wish.          |
|                                                                           |
| By default, Molly creates a user 'Admin' with a password of 'clear' so    |
| that you can log in and access administrative functionality immediately.  |
| You should go to the database module's administration page and change the |
| Admin password in the 'molly_login' table now.                            |
+---------------------------------------------------------------------------+

ENDSCREEN;
			$g_DBInstalled = true;
		} // end database install
		else { // user opted not to install database.
			$g_DBInstalled = false;
echo <<<ENDSCREEN
+---------------------------------------------------------------------------+
| Molly Installation Script: Writing molly.ini                              |
+---------------------------------------------------------------------------+
| We will now write your molly.ini file to the location you specified       |
| earlier. Your database information has not been set up, so you can now    |
| manually enter the molly.ini file to enter it if you wish.                |
|                                                                           |
| Your Molly install WILL NOT BE FUNCTIONAL until you set up the database   |
| by either (1) re-running this script or (2) editing molly.ini with your   |
| database info and running the scripts system/database/sql/dbms.sql (where |
| dbms is the name of your particular dbms) and system/database/sql/data.sql|
|                                                                           |
| By default, Molly creates a user 'Admin' with a password of 'clear' so    |
| that you can log in and access administrative functionality immediately.  |
| You should go to the database module's administration page and change the |
| Admin password in the 'molly_login' table now.                            |
+---------------------------------------------------------------------------+

ENDSCREEN;
		}

		$g_DocumentPath = RelativePath($g_PathSystem, $g_ScriptDir);
        $g_FileRoot = $g_ScriptDir."/";
        $g_SystemRoot = $g_WebPath."system/";
		//$iniContents = file_get_contents($g_PathSystem."molly.ini");
       	$iniContents = file_get_contents($g_PathMollyIni);
        $tagTerms = array("HTMLRoot = ", "SystemRoot = ", "FileRoot = ", "Server = ", "WebmasterEMail = ");
        
        $tagReplace = array($g_WebPath, $g_SystemRoot, $g_FileRoot, $g_Server, $g_WebmasterEmail);
        $iniSearch = array();
        $iniReplace = array();
        
        if($g_DBInstalled) {
            array_push($tagTerms,"DatabaseName = ", "DBUserName = ",  "DBPassword = ",  "SessionDatabase = ","SessionUser = ","SessionPassword = ","LoginDatabase[] = ","LoginDBUserName[] = ", "LoginDBPassword[] = ", "ConfigDatabase = ", "ConfigDBUserName = ", "ConfigDBPassword = ");
            array_push($tagReplace,$g_DBName, $g_DBMollyUserName, $g_DBMollyUserPass,  $g_DBName, $g_DBMollyUserName, $g_DBMollyUserPass,  $g_DBName, $g_DBMollyUserName,  $g_DBMollyUserPass,  $g_DBName,  $g_DBMollyUserName,  $g_DBMollyUserPass);
        }
        
        $lines = file($g_PathMollyIni);
        for ($i=0; $i<=count($tagTerms)-1; $i++){
            foreach($lines as $line)
            {
              // Check if the line contains the string we're looking for, and print if it does
                if(strpos($line, $tagTerms[$i]) !== false){
                    $line_array = explode('"',$line);
                    $newLine = str_replace($line_array[1],$tagReplace[$i],$line);
                    array_push($iniSearch, $line);
                    array_push($iniReplace, $newLine);
                  //  echo $line;
                 //   echo $newLine;
                }
             }
        }
		$iniContents = str_replace($iniSearch,$iniReplace,$iniContents);
    // echo $iniContents;
		$fp = fopen($g_PathMollyIni,'w');
		if(fwrite($fp,$iniContents) === false) {
			echo "\nError: molly.ini failed to be written.\n\n";
            		} else {
			echo "\n$g_PathMollyIni written. Your install is complete! Please delete this install.php file for security reasons.\n\n";
		}
		fclose($fp);
}
?>