<?php
	function m_GetDocument ($pv_URL) {
	
		$fv_TheFile = file_get_contents ($pv_URL);
		if ($fv_TheFile) {
			$fv_TheDocument = $fv_TheFile;
		} else {
			$fv_TheDocument = "<!-- -- -- -- -- File Not Read: $pv_URL -- -- -- -- -->";
		}
		
		return $fv_TheDocument;
	} //m_GetDocument

	function m_NakedHTML ($pv_URL) {
	
		//global $g_DocumentPath;
	
		$fv_TheDocument = m_GetDocument ($pv_URL);
// preg_replace ($pattern, $replacement, $subject)		
// eregi_replace ($pattern, $replacement, $string) //deprecated
		$fv_TheDocument = preg_replace ('/^.*<body/i','',$fv_TheDocument); //Strip off the <body> tag and everything before it
		$fv_TheDocument = preg_replace ('/^[^>]*>/i','',$fv_TheDocument);

		$fv_TheDocument = preg_replace ('#</html>#i','',$fv_TheDocument); //Strip off the </html> tag
		$fv_TheDocument = preg_replace ('#</body>#i','',$fv_TheDocument); //Strip off the </body> tag
		
		return $fv_TheDocument;
	
	} //m_NakedHTML

        function m_Permissions($pv_FilePathName) {
            $fv_Permissions = fileperms($pv_FilePathName);

            if     (($fv_Permissions & 0xC000) == 0xC000) { $fv_FileInfo = 's'; }
            elseif (($fv_Permissions & 0xA000) == 0xA000) { $fv_FileInfo = 'l'; }
            elseif (($fv_Permissions & 0x8000) == 0x8000) { $fv_FileInfo = '-'; }
            elseif (($fv_Permissions & 0x6000) == 0x6000) { $fv_FileInfo = 'b'; }
            elseif (($fv_Permissions & 0x4000) == 0x4000) { $fv_FileInfo = 'd'; }
            elseif (($fv_Permissions & 0x2000) == 0x2000) { $fv_FileInfo = 'c'; }
            elseif (($fv_Permissions & 0x1000) == 0x1000) { $fv_FileInfo = 'p'; }
            else                                 		  { $fv_FileInfo = 'u'; }

            // owner
            $fv_FileInfo .= (($fv_Permissions & 0x0100) ? 'r' : '-');
            $fv_FileInfo .= (($fv_Permissions & 0x0080) ? 'w' : '-');
            $fv_FileInfo .= (($fv_Permissions & 0x0040) ? (($fv_Permissions & 0x0800) ? 's' : 'x' ) : (($fv_Permissions & 0x0800) ? 'S' : '-'));

            // group
            $fv_FileInfo .= (($fv_Permissions & 0x0020) ? 'r' : '-');
            $fv_FileInfo .= (($fv_Permissions & 0x0010) ? 'w' : '-');
            $fv_FileInfo .= (($fv_Permissions & 0x0008) ? (($fv_Permissions & 0x0400) ? 's' : 'x' ) : (($fv_Permissions & 0x0400) ? 'S' : '-'));

            // everyone
            $fv_FileInfo .= (($fv_Permissions & 0x0004) ? 'r' : '-');
            $fv_FileInfo .= (($fv_Permissions & 0x0002) ? 'w' : '-');
            $fv_FileInfo .= (($fv_Permissions & 0x0001) ? (($fv_Permissions & 0x0200) ? 't' : 'x' ) : (($fv_Permissions & 0x0200) ? 'T' : '-'));

            return $fv_FileInfo;
        }

        function m_DirectoryList($pv_Directory, $pv_DateFormat="d F Y H:i:s") { //Time/Date Formatting: php.net/manual/en/function.date.php
            if ($pv_Directory[strlen($pv_Directory)-1] != '/') $pv_Directory .= '/';

            if (!is_dir($pv_Directory)) return array();

            $pv_Directory_handle  = opendir($pv_Directory);
            $pv_Directory_objects = array();
            while ($fv_TheFile = readdir($pv_Directory_handle))
                if (!in_array($fv_TheFile, array('.','..')))
                {
                    $fv_FilePathName = $pv_Directory . $fv_TheFile;
                    $fv_PathInfo = pathinfo($fv_FilePathName);
                    $fv_FileInfoHash = array(
                                            'filename' => $fv_TheFile,
                                            'fileroot' => $fv_PathInfo['filename'],
                                            'filesize' => filesize($fv_FilePathName),
                                            'permissions' => m_Permissions($fv_FilePathName),
                                            'filetype' => filetype($fv_FilePathName),
                                            'modtime' => date($pv_DateFormat, filemtime($fv_FilePathName)),
                                            'extension' => $fv_PathInfo['extension']
                                        );
                    $pv_Directory_objects[] = $fv_FileInfoHash;
                }
			sort($pv_Directory_objects);
            return $pv_Directory_objects;
        }
class molly_compare{

  // define the constants
  const UNMODIFIED = 0;
  const DELETED    = 1;
  const INSERTED   = 2;

  /* Returns the diff for two strings. The return value is an array, each of
   * whose values is an array containing two values: a line (or character, if
   * $pv_CompareCharacters is true), and one of the constants UNMODIFIED (the
   * line or character is in both strings), DELETED (the line or character
   * is only in the first string), and INSERTED (the line or character is
   * only in the second string). The parameters are:
   *
   * $pv_string1           - the first string
   * $pv_string2           - the second string
   * $pv_CompareCharacters - true to compare characters, and false to compare
   *                      lines; this optional parameter defaults to false
   */
  public static function compare(
      $pv_string1, $pv_string2, $pv_CompareCharacters = false){

    // initialise the sequences and comparison start and end positions
    $start = 0;
    if ($pv_CompareCharacters){
      $sequence1 = $pv_string1;
      $sequence2 = $pv_string2;
      $end1 = strlen($pv_string1) - 1;
      $end2 = strlen($pv_string2) - 1;
    }else{
      $sequence1 = preg_split('/\R/', $pv_string1);
      $sequence2 = preg_split('/\R/', $pv_string2);
      $end1 = count($sequence1) - 1;
      $end2 = count($sequence2) - 1;
    }

    // skip any common prefix
    while ($start <= $end1 && $start <= $end2
        && $sequence1[$start] == $sequence2[$start]){
      $start ++;
    }

    // skip any common suffix
    while ($end1 >= $start && $end2 >= $start
        && $sequence1[$end1] == $sequence2[$end2]){
      $end1 --;
      $end2 --;
    }

    // compute the table of longest common subsequence lengths
    $table = self::computeTable($sequence1, $sequence2, $start, $end1, $end2);

    // generate the partial diff
    $partial_comparison =
        self::generatePartialmolly_compare($table, $sequence1, $sequence2, $start);

    // generate the full diff
    $diff = array();
    for ($index = 0; $index < $start; $index ++){
      $diff[] = array($sequence1[$index], self::UNMODIFIED);
    }
    while (count($partial_comparison) > 0) $diff[] = array_pop($partial_comparison);
    for ($index = $end1 + 1;
        $index < ($pv_CompareCharacters ? strlen($sequence1) : count($sequence1));
        $index ++){
      $diff[] = array($sequence1[$index], self::UNMODIFIED);
    }

    // return the diff
    return $diff;

  }

  /* Returns the diff for two files. The parameters are:
   *
   * $file1             - the path to the first file
   * $file2             - the path to the second file
   * $pv_CompareCharacters - true to compare characters, and false to compare
   *                      lines; this optional parameter defaults to false
   */
  public static function compareFiles(
      $file1, $file2, $pv_CompareCharacters = false){

    // return the diff of the files
    return self::compare(
        file_get_contents($file1),
        file_get_contents($file2),
        $pv_CompareCharacters);

  }

  /* Returns the table of longest common subsequence lengths for the specified
   * sequences. The parameters are:
   *
   * $sequence1 - the first sequence
   * $sequence2 - the second sequence
   * $start     - the starting index
   * $end1      - the ending index for the first sequence
   * $end2      - the ending index for the second sequence
   */
  private static function computeTable(
      $sequence1, $sequence2, $start, $end1, $end2){

    // determine the lengths to be compared
    $length1 = $end1 - $start + 1;
    $length2 = $end2 - $start + 1;

    // initialise the table
    $table = array(array_fill(0, $length2 + 1, 0));

    // loop over the rows
    for ($index1 = 1; $index1 <= $length1; $index1 ++){

      // create the new row
      $table[$index1] = array(0);

      // loop over the columns
      for ($index2 = 1; $index2 <= $length2; $index2 ++){

        // store the longest common subsequence length
        if ($sequence1[$index1 + $start - 1]
            == $sequence2[$index2 + $start - 1]){
          $table[$index1][$index2] = $table[$index1 - 1][$index2 - 1] + 1;
        }else{
          $table[$index1][$index2] =
              max($table[$index1 - 1][$index2], $table[$index1][$index2 - 1]);
        }

      }
    }

    // return the table
    return $table;

  }

  /* Returns the partial diff for the specificed sequences, in reverse order.
   * The parameters are:
   *
   * $table     - the table returned by the computeTable function
   * $sequence1 - the first sequence
   * $sequence2 - the second sequence
   * $start     - the starting index
   */
  private static function generatePartialmolly_compare(
      $table, $sequence1, $sequence2, $start){

    //  initialise the diff
    $diff = array();

    // initialise the indices
    $index1 = count($table) - 1;
    $index2 = count($table[0]) - 1;

    // loop until there are no items remaining in either sequence
    while ($index1 > 0 || $index2 > 0){

      // check what has happened to the items at these indices
      if ($index1 > 0 && $index2 > 0
          && $sequence1[$index1 + $start - 1]
              == $sequence2[$index2 + $start - 1]){

        // update the diff and the indices
        $diff[] = array($sequence1[$index1 + $start - 1], self::UNMODIFIED);
        $index1 --;
        $index2 --;

      }elseif ($index2 > 0
          && $table[$index1][$index2] == $table[$index1][$index2 - 1]){

        // update the diff and the indices
        $diff[] = array($sequence2[$index2 + $start - 1], self::INSERTED);
        $index2 --;

      }else{

        // update the diff and the indices
        $diff[] = array($sequence1[$index1 + $start - 1], self::DELETED);
        $index1 --;

      }

    }

    // return the diff
    return $diff;

  }

  /* Returns a diff as a string, where unmodified lines are prefixed by '  ',
   * deletions are prefixed by '- ', and insertions are prefixed by '+ '. The
   * parameters are:
   *
   * $diff      - the diff array
   * $separator - the separator between lines; this optional parameter defaults
   *              to "\n"
   */
  public static function toString($diff, $separator = "\n"){

    // initialise the string
    $string = '';

    // loop over the lines in the diff
    foreach ($diff as $line){

      // extend the string with the line
      switch ($line[1]){
        case self::UNMODIFIED : $string .= '  ' . $line[0];break;
        case self::DELETED    : $string .= '- ' . $line[0];break;
        case self::INSERTED   : $string .= '+ ' . $line[0];break;
      }

      // extend the string with the separator
      $string .= $separator;

    }

    // return the string
    return $string;

  }

  /* Returns a diff as an HTML string, where unmodified lines are contained
   * within 'span' elements, deletions are contained within 'del' elements, and
   * insertions are contained within 'ins' elements. The parameters are:
   *
   * $diff      - the diff array
   * $separator - the separator between lines; this optional parameter defaults
   *              to '<br>'
   */
  public static function toHTML($diff, $separator = '<br>'){

    // initialise the HTML
    $html = '';

    // loop over the lines in the diff
    foreach ($diff as $line){

      // extend the HTML with the line
      switch ($line[1]){
        case self::UNMODIFIED : $element = 'span'; break;
        case self::DELETED    : $element = 'del';  break;
        case self::INSERTED   : $element = 'ins';  break;
      }
      $html .=
          '<' . $element . '>'
          . htmlspecialchars($line[0])
          . '</' . $element . '>';

      // extend the HTML with the separator
      $html .= $separator;

    }

    // return the HTML
    return $html;

  }

  /* Returns a diff as an HTML table. The parameters are:
   *
   * $diff        - the diff array
   * $indentation - indentation to add to every line of the generated HTML; this
   *                optional parameter defaults to ''
   * $separator   - the separator between lines; this optional parameter
   *                defaults to '<br>'
   */
  public static function toTable($diff, $indentation = '', $separator = '<br>'){

    // initialise the HTML
    $html = $indentation . "<table class=\"diff\">\n";

    // loop over the lines in the diff
    $index = 0;
    while ($index < count($diff)){

      // determine the line type
      switch ($diff[$index][1]){

        // display the content on the left and right
        case self::UNMODIFIED:
          $leftCell =
              self::getCellContent(
                  $diff, $indentation, $separator, $index, self::UNMODIFIED);
          $rightCell = $leftCell;
          break;

        // display the deleted on the left and inserted content on the right
        case self::DELETED:
          $leftCell =
              self::getCellContent(
                  $diff, $indentation, $separator, $index, self::DELETED);
          $rightCell =
              self::getCellContent(
                  $diff, $indentation, $separator, $index, self::INSERTED);
          break;

        // display the inserted content on the right
        case self::INSERTED:
          $leftCell = '';
          $rightCell =
              self::getCellContent(
                  $diff, $indentation, $separator, $index, self::INSERTED);
          break;

      }

      // extend the HTML with the new row
      $html .=
          $indentation
          . "  <tr>\n"
          . $indentation
          . '    <td class="diff'
          . ($leftCell == $rightCell
              ? 'Unmodified'
              : ($leftCell == '' ? 'Blank' : 'Deleted'))
          . '">'
          . $leftCell
          . "</td>\n"
          . $indentation
          . '    <td class="diff'
          . ($leftCell == $rightCell
              ? 'Unmodified'
              : ($rightCell == '' ? 'Blank' : 'Inserted'))
          . '">'
          . $rightCell
          . "</td>\n"
          . $indentation
          . "  </tr>\n";

    }

    // return the HTML
    return $html . $indentation . "</table>\n";

  }

  /* Returns the content of the cell, for use in the toTable function. The
   * parameters are:
   *
   * $diff        - the diff array
   * $indentation - indentation to add to every line of the generated HTML
   * $separator   - the separator between lines
   * $index       - the current index, passes by reference
   * $type        - the type of line
   */
  private static function getCellContent(
      $diff, $indentation, $separator, &$index, $type){

    // initialise the HTML
    $html = '';

    // loop over the matching lines, adding them to the HTML
    while ($index < count($diff) && $diff[$index][1] == $type){
      $html .=
          '<span>'
          . htmlspecialchars($diff[$index][0])
          . '</span>'
          . $separator;
      $index ++;
    }

    // return the HTML
    return $html;

  }

}

?>