<?php
	  /* use PUBLIC on variables and functions when:
	   *  1. outside-code SHOULD access this property or function.
	   *  2. extending classes SHOULD inherit this property or function.
	   */  
	
	  /* use PROTECTED on variables and functions when:
	   *  1. outside-code SHOULD NOT access this property or function.
	   *  2. extending classes SHOULD inherit this property or function.
	   */
	
	  /* use PRIVATE on variables and functions when:
	   *  1. outside-code SHOULD NOT access this property or function.
	   *  2. extending classes SHOULD NOT inherit this property or function.
	   */

	parse_str($_SERVER['QUERY_STRING'], $gv_QueryStringArray);

	function m_AppendQueryString($pv_Key, $pv_Value) {
		global $gv_QueryStringArray, $gv_Config;
		
		$gv_QueryStringArray[$pv_Key]=$pv_Value;
		$gv_Config['querystring']= http_build_query($gv_QueryStringArray);
	}

	function m_AppendJavaScript($pv_Scripts, $pv_ScriptName, $pv_AllowDuplicates=FALSE) { // Adds $pv_Scripts to the JavaScript section in the head of the page
		global $gv_Config;
		global $gv_JavaScriptList;
		
		$fv_ScriptExists = in_array($pv_ScriptName, $gv_JavaScriptList);
		
		if(!$fv_ScriptExists) {
			$gv_JavaScriptList[] = $pv_ScriptName;
			$gv_Config['javascript'] .= $pv_Scripts;
		} else {
			if ($pv_AllowDuplicates) {
				$gv_Config['javascript'] .= $pv_Scripts;
			}
		}
	}

	function m_AppendStylesheet($pv_Styles, $pv_StyleName='', $pv_AllowDuplicates=TRUE) { // Adds $pv_Styles to the stylesheet in the head of the page
		global $gv_Config;
		global $gv_StyleList;
		
		if ($pv_StyleName) {
			$fv_StyleExists = in_array($pv_StyleName, $gv_StyleList);
		} else {
			$fv_StyleExists = FALSE;
		}
		
		if(!$fv_StyleExists) {
			if ($pv_StyleName) {$gv_StyleList[] = $pv_StyleName;}
			$gv_Config['stylesheet'] .= m_Interpolate($pv_Styles, $gv_Config);
		} else {
			if ($pv_AllowDuplicates) {
				$gv_Config['stylesheet'] .= m_Interpolate($pv_Styles, $gv_Config);
			}
		}
	}

	/* All MAML Tags must support the style, class, and id attributes */

	class prototype_tag {
		public $id;
		public $class;
		public $style = "visibility:visible;";
		public $permitted;
		
		protected $emptytag=0;
		protected $tagCache;

		protected $doctext = <<<DOCBLOCK
prototype_tag is a generic class for MAML tags so that they can 
inherit methods such as id().  Undocumented tag classes inherit this documentation.
DOCBLOCK;
		
		protected function echoTemplate($pv_TemplateFile, $pv_TemplateVariables=FALSE) {
			$fv_TheTemplate = $this->fetchTemplate($pv_TemplateFile);
			
			if (!$pv_TemplateVariables) {
				echo $fv_TheTemplate;
			} else {
				echo m_Interpolate($fv_TheTemplate, $pv_TemplateVariables);
			}
		}

		protected function fetchTemplate($pv_TemplateFile) {
			/*
				HOW THIS WORKS (2018-05-23):
				fetchTemplate now attempts to smartly allow skins to override module templates and also provide fallback to a default (in system/default-skin)
				This is done by parsing the string provided, which may cause minor compatibility issues.
				New modules and override should now be specified in the skins, such as (skin folder)/modules/[module]/templates/*.tplt
			*/
			global $gv_SiteGlobals;
			$fv_TheTemplate = ""; // Silent fail is legacy behavior from file_get_contents returning FALSE on fail and FALSE being auto-casted to "" by PHP
			if(strpos($pv_TemplateFile, $gv_SiteGlobals['Paths']['FileRoot']) === 0) { // === for position 0 (int), not false
				$fv_SkinDirFull = $gv_SiteGlobals['Paths']['FileRoot'] . $gv_SiteGlobals['Paths']['SkinDirectory'] . $gv_SiteGlobals['Site']['Skin'];
				$fv_TemplateFileRelative = substr($pv_TemplateFile, strlen($gv_SiteGlobals['Paths']['FileRoot']));
				if(strpos($pv_TemplateFile, $fv_SkinDirFull) === 0) {
					// template call is for the current theme
					$fv_TemplateFileRelative = substr($pv_TemplateFile, strlen($fv_SkinDirFull));
					if(file_exists($pv_TemplateFile)) {
						$fv_TheTemplate = file_get_contents($pv_TemplateFile);
					} else {
						$fv_TheTemplate = file_get_contents($gv_SiteGlobals['Paths']['FileRoot']. $gv_SiteGlobals['Paths']['SkinDirectory'] . "_default/" . $fv_TemplateFileRelative);
					}
				} else if(strpos($fv_TemplateFileRelative, $gv_SiteGlobals['Paths']['ModulesDir']) === 0) {
					// template call is for a module
					$fv_TemplateFileRelative = substr($fv_TemplateFileRelative, strlen($gv_SiteGlobals['Paths']['ModulesDir']));
					if(file_exists($fv_SkinDirFull . '/templates/modules/' . $fv_TemplateFileRelative)) {
						// if skin has override, intercept
						$fv_TheTemplate = file_get_contents($fv_SkinDirFull . '/templates/modules/' . $fv_TemplateFileRelative);
					} else {
						// if no skin override, let happen
						$fv_TheTemplate = file_get_contents($pv_TemplateFile);
					}
				} else {
					// file is not in a skin or module, just leave it
					$fv_TheTemplate = file_get_contents($pv_TemplateFile);
				}
			} else {
				// template is not in the Molly root, just leave it
				$fv_TheTemplate = file_get_contents($pv_TemplateFile);
			}
			return $fv_TheTemplate;
		}
		
		protected function id(){
			global $gv_IDNum;
			if (!$this->id){
				$this->id = get_class($this) . "_" . $gv_IDNum;
				$gv_IDNum++;
			}
			return $this->id;
		}
	
		protected function token() { //create a unique key (32 character  hexadecimal string) like: ef5442d2c8afb84fe938cb64f1368bcd
			return md5(uniqid(rand(),true));
		}
		
		protected function startCache() {
			ob_start();

		}
		
		protected function finishCache() {
			$this->tagCache = ob_get_contents();
			ob_end_clean();
		}
		
		protected function splitAttribute($pv_Attribute){
			return preg_split('/[\s,]+/', $pv_Attribute);
		}
		
		function __construct() {
			$this->id = $this->id();
		}

		function __destruct() {

		}
		
		public function docs(){
			return $this->doctext;
		}
		
		public function precheck() {
			if(!isset($this->permitted)) {
				// permitted is unset
				return;
			}
			if(!m_permitted($this->permitted)) {
				$this->popElement();
			}
		}
		
		protected function popElement() {
			// Static b/c uses PHP's "late static binding" get to child class
			global $gv_stopParse;
			$gv_stopParse = get_class($this);
		}
		
		public function begin(){
			$fv_ThisClassName = get_class($this);
			if ($fv_ThisClassName == 'maml_tag') {
				echo '<!-- "prototype:tag" is a generic tag class: do not instantiate -->';
			} else {
				$fv_ThisTagName = str_replace('_', ':', $fv_ThisClassName);
				echo "<!-- the <$fv_ThisTagName> tag has not been implemented and may be deprecated -->";
			}
		}
		
		public function end(){
			
		}
		
	} // prototype_tag
	
	
	class prototype_template_tag extends prototype_tag {
		protected $tagName;
		
		function __construct() {
			$this->tagName = str_replace('maml_', '', get_class($this));
		}
		
		public function begin() {
			$fv_TemplateVars['id'] = $this->id;
			if (!isset($this->class)) {
				$this->class='molly';
			}
			$fv_TemplateVars['class'] = $this->class;
			$fv_TemplateVars['style'] = $this->style;
			$fv_TemplateVars['title'] = $this->title;
			
			$this->echoTemplate(MOLLY_SKIN_DIRECTORY . 'templates/' . $this->tagName . '.begin.tplt', $fv_TemplateVars);
		}
	
		public function end(){
			$fv_TemplateVars['id'] = $this->id;

			$this->echoTemplate(MOLLY_SKIN_DIRECTORY . 'templates/' . $this->tagName . '.end.tplt', $fv_TemplateVars);
		}
	} // class prototype_template_tag


	m_AutoInclude(MOLLY_SYSTEM_DIRECTORY . 'core/tags/', 'inc');
?>