<?php

	/*	Modules */
	/*
		Modules are optional add-ons to Molly. Over time some modules may migrate
		into Molly's core.
		
		Modules to be loaded are specified in the molly.ini file for the site in
		the [Modules] section. There each module is listed with the path to the 
		module's directory. Molly will then automatically include any .inc files
		found within that directory. Most modules will only require one .inc file
		and by convention that .inc file will be named the same as the module. So,
		for example, the Calendar module included with Molly is located in the 
		calendar directory and has one .inc file named calendar.inc
		
		Modules should also include a documentation file named docs.htmf which will
		automatically be included into the Modules appendix of the Webmaster Manual
		which is generated dynamically for each site. (htmf stands for HyperText
		Markup Fragment and indicates that this file should include valid, well formed
		HTML and text, but is not a complete HTML document. Its contents are to be 
		inserted into a complete HTML document.)
		
	*/

	function m_LoadModules() {
		global $gv_SiteGlobals;
		
		if (isset($gv_SiteGlobals["Modules"])) {
			foreach($gv_SiteGlobals["Modules"] as $fv_ModulePath) {
				m_AutoInclude($gv_SiteGlobals['Paths']['FileRoot'] . $gv_SiteGlobals['Paths']['ModulesDir'] . $fv_ModulePath, 'inc');
			}
		}
	}
	
	function m_EchoModulesDocs() {
		global $gv_SiteGlobals;
		
		if (isset($gv_SiteGlobals["Modules"])) {
			foreach($gv_SiteGlobals["Modules"] as $fv_ModulePath) {
				//m_AutoInclude($gv_SiteGlobals['Paths']['FileRoot'] . $gv_SiteGlobals['Paths']['ModulesDir'] . $fv_ModulePath, 'inc');
				
				if (file_exists($gv_SiteGlobals['Paths']['FileRoot'] . $gv_SiteGlobals['Paths']['ModulesDir'] . $fv_ModulePath . "docs.htmf")) {
					echo m_GetDocument ($gv_SiteGlobals['Paths']['FileRoot'] . $gv_SiteGlobals[Paths][ModulesDir] . $fv_ModulePath . "docs.htmf");
				} else {
					echo "<h3>$fv_ModulePath" . "docs.htmf</h3><p><em>File Not Found</em></p>";
				}
			}
		}
	}
	
	/* -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+----- */

	
	m_LoadModules();
?>