<?php

	class html_html extends prototype_tag {
		public function begin() {
			global $gv_PageStarted;
			
			if(!$gv_PageStarted) {
				$gv_PageStarted = TRUE;
				$this->echoTemplate(MOLLY_SKIN_DIRECTORY . 'templates/html.begin.tplt');
			}
		}
	
		
		public function end() {
			global $gv_PageEnded;
			
			if ($gv_PageEnded) {
				$this->echoTemplate(MOLLY_SKIN_DIRECTORY . 'templates/html.end.tplt');
			}
		}
	}

	class html_head extends prototype_tag {
	
		public function begin() {
			global $gv_InHTMLHead;
			$gv_InHTMLHead = true;
			
			$this->echoTemplate(MOLLY_SKIN_DIRECTORY . 'templates/head.begin.tplt');
		}
		
		public function end() {
			global $gv_InHTMLHead;
			$gv_InHTMLHead = false;
			
			$this->echoTemplate(MOLLY_SKIN_DIRECTORY . 'templates/head.end.tplt');
		}
	}

	class html_body extends prototype_tag {
	
		public function begin() {
			$this->echoTemplate(MOLLY_SKIN_DIRECTORY . 'templates/body.begin.tplt');
		}
		
		public function end() {
			$this->echoTemplate(MOLLY_SKIN_DIRECTORY . 'templates/body.end.tplt');
		}
	}
	
global $gv_SiteGlobals;
if(strtolower($gv_SiteGlobals['Site']['Optimize']) != "off") {
	class html_style extends prototype_tag {
		public $type;
	
		public function begin() {
				$this->startCache();
		}
		
		public function end() {
			$this->finishCache();
			if ($this->type == 'text/css') {
				m_AppendStylesheet($this->tagCache);
			} else {
				$fv_TemplateVariables['type'] = $this->type;
				$fv_TemplateVariables['stylesheet'] = $this->tagCache;
				$this->echoTemplate(MOLLY_SKIN_DIRECTORY . 'templates/stylesheet.noncss.tplt', $fv_TemplateVariables);
			}
		}
	}
	
	class html_script extends prototype_tag {
		public $type;
	
		public function begin() {
				$this->startCache();
		}
		
		public function end() {
			global $gv_InHTMLHead;
			
			$this->finishCache();
			if (property_exists($this, 'src')) {
				$extras = "";
				$extraProps = array('crossorigin', 'integrity', 'none', 'nomodule', 'defer', 'async');
				foreach(get_object_vars($this) as $key => $value) {
					if(in_array($key, $extraProps)) {
						$extras .= ' ' . $key . '="' . $value . '"';
					}
				}
				$fv_TemplateVariables['type'] = $this->type;
				$fv_TemplateVariables['src'] = $this->src;
				$fv_TemplateVariables['extras'] = $extras;
				m_AppendJavaScript(m_Interpolate('</script><script type="*[type]*" src="*[src]*" *[extras]*></script><script type="text/javascript">', $fv_TemplateVariables), "foo", true); // "foo, true" forces on AllowDuplicates since it's causing issues
			} else {
				if(isset($gv_InHTMLHead) && $gv_InHTMLHead === true) {
					m_AppendJavaScript($this->tagCache, "bar", true);
				} else {
					$fv_TemplateVariables['type'] = $this->type;
					$fv_TemplateVariables['script'] = $this->tagCache;
					$this->echoTemplate(MOLLY_SKIN_DIRECTORY . 'templates/script.nonjs.tplt', $fv_TemplateVariables);
				}
			}
		}
	}
	
	class html_link extends prototype_tag {
		public $type;
	
		public function begin() {
				$this->startCache();
		}
		
		public function end() {
			$this->finishCache();
			if (property_exists($this, 'rel')) {
				$extras = "";
				$extraProps = array('crossorigin', 'integrity', 'media', 'prefetch');
				foreach(get_object_vars($this) as $key => $value) {
					if(in_array($key, $extraProps)) {
						$extras .= ' ' . $key . '="' . $value . "'";
					}
				}
				$fv_TemplateVariables['rel'] = $this->rel;
				$fv_TemplateVariables['href'] = $this->href;
				$fv_TemplateVariables['extras'] = $extras;
				m_AppendStylesheet(m_Interpolate('</style><link rel="*[rel]*" href="*[href]*" *[extra]* /><style type="text/css">', $fv_TemplateVariables));
			} else {
				$fv_TemplateVariables['type'] = $this->type;
				$fv_TemplateVariables['stylesheet'] = $this->tagCache;
				$this->echoTemplate(MOLLY_SKIN_DIRECTORY . 'templates/stylesheet.noncss.tplt', $fv_TemplateVariables);
			}
		}
	}
}

?>