<?php

	class maml_ajax extends prototype_tag {
		public $target;
		public $interval = 0;
		public $url;
		public $trigger;
		protected $doctext = <<<'DOCBLOCK'
Creates an AJAX script to continually load data from the <code>url</code>.
The returned data will get put in the <code>#<em>target</em></code> element.
If a <code>trigger</code> is specified then the AJAX refresh won't start until the <code>#<em>trigger</em></code> element is clicked.
The <code>interval</code> specifies the time (in seconds) to reload automatically.
If <code>interval</code> not set, or set to zero, then the AJAX will only run once.
DOCBLOCK;
		protected $mollyAjax = <<<'AJAXSCRIPT'
function mollyAjax(target, url, remove=null) {
	var xmlHttp;
	try  {
		// Firefox, Opera 8.0+, Safari
		xmlHttp=new XMLHttpRequest();
	} catch (e) {
		try {
			xmlHttp=new ActiveXObject("Msxml2.XMLHTTP");
		} catch (e) {
			try {
				xmlHttp=new ActiveXObject("Microsoft.XMLHTTP");
			} catch (e) {
				alert("Your browser does not support AJAX!");
				return false;
			}
		}
	}
	xmlHttp.onreadystatechange=function() {
		if(xmlHttp.readyState==4) {
			document.getElementById(target).innerHTML = xmlHttp.responseText;
		}
	}
	xmlHttp.open("GET",url,true);
	xmlHttp.send(null);
	
	if(remove != null) {
		document.getElementById(remove.trigger).removeEventListener("click", remove.func);
	}
}
AJAXSCRIPT;
	
		function begin() {
			
		}
		
		function end() {
			$fv_script = "\n" . 'function mollyAjax_e_' . $this->id . '() { mollyAjax("' . $this->target . '", "' . $this->url . '"';
			if(isset($this->trigger)) {
				$fv_script .= ', {trigger:"' . $this->trigger . '",func:mollyAjax_e_' . $this->id . '}';
			}
			$fv_script .= ');';
			if($this->interval > 0) {
				$fv_script .= ' window.setTimeout(mollyAjax_e_' . $this->id . ', ' . $this->interval . '*1000);';
			}
			$fv_script .= ' }' . "\n";
			
			if(isset($this->trigger)) {
				$fv_script .= 'document.getElementById("' . $this->trigger . '").addEventListener("click", ';
			} else {
				$fv_script .= 'window.addEventListener("load", ';
			}
			
			$fv_script .= 'mollyAjax_e_' . $this->id  . ');';
			
			m_AppendJavaScript($this->mollyAjax, 'mollyAjax');
			m_AppendJavaScript($fv_script, 'mollyAjaxTag', true);
		}
	
	}

/*
	class maml_ajax extends prototype_tag {
		public $node; // which node to watch (id)
		public $event; // what event to watch for
		public $action; // what to do on event
		public $target; // where to put results of action

		protected $doctext = <<<'DOCBLOCK'
		ajax docs here
		
DOCBLOCK;

		protected $script = <<<'AJAXSCRIPT'

function hide( items ) {
	var temp = new Array();
	temp = items.split(',');     	
	for( var s=0; s<temp.length; s++ ) {
		if( temp[ s ] != '' ) {
			document.getElementById(temp[s]).style.display = "none";		
		}
	}
}
function show( items ) {
	var temp = new Array();
	temp = items.split(',');  	
	for( var s=0; s<temp.length; s++ ) {
		if( temp[ s ] != '' ) {
			document.getElementById(temp[s]).style.display = "block";
		}
	}
}
function show_loading( item ) {
	document.getElementById(item).style.display = "block";
	
}
function clear_home_galen_suggest( items ) {
	document.getElementById("galen_suggest").innerHTML = "";
	show( items );
}


    function mollyAjaxElement( target, href, dynamic ) {
      var target = document.getElementById( target );
      var page = href;

      if( dynamic.length > 0 ) {
            	
      	var temp = new Array();
			  temp = dynamic.split(' ');
			      	
			  for( i=0; i<temp.length; i++ ) {
			
				  if( temp[ i ] != '' ) {
			
					 var name_param = new Array();
					 name_param = temp[i].split( '|' );
								
					 var obj_value = document.getElementById( name_param[1] );				
				
					 page = page + name_param[0] + "=" + obj_value.value + "&";
					
				  }
			  }
      } 

      var xmlHttp;
      try  {
        // Firefox, Opera 8.0+, Safari
        xmlHttp=new XMLHttpRequest();
      }
      catch (e) {
      try {
        xmlHttp=new ActiveXObject("Msxml2.XMLHTTP");
      } catch (e) {
      try {
        xmlHttp=new ActiveXObject("Microsoft.XMLHTTP");
      }
      catch (e) {
        alert("Your browser does not support AJAX!");
        return false;
      }
      }
    }
    xmlHttp.onreadystatechange=function() {
      if(xmlHttp.readyState==4) {
	     target.innerHTML = xmlHttp.responseText;
      }
    }
    xmlHttp.open("GET",page,true);
    xmlHttp.send(null);
    }

	function addEvent(obj, evType, fn){ 
		if (obj.addEventListener){ 
			obj.addEventListener(evType, fn, false); 
			 return true; 
		} else if (obj.attachEvent){ 
			var r = obj.attachEvent("on"+evType, fn); 
			return r; 
		} else { 
			return false; 
		} 
	}

	function prepMollyAjax() {
		*[ajax_event_listeners]*
		addEvent(document.getElementById('galen_input_field'), 'keyup', function(){mollyAjaxElement('galen_suggest','http://galen.rit.edu/~dev02/m3r1c/galen_itouch/galen_patientselect/patientselect.maml?', 'name|galen_input_field ');});
	}
	addEvent(window, 'load', prepMollyAjax);

AJAXSCRIPT;
		
		public function begin() {
			m_AppendJavaScript($this->script, 'ajax');
		}
		
		public function end(){
		
		}

	}
*/
?>