<?php
/*		Constructs		*/

	global $gv_IfStack;
	$gv_IfStack=array();

	class maml_if extends prototype_tag {
		public $condition;
		//public $else = '';
		protected $logic;

		protected $doctext = <<<'DOCBLOCK'
<p><strong>Description:</strong> The &lt;maml:if&gt; tag allows one to conditionally display portions of the page.</p> 
<pre class="maml"><span class="sc2">&lt;maml:if condition<span class="sy0">=</span><span class="st0">&quot;'*<span>[token]</span>*' == 'value'&quot;</span>&gt;</span>
    <span class="sc2">&lt;p&gt;</span>True Stuff (inside an if).<span class="sc2">&lt;<span class="sy0">/</span>p&gt;</span>
    <span class="sc2">&lt;maml:else&gt;</span>
        <span class="sc2">&lt;p&gt;</span>False Stuff (inside an else).<span class="sc2">&lt;<span class="sy0">/</span>p&gt;</span>
    <span class="sc2">&lt;<span class="sy0">/</span>maml:else&gt;</span>
<span class="sc2">&lt;<span class="sy0">/</span>maml:if&gt;</span>
&nbsp;</pre>
DOCBLOCK;
		
		public function precheck() {
			global $gv_stopParse, $gv_IfTagFailed, $gv_Config;
			$gv_IfTagFailed = false;
			
			// Run prototype_tag's precheck for permitted attribute & check result
			parent::precheck();
			if($gv_stopParse == "") {
				// Passed prototype_tag's precheck
				
				// Interpolate
				$interpolatedCondition = m_Interpolate($this->condition, array_merge($_SESSION['tokens'], $gv_Config));
				
				// Simple, stupid checks for stopping blatant hacking attempts
				if(strpos($interpolatedCondition, ';') !== FALSE) {
					// Disallow semicolons
					$gv_IfTagFailed = true;
					$this->popElement();
					m_Debug('IF FAILED: SEMICOLON FOUND');
				}
				$parenLevel = 0;
				for($i = 0; $i < strlen($interpolatedCondition); $i++) {
					$curChar = $interpolatedCondition[$i];
					if($curChar == '(') {
						$parenLevel++;
					} else if($curChar == ')') {
						$parenLevel--;
						if($parenLevel < 0) {
							// Disallow trying to escape the condition encapsulation
							$gv_IfTagFailed = true;
							$this->popElement();
							m_Debug('IF FAILED: NEGATIVE PARENTHESES LEVEL');
						}
					}
				}
				if($parenLevel != 0) {
					// Disallow unbalenced parentheses
					$gv_IfTagFailed = true;
					$this->popElement();
					m_Debug('IF FAILED: UNBALANCED PARENTHESES');
				}
				
				// Eval condition - WARNING - THIS IS DANGEROUS
				eval('$mamlIfCheck = (' . $interpolatedCondition . ');');
				if($mamlIfCheck !== true) {
					// Condition did not pass, pop it
					$this->popElement();
				}
			}
		}
		
		public function begin() {
			/*global $gv_IfStack, $gv_RecordHash;
			array_push($gv_IfStack, $this);
			$this->startCache();*/
		}
		
		public function end() {
            /*global $gv_Config, $gv_IfStack, $gv_TokenVariables;

            $this->finishCache();

			$this->logic = <<< "DONEIF"
				if ($this->condition) { // only doing the TRUE part
					echo '$this->tagCache';
				} else {
					echo '$this->else';
				}
DONEIF;

			$this->logic = m_Interpolate($this->logic,$_SESSION['tokens']); // interpolate persistent *[placeholders]*
			$this->logic = m_Interpolate($this->logic, $gv_Config); // interpolate *[placeholders]*
//			echo "<pre>$this->logic</pre>";
	
			eval($this->logic);
			array_pop($gv_IfStack); */
		}
	}


	class maml_else extends prototype_tag {

		protected $doctext = <<<'DOCBLOCK'
<p><strong>Description:</strong> The &lt;maml:else&gt; works within the &lt;maml:if&gt; tag  to allow one to conditionally display portions of the page.</p> 
<pre class="maml"><span class="sc2">&lt;maml:if condition<span class="sy0">=</span><span class="st0">&quot;'*<span>[token]</span>*' == 'value'&quot;</span>&gt;</span>
    <span class="sc2">&lt;p&gt;</span>True Stuff (inside an if).<span class="sc2">&lt;<span class="sy0">/</span>p&gt;</span>
    <span class="sc2">&lt;maml:else&gt;</span>
        <span class="sc2">&lt;p&gt;</span>False Stuff (inside an else).<span class="sc2">&lt;<span class="sy0">/</span>p&gt;</span>
    <span class="sc2">&lt;<span class="sy0">/</span>maml:else&gt;</span>
<span class="sc2">&lt;<span class="sy0">/</span>maml:if&gt;</span>
&nbsp;</pre>
DOCBLOCK;
		
		public function precheck() {
			global $gv_stopParseStack, $gv_stopParseOffStackStack, $gv_IfTagFailed;
			if(count($gv_stopParseStack) != 1) {
				$this->popElement();
			} else if($gv_IfTagFailed == true) {
				$gv_IfTagFailed = false;
				$this->popElement();
			} else {
				// <maml:else> is direct child of <maml:if>
				array_push($gv_stopParseOffStackStack, array_shift($gv_stopParseStack));
			}
		}
	
		public function begin() {
			$this->startCache();
		}
		
		public function end() {
			global $gv_IfStack, $gv_stopParseStack, $gv_stopParseOffStackStack;

			$this->finishCache();
			
			$fv_IfIndex = count($gv_IfStack) - 1;
			
			$gv_IfStack[$fv_IfIndex]->else = $this->tagCache;
			
			// undo "not if" stacking
			array_push($gv_stopParseStack, array_pop($gv_stopParseOffStackStack));
		}
	}
	
	
	class maml_redirect extends prototype_tag {
		protected $doctext = <<<'DOCBLOCK'
<p><strong>Description:</strong> The &lt;maml:redirect&gt; leaves the current page 
and goes to the page specified in the href attribute. (Technically, it sends a location
header to the browser telling it to request the new page.)</p>
DOCBLOCK;
	
	
		public $href;
		
		public function begin() {
			global $gv_SiteGlobals;
			
			if (!isset($this->href)) {
				$this->href = $gv_SiteGlobals['Paths']['HTMLRoot'];
			}

			header ("Location:{$this->href}");

		}
		
	}


?>