<?php

	global $gv_FetchStack; /*	<maml_fetch> will push objects onto this stack
								to maintain state for sub tags and (hopefully)
								allow nesting of <mam_select> tags				*/

	$gv_FetchStack=array(); /*	initialize The Stack							*/
	m_AutoInclude(MOLLY_SYSTEM_DIRECTORY . 'core/captcha/', 'inc');

	class molly_fetch_state {
		public $query;
		public $table;
		public $numrows;
	} // class molly_fetch_state


	class maml_fetch extends prototype_tag {
		public $query;
		public $table;		// database table
		public $fields = '*';
		public $sort;		// sort order
		public $order="ascending";		// ascending|descending
		public $criteria;		// SQL WHERE clause
		public $maxentries;	// max records to retrieve should this be limited to some high value
		public $start=1;		// start with this record

		public $key;		//
		public $detail;		// link

		// for overriding defaults
		public $host;
		public $database;
		public $user;
		public $password;

		protected $currentFetch;

		protected $doctext = <<<'DOCBLOCK'
<p><strong>Description:</strong> Used to retrieve results from a database.
Together with the &lt;maml:row&gt; and &lt;maml:field&gt; tags this allows
you to retrieve and display data from Molly&rsquo;s database.</p>
<p><strong>Example:</strong></p>
<pre class="maml"><span class="sc2">&lt;maml:<span class="kw1">fetch</span> <span class="kw1">table</span><span class="sy0">=</span><span class="st0">&quot;molly_test&quot;</span> key<span class="sy0">=</span><span class="st0">&quot;name&quot;</span> criteria<span class="sy0">=</span><span class="st0">&quot;true&quot;</span> detail<span class="sy0">=</span><span class="st0">&quot;form.maml&quot;</span> format<span class="sy0">=</span><span class="st0">&quot;off&quot;</span>&gt;</span>
    <span class="sc2">&lt;table <span class="kw1">style</span><span class="sy0">=</span><span class="st0">&quot;width:20em;&quot;</span>&gt;</span>
        <span class="sc2">&lt;tr&gt;</span>
            <span class="sc2">&lt;th&gt;&lt;maml:sort sort<span class="sy0">=</span><span class="st0">&quot;name&quot;</span>&gt;</span>Name<span class="sc2">&lt;<span class="sy0">/</span>maml:sort&gt;&lt;<span class="sy0">/</span>th&gt;</span>
            <span class="sc2">&lt;th&gt;&lt;maml:sort sort<span class="sy0">=</span><span class="st0">&quot;eyecolor&quot;</span> order<span class="sy0">=</span><span class="st0">&quot;descending&quot;</span>&gt;</span>Eye Color<span class="sc2">&lt;<span class="sy0">/</span>maml:sort&gt;&lt;<span class="sy0">/</span>th&gt;</span>
            <span class="sc2">&lt;th&gt;&lt;maml:sort sort<span class="sy0">=</span><span class="st0">&quot;age&quot;</span>&gt;</span>Age<span class="sc2">&lt;<span class="sy0">/</span>maml:sort&gt;&lt;<span class="sy0">/</span>th&gt;</span>
        <span class="sc2">&lt;<span class="sy0">/</span>tr&gt;</span>
        <span class="sc2">&lt;maml:row maxentries<span class="sy0">=</span><span class="st0">&quot;3&quot;</span>&gt;</span>
        <span class="sc2">&lt;tr&gt;</span>
            <span class="sc2">&lt;td&gt;&lt;maml:field <span class="kw3">name</span><span class="sy0">=</span><span class="st0">&quot;name&quot;</span><span class="sy0">/</span>&gt;&lt;<span class="sy0">/</span>td&gt;</span>
            <span class="sc2">&lt;td&gt;&lt;maml:detail <span class="kw3">href</span><span class="sy0">=</span><span class="st0">&quot;advancedLists.maml&quot;</span>&gt;</span> <span class="sc2">&lt;maml:field <span class="kw3">name</span><span class="sy0">=</span><span class="st0">&quot;eyecolor&quot;</span><span class="sy0">/</span>&gt;&lt;<span class="sy0">/</span>maml:detail&gt;&lt;<span class="sy0">/</span>td&gt;</span>
            <span class="sc2">&lt;td&gt;&lt;maml:detail <span class="kw3">href</span><span class="sy0">=</span><span class="st0">&quot;advancedForm.maml&quot;</span>&gt;</span> <span class="sc2">&lt;maml:field <span class="kw3">name</span><span class="sy0">=</span><span class="st0">&quot;age&quot;</span><span class="sy0">/</span>&gt;&lt;<span class="sy0">/</span>maml:detail&gt;&lt;<span class="sy0">/</span>td&gt;</span>
        <span class="sc2">&lt;<span class="sy0">/</span>tr&gt;</span>
        <span class="sc2">&lt;<span class="sy0">/</span>maml:row&gt;</span>
    <span class="sc2">&lt;<span class="sy0">/</span>table&gt;</span>
  Total Records: <span class="sc2">&lt;maml:numrows<span class="sy0">/</span>&gt;&lt;br<span class="sy0">/</span>&gt;</span>
  <span class="sc2">&lt;maml:previous&gt;</span>Previous <span class="sc2">&lt;maml:numrows<span class="sy0">/</span>&gt;</span> Records <span class="sc2">&lt;<span class="sy0">/</span>maml:previous&gt;</span>
  | <span class="sc2">&lt;maml:pages delimiter<span class="sy0">=</span><span class="st0">&quot;-&quot;</span> <span class="sy0">/</span>&gt;</span> |
  <span class="sc2">&lt;maml:next&gt;</span>Next <span class="sc2">&lt;maml:numrows<span class="sy0">/</span>&gt;</span> Records <span class="sc2">&lt;<span class="sy0">/</span>maml:next&gt;&lt;br<span class="sy0">/</span>&gt;</span>
<span class="sc2">&lt;<span class="sy0">/</span>maml:fetch&gt;</span>
&nbsp;</pre>

<p><strong>Results:</strong></p>
<table style = "width:20em;">
	<tr>
		<th><span class="sort_ascending"><a href="?t_Sort=molly_test.name&t_Order=ascending&molly=true">Name</a></span></th>
		<th><span class="sort_descending"><a href="?t_Sort=molly_test.eyecolor&t_Order=descending&molly=true">Eye Color</a></span></th>
		<th><span class="sort_ascending"><a href="?t_Sort=molly_test.age&t_Order=ascending&molly=true">Age</a></span></th>
	</tr>

	<tr>
		<td>Genny</td>
		<td><detail href = "advancedLists.maml"> Brown</detail></td>
		<td><detail href = "advancedForm.maml"> 6</detail></td>
	</tr>

	<tr>
		<td>Heather</td>
		<td><detail href = "advancedLists.maml"> Blue</detail></td>
		<td><detail href = "advancedForm.maml"> 28</detail></td>
	</tr>

	<tr>
		<td>Michelle</td>
		<td><detail href = "advancedLists.maml"> brown</detail></td>
		<td><detail href = "advancedForm.maml"> 12</detail></td>
	</tr>

	<tr>
		<td>Ron</td>
		<td><detail href = "advancedLists.maml"> Brown</detail></td>
		<td><detail href = "advancedForm.maml"> 48</detail></td>
	</tr>

	<tr>
		<td>Tim</td>
		<td><detail href = "advancedLists.maml"> brown</detail></td>
		<td><detail href = "advancedForm.maml"> 22</detail></td>
	</tr>

</table>
Total Records:<br />
Previous Records
|  |
Next Records <br />


<p>Things which are known to be not working:</p>
<ul type = "square">
<li>&lt;maml:row&gt; tag&rsquo;s maxentries attribute</li>
<li>&lt;maml:previous&gt;</li>
<li>&lt;maml:next&gt;</li>
<li>&lt;maml:pages&gt;</li>
<li>&lt;maml:detail&gt;</li>
</ul>

<p><em>Example from select_tag_test.maml - be sure to update these docs as functionality is added.</em></p>

DOCBLOCK;

		private function setupQuery() {

			if (!isset($this->query)) {
				$this->query = 'SELECT ' . $this->fields . ' FROM ' . $this->table;


				if (isset($this->criteria)) {
					$this->query .= ' WHERE ' .$this->criteria;
				}
			}
				if (isset($_REQUEST['t_Sort'])) { // override default sort order with querystring (and form sort attribute?)
					$fv_TempArray=explode(',', $_REQUEST['t_Sort']);

					$fv_SortOverrideArray = array();
					foreach ($fv_TempArray as $fv_SortItem) {
						list($fv_Table, $fv_Field) = explode('.', $fv_SortItem);
						if ($this->table==$fv_Table) {
							$fv_SortOverrideArray[] = $fv_Field;
						}
					}
					if ($fv_SortOverrideArray) {
						$this->sort = implode(',',$fv_SortOverrideArray);
					}
				}
				if (isset($_REQUEST['t_Order'])) { // override default sort order with querystring (and form sort attribute?)
					$this->order=$_REQUEST['t_Order'];
				}
				if (isset($this->sort)) {
					$this->query .= ' ORDER BY ' .$this->sort;
					if ($this->order=='descending') {
						$this->query .= ' DESC ';
					} else {
						$this->query .= ' ASC ';
					}
				}
				if (isset($this->maxentries)) {
					$this->query .= ' LIMIT ' . $this->maxentries . ' OFFSET ' . ($this->start - 1);
				}
				$this->query .= ';';
			//}
		}


		public function begin() {
			global $gv_FetchStack;

			$gv_FetchStack[] = new molly_fetch_state();
			$this->currentFetch = count($gv_FetchStack) - 1;
			$this->setupQuery();
//			$this->query = m_Interpolate($this->query, $_REQUEST); //do we want/need this?

			if(isset($_SESSION['tokens'])) {
				$this->query =  m_Interpolate($this->query,$_SESSION['tokens']); // interpolate persistent *[placeholders]*
			}
			$gv_FetchStack[$this->currentFetch] = new stdClass(); // instantiate object explicitely
			$gv_FetchStack[$this->currentFetch]->query = $this->query; // now it's save to do this!
			$gv_FetchStack[$this->currentFetch]->table = $this->table;
			if (isset($this->host)) {
				$gv_FetchStack[$this->currentFetch]->host = $this->host;
			} else {
				$gv_FetchStack[$this->currentFetch]->host = ''; // '' is the default value of the underlying function call
			}
			if (isset($this->database)) {
				$gv_FetchStack[$this->currentFetch]->database = $this->database;
			} else {
				$gv_FetchStack[$this->currentFetch]->database = ''; // '' is the default value of the underlying function call
			}
			if (isset($this->user)) {
				$gv_FetchStack[$this->currentFetch]->user = $this->user;
			} else {
				$gv_FetchStack[$this->currentFetch]->user = ''; // '' is the default value of the underlying function call
			}
			if (isset($this->password)) {
				$gv_FetchStack[$this->currentFetch]->password = $this->password;
			} else {
				$gv_FetchStack[$this->currentFetch]->password = ''; // '' is the default value of the underlying function call
			}
		}

		public function end(){
			global $gv_FetchStack;

			array_pop($gv_FetchStack); //delete this query's state object from the stack
		}


	} // class maml_fetch

	class maml_row extends prototype_tag {
		protected $currentFetch;
		public $empty;
		public $maxentries;

		protected $doctext = <<<'DOCBLOCK'
<p><strong>Description:</strong> Used in conjunction with &lt;maml:fetch&gt; tag to retrieve results from a database.</p>
<p>The &lt;maml:row&gt; tag duplicates its contents for each row (record) found by the &lt;maml:fetch&gt; tag&rsquo;s query.</p>
<p>See &lt;maml:fetch&gt; tag for example usage.</p>
DOCBLOCK;

		public function begin() {
			global $gv_FetchStack, $gv_InRow;

			$gv_InRow = TRUE;

			$this->currentFetch = count($gv_FetchStack) - 1;

			$this->startCache();
		}

		public function end() {
			global $gv_FetchStack, $gv_InRow;

			$this->finishCache();
			$gv_InRow = FALSE;
			$fv_HashArray=m_FetchDBHash($gv_FetchStack[$this->currentFetch]->query, $gv_FetchStack[$this->currentFetch]->host, $gv_FetchStack[$this->currentFetch]->user, $gv_FetchStack[$this->currentFetch]->password, $gv_FetchStack[$this->currentFetch]->database);

			if($fv_HashArray) { // results not empty
				foreach ($fv_HashArray as $fv_RecordHash) {
					echo m_Interpolate($this->tagCache, $fv_RecordHash);
				}
				$gv_FetchStack[$this->currentFetch]->numrows = count($fv_HashArray);

				foreach ($fv_HashArray as $key => $value ) {

                    foreach($value as $key2 => $value2){
                        $_SESSION['tokens'][$key2] = $value2;
                    }
				}

            } else {
				echo $this->empty;
				$gv_FetchStack[$this->currentFetch]->numrows = 0;
			}
		}

	} // class maml_row

	class maml_field extends prototype_tag {
		public $name;

		protected $doctext = <<<'DOCBLOCK'
<p><strong>Description:</strong> Used in conjunction with &lt;maml:fetch&gt; tag to retrieve results from a database.</p>
<p>Replaces itself with the data retrieved from that field by the &lt;maml:fetch&gt; tag&rsquo;s query.</p>
<p>See &lt;maml:fetch&gt; tag for example usage.</p>
DOCBLOCK;

		public function begin() {
			echo "*[$this->name]*";
		}

	} // class maml_field


	class maml_sort extends prototype_tag {
		public $sort;
		public $order = 'ascending';

		protected $doctext = <<<'DOCBLOCK'
<p><strong>Description:</strong> Used in conjunction with &lt;maml:fetch&gt; tag to retrieve results from a database.</p>
<p>Creates links which allow the user to sort the results of the &lt;maml:fetch&gt; tag&rsquo;s query.</p>
<p>See &lt;maml:fetch&gt; tag for example usage.</p>
DOCBLOCK;

		public function begin() {
			global $gv_Config, $gv_QueryStringArray, $gv_FetchStack;

			$this->id = $this->id(); //get a unique identifier so we can build a unique template variable

			$this->currentFetch = count($gv_FetchStack) - 1; //determin which query we're operating on (there may be more than one on the page)

			if (isset($_REQUEST['t_Order'])) {// querystring overrides default
				if($_REQUEST['t_Order']==$gv_QueryStringArray['t_Sort']) { // first see if this field was sorted last
					if ($_REQUEST['t_Order']=='ascending') { // set to the opposite of whatever we're at so user can re-sort
						$this->order = 'descending';
					} else {
						$this->order = 'ascending';
					}
				}
			}

			unset($gv_QueryStringArray['t_Sort']); //remove any incoming sort from last page load's querystring
			unset($gv_QueryStringArray['t_Order']);

			$gv_Config[$this->id]='?t_Sort=' . $gv_FetchStack[$this->currentFetch]->table . '.' . $this->sort . '&t_Order=' . $this->order;

			echo '<span class="sort_' . $this->order . '"><a href="*[' . $this->id . ']*&*[querystring]*">';

// ok, this is a hack here:
 m_AppendQueryString('molly','true');

		}

		public function end() {
			echo '</a></span>';
		}
	}


	class maml_numrows  extends prototype_tag {

		protected $currentFetch;
		protected $doctext = <<<'DOCBLOCK'
<p><strong>Description:</strong> Used in conjunction with &lt;maml:fetch&gt; tag to display the number of records returned.</p>
DOCBLOCK;

		public function begin() {
			global $gv_FetchStack;

			echo '<span class="maml_numrows">';
			$this->currentFetch = count($gv_FetchStack) - 1;
			echo $gv_FetchStack[$this->currentFetch]->numrows;
		}


		public function end() {
			echo '</span>';
		}

	}


/* -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+----- */


class maml_form extends prototype_tag {
	public $keyvalue;
	public $table;
	public $keyfield;
	public $criteria;
	public $response;
	public $mode; // insert (formerly input) | edit | output (t_RenderAs) | register
	public $action; // to allow override of default behavior?
	public $name;
	public $schema;
	public $ownership = 'none'; // how ownership is determined.  idfield | namefield | field | login | name | id | all
	public $owner;
	public $linkname;
	public $linkfield;

		protected $doctext = <<<'DOCBLOCK'
<p><strong>Description:</strong> Molly&rsquo;s forms are, by design, very similar to the HTML forms web developers
are used to, where users can send data to a website, store the data in the web server's database, and manipulate that data.
The key difference in Molly&rsquo;s forms is that they automatically connect with the database and require
no additional programming from the user.</p>

<p>The <strong>maml:form</strong> tag connects to the database under the hood, specified by several attributes related to the query being made and how to handle
data in the form response. The key attributes to pay attention to are as follows:</p>

<ul>
<li>The <strong>table</strong> attribute is the name of the database table that this form will be interacting with, both to retrieve data from the table and save form data to the table.</li>
<li>The <strong>response</strong> attribute is the url of the page that the user will be sent to after submitting the form, once form data has been inserted into the database table specified.</li>
<li>The <strong>keyfield</strong> attribute identifies the field in the database used as the primary key.</li>
<li>The <strong>schema</strong> attribute tells Molly to write the basic SQL code needed to create a database table to support the form <strong>(partially implemented)</strong>. If set to off, Molly will not attempt to create a new table in the DB and instead looks for the presumed existing table.</li>
<li>The <strong>criteria</strong> attribute allows the user to specify column values when submitting the form.</li>
<li>The <strong>permitted</strong> attribute defines who is allowed to submit the form.</li>
</ul>

<h5 style="text-align: center;">Sample MAML:</h5>
<pre class="maml"><span class="sc2">&lt;maml:<span class="kw1">form</span> <span class="kw1">table</span><span class="sy0">=</span><span class="st0">&quot;molly_test&quot;</span> response<span class="sy0">=</span><span class="st0">&quot;form_test.maml&quot;</span> keyfield<span class="sy0">=</span><span class="st0">&quot;test_id&quot;</span> keyvalue<span class="sy0">=</span><span class="st0">&quot;*<span>[t_Link]</span>*&quot;</span> mode<span class="sy0">=</span><span class="st0">&quot;replace&quot;</span> schema<span class="sy0">=</span><span class="st0">&quot;on&quot;</span>&gt;</span>
   Name: <span class="sc2">&lt;maml:<span class="kw1">input</span> <span class="kw3">type</span><span class="sy0">=</span><span class="st0">&quot;text&quot;</span> <span class="kw3">name</span><span class="sy0">=</span><span class="st0">&quot;name&quot;</span> <span class="kw3">size</span><span class="sy0">=</span><span class="st0">&quot;24&quot;</span> <span class="sy0">/</span>&gt;&lt;br<span class="sy0">/</span>&gt;</span>
   Eye Color: <span class="sc2">&lt;maml:<span class="kw1">input</span> <span class="kw3">type</span><span class="sy0">=</span><span class="st0">&quot;text&quot;</span> <span class="kw3">name</span><span class="sy0">=</span><span class="st0">&quot;eyecolor&quot;</span> <span class="kw3">value</span><span class="sy0">=</span><span class="st0">&quot;*<span>[t_RenderAs]</span>*&quot;</span><span class="sy0">/</span>&gt;&lt;br<span class="sy0">/</span>&gt;</span>
   Age: <span class="sc2">&lt;maml:<span class="kw1">input</span> <span class="kw3">type</span><span class="sy0">=</span><span class="st0">&quot;text&quot;</span> <span class="kw3">name</span><span class="sy0">=</span><span class="st0">&quot;age&quot;</span> <span class="kw3">value</span><span class="sy0">=</span><span class="st0">&quot;*<span>[t_Link]</span>*&quot;</span><span class="sy0">/</span>&gt;&lt;br<span class="sy0">/</span>&gt;</span>
&nbsp;
    <span class="sc2">&lt;maml:fetch <span class="kw1">table</span><span class="sy0">=</span><span class="st0">&quot;molly_username&quot;</span> maxentries<span class="sy0">=</span><span class="st0">&quot;2&quot;</span> fields<span class="sy0">=</span><span class="st0">&quot;lastname, firstname, user_id&quot;</span> orderby<span class="sy0">=</span><span class="st0">&quot;lastname&quot;</span>&gt;</span>
        <span class="sc2">&lt;maml:<span class="kw1">select</span> <span class="kw3">name</span><span class="sy0">=</span><span class="st0">&quot;file_token&quot;</span> <span class="kw3">size</span><span class="sy0">=</span><span class="st0">&quot;1&quot;</span>&gt;</span>
            <span class="sc2">&lt;maml:option&gt;</span>Choose One:<span class="sc2">&lt;<span class="sy0">/</span>maml:option&gt;</span>
            <span class="sc2">&lt;maml:row&gt;</span>
                <span class="sc2">&lt;maml:<span class="kw1">option</span> <span class="kw3">value</span><span class="sy0">=</span><span class="st0">&quot;*[user_id]*&quot;</span>&gt;&lt;maml:field <span class="kw3">name</span><span class="sy0">=</span><span class="st0">&quot;lastname&quot;</span> <span class="sy0">/</span>&gt;</span>, <span class="sc2">&lt;maml:field <span class="kw3">name</span><span class="sy0">=</span><span class="st0">&quot;firstname&quot;</span><span class="sy0">/</span>&gt;</span> (*<span>[user_id]</span>*)<span class="sc2">&lt;<span class="sy0">/</span>maml:option&gt;</span>
            <span class="sc2">&lt;<span class="sy0">/</span>maml:row&gt;</span>
        <span class="sc2">&lt;<span class="sy0">/</span>maml:select&gt;</span>
    <span class="sc2">&lt;<span class="sy0">/</span>maml:fetch&gt;</span>
&nbsp;
   <span class="sc2">&lt;maml:<span class="kw1">input</span> <span class="kw3">type</span><span class="sy0">=</span><span class="st0">&quot;submit&quot;</span> <span class="kw3">value</span><span class="sy0">=</span><span class="st0">&quot;MAML submit Button&quot;</span><span class="sy0">/</span>&gt;</span>
<span class="sc2">&lt;<span class="sy0">/</span>maml:form&gt;</span>
&nbsp;</pre>
<br />

<h5 style="text-align: center;">Sample Form:</h5>
<div style="height: 200px; width: 500px; padding: 20px; background: #fcfcfc; margin: 0 auto;">
    <maml:form table="molly_test" response="" keyfield="test_id" keyvalue="*[t_Link]*" mode="replace" schema="on">
       <strong>Name:&#9;</strong> <maml:input type="text" name="name" size="24" /><br/>
       <strong>Eye Color:&#9;</strong> <maml:input type="text" name="eyecolor" value="*[t_RenderAs]*"/><br/>
       <strong>Age:&#9;</strong> <maml:input type="text" name="age" value="*[t_Link]*"/><br/>

        <maml:fetch table="molly_username" maxentries="2" fields="lastname, firstname, user_id" orderby="lastname">
            <strong>User:&#9;</strong> <maml:select name="file_token" size="1">
                <maml:row>
                    <maml:option value=""><maml:field name="lastname" />, <maml:field name="firstname"/> (*[user_id]*)</maml:option>
                </maml:row>
            </maml:select>
        </maml:fetch>
        <br />
       <maml:input type="submit" value="MAML submit Button"/>
    </maml:form>
</div>
<br />
DOCBLOCK;

	function __construct() {
		$this->name = $this->id();
		$this->action = 'none';
		$this->schema = 'off';
		$this->owner=$_SESSION['s_UserID']; //////////// WAIT - is this right???????????

	}


	protected function autoSchema($pv_Render='off') {
		global $gv_SchemaStart, $gv_SchemaEnd;
		if ($pv_Render=='on') {
			echo "\r<!-- \r        Schema Automatically Generated by Molly from <maml:form>\r\r";
			echo "*****************************************************************************************\r";
			echo "*** Please note that the SQL generated may not be correct for other than simple       ***\r";
			echo "*** forms and that Molly makes some assumptions about key fields, field lengths, etc. ***\r";
			echo "*** Please edit the SQL to suit your needs.                                           ***\r";
			echo "*****************************************************************************************\r\r";
			echo $gv_SchemaStart;
			echo $gv_SchemaEnd;
			echo "\r\r-->";
		}
	}

	public function begin(){
		global $gv_SchemaStart;
		global $gv_SchemaEnd;
		global $gv_currentForm;

		$gv_currentForm = array_pop(explode('$', crypt(session_id() . array_shift(explode('?', $_SERVER['REQUEST_URI'])) . $this->id, '$5$1234567890123456'))); // the number after the second $ is supposed to be constant


		if (!($this->keyvalue)){
			$this->keyvalue=m_clean_params_for_query($_REQUEST['t_Link']); // cleaning b/c gets passed into query on submission
		}
		if (!($this->keyvalue)){
			global $gv_InsertID;
			$this->keyvalue=$gv_InsertID;
		}
		if ($this->mode == 'input') { // backward compatibility with old form tags
			$this->mode = 'insert';
		}

		if ($this->mode == 'edit' or $_REQUEST['t_RenderAs'] == 'edit') {
			switch ($this->ownership) {
				case "field":
					$fv_Query= $this->keyfield . " = '" . $this->keyvalue . "'";
					$fv_FormData = m_FetchRecordsArray ($this->table, '*', $fv_Query, $this->keyfield);
					$fv_CurrentRecordOwner = $fv_FormData[0][$this->owner];
					//$fv_isOwned = (checkOwnerName($fv_CurrentRecordOwner) or checkOwnerID($fv_CurrentRecordOwner));
				break;

				case "idfield":
					$fv_Query= $this->keyfield . " = '" . $this->keyvalue . "'";
					$fv_FormData = m_FetchRecordsArray ($this->table, '*', $fv_Query, $this->keyfield);
					$fv_CurrentRecordOwner = $fv_FormData[0][$this->owner];
					//$fv_isOwned = checkOwnerID($fv_CurrentRecordOwner);
				break;

				case "namefield":
					$fv_Query= $this->keyfield . " = '" . $this->keyvalue . "'";
					$fv_FormData = m_FetchRecordsArray ($this->table, '*', $fv_Query, $this->keyfield);
					$fv_CurrentRecordOwner = $fv_FormData[0][$this->owner];
					//$fv_isOwned = checkOwnerName($fv_CurrentRecordOwner);
				break;

				/*case "login":
				case "name":
					$fv_isOwned = checkOwnerName($this->owner);
				break;

				case "id":
					$fv_isOwned = checkOwnerID($this->owner);
				break;

				case "none":
				default:
					$fv_isOwned = true;
				break;*/

			}

		}      elseif

            ($this->mode == 'insert' or $_REQUEST['t_RenderAs'] == 'insert') {
			//$fv_isOwned = true;
		} else {
			//$fv_isOwned = false;
		}

/*		if ($fv_isOwned) {
//		if ($fv_isOwned or checkPermission($this->permitted)) {

// echo "<br />Permitted:" . $this->permitted . "<br />"; //debug


			if ($this->mode) {
				$gv_FormRenderMode = $this->mode;
			} else {
				$gv_FormRenderMode = $_REQUEST['t_RenderAs'];
			}
		} else {
			$gv_FormRenderMode = "output";
		}

		if (!($this->keyvalue)){
			$fv_results=m_FetchRecordsArray($this->table,$this->keyfield,"1=1",$this->keyfield);
			$key=$this->keyfield;
			$fv_resultCount = count($fv_results)-1;
			if(is_numeric($fv_results[$fv_resultCount][$key])){
				//echo $fv_results[$fv_resultCount][$key];
				$this->keyvalue=$fv_results[$fv_resultCount][$key]+1;
			}else{

			}

		}
		$gv_incrementField=0;
		// echo "\n<!-- about to call autoform -->\n";
//		$t_FormData = $this->autoForm($this->keyvalue, $this->table, $this->keyfield, $this->response, $gv_FormRenderMode, $this->action, $this->name,$this->criteria, $this->linkfield);
		// echo "\n<!-- returning from autoform -->\n";
*/



		global $gv_Config, $gv_RecordToEdit;

		switch ($this->mode) { // ok, really default mode should be output... need to figure out the logic here
			case "edit":
//				echo "<h1>edit mode</h1>";
				if ($this->action == 'none') {
					$fv_TemplateVars['script'] = 'replace.html';
				} else {
					$fv_TemplateVars['script'] = $this->action;
				}
/*
			<input type="hidden" name="user_id" value="28"/>
			<input type="hidden" name="t_keyfield" value="user_id"/>
			<input type="hidden" name="t_linkfield" value=""/>
			<input type="hidden" name="t_keyvalue" value="28"/>
			<input type="hidden" name="t_response" value="myportico.maml"/>
			<input type="hidden" name="t_table" value="foto_profiles"/>

*/
				$fv_Query = "SELECT * from `" . $this->table . "` WHERE `" . $this->keyfield . "` = '" . $this->keyvalue . "'";
//				echo $fv_Query . '<br />';
//				$fv_Query = "SELECT * from `foto_profiles` WHERE `user_id` = '28'";

				$fv_Query = m_Interpolate($fv_Query,$_SESSION['tokens']);


//				echo $fv_Query . '<pre>';
				$fv_RecordToEdit = m_FetchDBHash($fv_Query);
//				var_dump($fv_RecordToEdit);
				$gv_RecordToEdit = $fv_RecordToEdit[0];
//				echo '</pre><br />';
			break;
		case "delete":
				if ($this->action == 'none') {

					$fv_TemplateVars['script'] = 'delete.html';
				} else {
					$fv_TemplateVars['script'] = $this->action;
				}
                break;
			case "insert":
			default:
				$this->mode = "insert";
				if ($this->action == 'none') {
					$fv_TemplateVars['script'] = 'insert.html';
				} else {
					$fv_TemplateVars['script'] = $this->action;
				}
//				$fv_TemplateVars['action'] = $gv_Config['HTMLRoot'] . $gv_Config['FormHandler'] . 'insert.html';
			break;
		}

		$fv_TemplateVars['id'] = $this->id;
		$fv_TemplateVars['name'] = $this->name;
		$fv_TemplateVars['formToken'] = $gv_currentForm;

		if(!isset($_SESSION['forms']) || !is_array($_SESSION['forms'])) {
			$_SESSION['forms'] = array();
		}

		$fv_tokens = array_merge($gv_Config, $_SESSION['tokens']);

		$_SESSION['forms'][$gv_currentForm] = array();
		$_SESSION['forms'][$gv_currentForm]['table'] = m_Interpolate($this->table, $fv_tokens);
		$_SESSION['forms'][$gv_currentForm]['response'] = m_Interpolate($this->response, $fv_tokens);
		$_SESSION['forms'][$gv_currentForm]['keyfield'] = m_Interpolate($this->keyfield, $fv_tokens);
		$_SESSION['forms'][$gv_currentForm]['keyvalue'] = m_Interpolate($this->keyvalue, $fv_tokens);
		$_SESSION['forms'][$gv_currentForm]['linkfield'] = m_Interpolate($this->linkfield, $fv_tokens);
		$_SESSION['forms'][$gv_currentForm]['linkname'] = m_Interpolate($this->linkname, $fv_tokens);

		$_SESSION['forms'][$gv_currentForm]['id']= $this->id;
		$_SESSION['forms'][$gv_currentForm]['page']= $_SERVER['REQUEST_URI'];
		if($this->permitted != 'all' && $this->permitted != null) {
			$_SESSION['forms'][$gv_currentForm]['permitted']= $this->permitted;
		}

		$this->echoTemplate(MOLLY_SKIN_DIRECTORY . 'templates/form.begin.' . $this->mode . '.' . 'tplt', $fv_TemplateVars);

		$gv_SchemaStart = "\r# Host: {$GLOBALS['gv_SiteGlobals']['Database']['DBHostName']} Database : {$GLOBALS['gv_SiteGlobals']['Database']['DatabaseName']}\r";
		$gv_SchemaStart .= "# --------------------------------------------------------\r";
		$gv_SchemaStart .= "#\r";
		$gv_SchemaStart .= "# Table structure for table '$this->table'\r";
		$gv_SchemaStart .= "#\r\r";
		$gv_SchemaStart .= "DROP TABLE IF EXISTS $this->table;\r";
		$gv_SchemaStart .= "CREATE TABLE $this->table (\r";

  		$gv_SchemaEnd = "   `$this->keyfield` mediumint(10) NOT NULL auto_increment,\r";

		$gv_SchemaEnd .= "   PRIMARY KEY ($this->keyfield),\r";
		$gv_SchemaEnd .= "   UNIQUE $p_KeyField ($this->keyfield)\r";
		$gv_SchemaEnd .= ");\r";

	}



	public function end(){
//		$this->endAutoForm();
		$this->echoTemplate(MOLLY_SKIN_DIRECTORY . 'templates/form.end.' . $this->mode . '.' . 'tplt', array());
		$this->autoSchema($this->schema);

		// Clean up
		unset($GLOBALS['gv_RecordToEdit']);
		$gv_currentForm = null;
	}

}

/* -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+----- */

class maml_captcha extends prototype_tag {

		protected $doctext = <<<'DOCBLOCK'
<p>Adds captcha protection to Molly forms.</p>
DOCBLOCK;

	public function begin(){
		global $gv_Config, $gv_currentForm;

		$_SESSION['forms'][$gv_currentForm]['captcha'] = 'true'; // actual captcha value is stored in another value

		$fv_TemplateVars['image_url'] = $gv_Config['HTMLRoot'] . m_captchaimgurl();
		$fv_TemplateVars['wav_url'] = $gv_Config['HTMLRoot'] . m_captchawavurl();
		$fv_TemplateVars['captcha_error'] = '<br /><span style="color:#DD0000;">' . $_GET['t_error'] . '</span>';
		$this->echoTemplate(MOLLY_SKIN_DIRECTORY . 'templates/captcha.tplt', $fv_TemplateVars);

	}

}

/* -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+----- */

class maml_email extends prototype_tag {

		public $to;
		public $subject;
		public $replyTo;

		protected $doctext = <<<'DOCBLOCK'
<p>Sends an email upon <code>&lt;maml:form&gt;</code> submission.</p>

<ul>
<li>The <strong>to</strong> attribute (required) denotes the address to send the email to.</li>
<li>The <strong>subject</strong> attribute (required) denotes the subject of the email. Tokens are allowed.</li>
<li>The <strong>replyTo</strong> attribute (optional) denotes the address that receivers should send their replies to.</li>
<li>The tag contents are the body of the email, and can contain tokens as well.</li>
</ul>

<p>
	Not all tokens can be used in the subject & body. Form data is be default not allowed.
	Form data can be used <em>if and only if</em> the <code>allowInEmail</code> attribute is set &amp; <code>&lt;maml:email&gt;</code> is located after all desired inputs.
	This is a safety measure to prevent accidental spam/abuse.
	Additionally, the token <code><span>*</span>[f_Page]<span>*</span></code> can be used for the page the form was submitted from.
</p>
<p><em>It is strongly advised to use this with <code>&lt;maml:captcha&gt;</code> or <code>&lt;maml:protect&gt;</code>.</em></p>
DOCBLOCK;

	public function begin() {
		global $gv_currentForm;

		if(!isset($gv_currentForm) || !isset($this->to) || !isset($this->subject)) {
			return;
		}

		$_SESSION['forms'][$gv_currentForm]['emailOnSubmit'] = "true";
		$_SESSION['forms'][$gv_currentForm]['emailOptions'] = array();
		$_SESSION['forms'][$gv_currentForm]['emailOptions']['to'] = $this->to;
		$_SESSION['forms'][$gv_currentForm]['emailOptions']['subject'] = $this->subject;
		if(isset($this->replyTo)) {
			$_SESSION['forms'][$gv_currentForm]['emailOptions']['replyTo'] = $this->replyTo;
		}

		$this->startCache();
	}

	public function end() {
		global $gv_currentForm;

		if(!isset($gv_currentForm) || !isset($this->to) || !isset($this->subject)) {
			return;
		}

		$this->finishCache();
		$_SESSION['forms'][$gv_currentForm]['emailOptions']['body'] = $this->tagCache;
	}

}

/* -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+----- */

class maml_input extends prototype_tag { // <input type="text" name="permissionGroupID" /> <input type="submit" value="Submit" />
/*	var $doctext='		Must be within <form></form> pair.

		Required Attribute: type [text|submit|hidden|checkbox|radio|password|reset]
		Optional Attribute: name
		Optional Attribute: value
		Optional Attribute: selected 	// [CHECKED] for radio andcheckbox
		Example:
			<maml:form table="test" response="/~rvullo/m2/test/list.maml" keyfield="age" schema="on">
				Name: <maml:input type="text" name="name"/><br/>
				Eye Color: <maml:input type="text" name="eyecolor"/><br/>
				Age: <maml:input type="text" name="age"/><br/>
				<maml:input type="submit" value="I am a submit Button"/>
			</maml:form>
';*/
	public $type;
	public $style;
	public $name;
	public $value;
	public $size;
	public $selected;
	public $id;

	public $onclick;
	public $onfocus;
	public $onblur;
	public $onchange;
	public $onselect;
	public $onreset;
	public $hash;
	public $match;
	public $allowInEmail;

		protected $doctext = <<<'DOCBLOCK'
<p><strong>Description:</strong> The input tag is to be used within a <strong>maml:form</strong> tag and acts similarly to HTML
form input types. The key difference of the <strong>maml:input</strong> tag is that it works alongside the <strong>maml:form</strong> tag to check input before being
inserted into the database, and does so without the user needing to write any code.</p>
<p><strong>Attributes:</strong>
    <ul>
        <li><strong>type:</strong> Defines the type of input the user can enter. Options include text, password, radio, checkbox, button, hidden, and more. Hidden inputs will be moved to the session information and re-injected in the submission. This means it will not appear in the page HTML &amp; allows for carrying over information the user shouldn't see.</li>
        <li><strong>name: </strong> Defines the name of the input field, which is submitted along with the form data.</li>
        <li><strong>value: </strong> Specifies the initial value of the input field. Required for radio buttons and checkboxes to determine their labels.</li>
        <li><strong>size: </strong> If type is text or password, this specifies the maximum number of characters allowed in that field. Otherwise, this attribute specifies the initial display size of the input field.</li>
        <li><strong>id: </strong> Defines the ID of the input field, which is used to reference that input and its contents.</li>
        <li><strong>allowInEmail: </strong>denotes that the value of this input can be used as a token in a <code>&lt;maml:email&gt;</code> tag as the given string, prepended by <code>"f_"</code>. This option does not work on password inputs.</li>
        <li><strong>hash: </strong>Hash the input with the default password hashing method in <code>molly.ini</code></li>
        <li><strong>match: </strong>Requires the value of this field to match the specified field</li>
    </ul>
<strong>Example:</strong>
<pre>
    <em style="color: red;">Input example here.</em>
</pre>
</p>
DOCBLOCK;

	function __construct(){
		$this->size='16';
		$this->id=$this->id();
	}

	public function begin(){
		global $gv_RecordToEdit, $gv_currentForm, $gv_Config;

		$fv_TemplateVars['id'] = $this->id;
		$fv_TemplateVars['size'] = $this->size;
		if (!isset($this->class)) {
			$this->class='insert';
		}
		$fv_TemplateVars['class'] = $this->class;
		$fv_TemplateVars['type'] = $this->type;
		$fv_TemplateVars['name'] = $this->name;
		$fv_TemplateVars['value'] = $this->value;

		if (isset($gv_RecordToEdit[$this->name])) {
			$fv_TemplateVars['value'] = $gv_RecordToEdit[$this->name];
		}
		if ($this->selected && $this->type == 'radio') {
			$fv_TemplateVars['checked'] = 'checked';
		} else {
			$fv_TemplateVars['checked'] = '';
		}
		if ($this->onclick) {
			$fv_TemplateVars['onclick'] = ' onclick="' . $this->onclick . '"';
		} else {
			$fv_TemplateVars['onclick'] = '';
		}
		if ($this->onfocus) {
			$fv_TemplateVars['onfocus'] = ' onfocus="' . $this->onfocus . '"';
		} else {
			$fv_TemplateVars['onfocus'] = '';
		}
		if ($this->onblur) {
			$fv_TemplateVars['onblur'] = ' onblur="' . $this->onblur . '"';
		} else {
			$fv_TemplateVars['onblur'] = '';
		}
		if ($this->onchange) {
			$fv_TemplateVars['onchange'] = ' onchange="' . $this->onchange . '"';
		} else {
			$fv_TemplateVars['onchange'] = '';
		}
		if ($this->onselect) {
			$fv_TemplateVars['onselect'] = ' onselect="' . $this->onselect . '"';
		} else {
			$fv_TemplateVars['onselect'] = '';
		}
		if ($this->onreset) {
			$fv_TemplateVars['onreset'] = ' onreset="' . $this->onreset . '"';
		} else {
			$fv_TemplateVars['onreset'] = '';
		}
		if ($this->style) {
			$fv_TemplateVars['style'] = ' style="' . $this->style . '"';
		} else {
			$fv_TemplateVars['style'] = '';
		}

		if($this->type != "hidden") {
			$this->echoTemplate(MOLLY_SKIN_DIRECTORY . 'templates/input.' . $this->type . '.' . 'insert' . '.' . 'tplt', $fv_TemplateVars);
		} else {
			if(!isset($_SESSION['forms'][$gv_currentForm]['request_override'])) {
				$_SESSION['forms'][$gv_currentForm]['request_override'] = array();
			}

			$fv_tokens = array_merge($gv_Config, $_SESSION['tokens']);

			// Parse HTML array-notation of name to an actual array
			$fv_inject0 = explode('[', str_replace(']', '', $this->name));
			$fv_inject = m_Interpolate($this->value, $fv_tokens);
			for($i = count($fv_inject0) - 1; $i >= 0 ; $i--) {
				$fv_inject = array($fv_inject0[$i] => $fv_inject);
			}

			$_SESSION['forms'][$gv_currentForm]['request_override'] = injectRecursive($_SESSION['forms'][$gv_currentForm]['request_override'], $fv_inject);
		}
		if($this->type != "password" && $this->emailOnSubmit) {
			if(!isset($_SESSION['forms'][$gv_currentForm]['emailTokens'])) {
				$_SESSION['forms'][$gv_currentForm]['emailTokens'] = array();
			}
			$_SESSION['forms'][$gv_currentForm]['emailTokens']['f_' . $this->name] = $this->value;
		}

		if($this->hash) {
				if(!isset($_SESSION['forms'][$gv_currentForm]['hash'])) {
					$_SESSION['forms'][$gv_currentForm]['hash'] = array();
				}

				// Parse HTML array-notation of name to an actual array
				$fv_inject0 = explode('[', str_replace(']', '', $this->name));
				$fv_inject = 'true';
				for($i = count($fv_inject0) - 1; $i >= 0 ; $i--) {
					$fv_inject = array($fv_inject0[$i] => $fv_inject);
				}

				$_SESSION['forms'][$gv_currentForm]['hash'] = injectRecursive($_SESSION['forms'][$gv_currentForm]['hash'], $fv_inject);
		}
		if($this->match) {
				if(!isset($_SESSION['forms'][$gv_currentForm]['match'])) {
					$_SESSION['forms'][$gv_currentForm]['match'] = array();
				}

				// Parse HTML array-notation of name to an actual array
				$fv_inject0 = explode('[', str_replace(']', '', $this->name));
				$fv_inject = $this->match;
				for($i = count($fv_inject0) - 1; $i >= 0 ; $i--) {
					$fv_inject = array($fv_inject0[$i] => $fv_inject);
				}

				$_SESSION['forms'][$gv_currentForm]['match'] = injectRecursive($_SESSION['forms'][$gv_currentForm]['match'], $fv_inject);
		}
		if($this->noquery) {
				if(!isset($_SESSION['forms'][$gv_currentForm]['noquery'])) {
					$_SESSION['forms'][$gv_currentForm]['noquery'] = array();
				}

				array_push($_SESSION['forms'][$gv_currentForm]['noquery'], $this->name);
		}

/*        //echo $this->encryption; exit();
        if ($this->encryption){
            // echo $this->encryption; exit();
            //echo "<span display = 'none'> <input type='hidden' name='encrypt' value='".$fv_TemplateVars['name']."'/><input type='hidden' name='encryptType' value='".strtolower($this->encryption)."'/></span>";
			if(!isset($_SESSION['forms'][$gv_currentForm]['request_override'])) {
				$_SESSION['forms'][$gv_currentForm]['request_override'] = array();
			}
			$_SESSION['forms'][$gv_currentForm]['request_override']['encrypt'] = $this->name;
			$_SESSION['forms'][$gv_currentForm]['request_override']['encryptType'] = strtolower($this->encryption);
        }
        if ($this->emailreset){
            //echo $fv_TemplateVars['name'];
            //echo "<span display = 'none'><input type = 'hidden' name = 'emailreset' value='".$fv_TemplateVars['name']."'/><input type = 'hidden' name='emailresetfield' value='".strtolower($this->emailreset)."'/></span>";
			if(!isset($_SESSION['forms'][$gv_currentForm]['request_override'])) {
				$_SESSION['forms'][$gv_currentForm]['request_override'] = array();
			}
			$_SESSION['forms'][$gv_currentForm]['request_override']['emailreset'] = $this->name;
			$_SESSION['forms'][$gv_currentForm]['request_override']['emailresetfield'] = strtolower($this->emailreset);
        }
        if ($this->passwordreset){
            //echo "<span display = 'none'><input type = 'hidden' name = 'passwordreset' value = '".$fv_TemplateVars['name']."'/><input type = 'hidden' name = 'passwordresetfield' value = '".strtolower($this->passwordreset)."'/></span>";
			if(!isset($_SESSION['forms'][$gv_currentForm]['request_override'])) {
				$_SESSION['forms'][$gv_currentForm]['request_override'] = array();
			}
			$_SESSION['forms'][$gv_currentForm]['request_override']['passwordreset'] = $this->name;
			$_SESSION['forms'][$gv_currentForm]['request_override']['passwordresetfield'] = strtolower($this->passwordreset);
		}*/
	}

	public function end() {
		global $gv_SchemaStart;
		if (!($this->type == "submit" or $this->type == "reset")) {
			$gv_SchemaStart .= "   `$this->name` varchar($this->size),\r";
		}
	}

}


/* -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+----- */

class maml_select extends prototype_tag {
	public $name;
	public $size;
	public $disabled;
	public $multiple;
	public $tabindex;

	public $onclick;
	public $onfocus;
	public $onblur;
	public $onchange;
	public $onselect;
	public $onreset;


	public function begin() {
		global $gv_RecordToEdit, $gv_ChosenOption;

		$fv_TemplateVars['id'] = $this->id;
		$fv_TemplateVars['name'] = $this->name;

		if ($this->size) {
			$fv_TemplateVars['size'] = $this->size;
		} else {
			$fv_TemplateVars['size'] = '1';
		}
		if ($this->disabled) {
			$fv_TemplateVars['disabled'] = ' disabled="' . $this->disabled . '"';
		} else {
			$fv_TemplateVars['disabled'] = '';
		}
		if ($this->multiple) {
			$fv_TemplateVars['multiple'] = ' multiple="' . $this->multiple . '"';
		} else {
			$fv_TemplateVars['multiple'] = '';
		}
		if ($this->tabindex) {
			$fv_TemplateVars['tabindex'] = ' tabindex="' . $this->tabindex . '"';
		} else {
			$fv_TemplateVars['tabindex'] = '';
		}

		// JavaScript Events
		if ($this->onclick) {
			$fv_TemplateVars['onclick'] = ' onclick="' . $this->onclick . '"';
		} else {
			$fv_TemplateVars['onclick'] = '';
		}
		if ($this->onfocus) {
			$fv_TemplateVars['onfocus'] = ' onfocus="' . $this->onfocus . '"';
		} else {
			$fv_TemplateVars['onfocus'] = '';
		}
		if ($this->onblur) {
			$fv_TemplateVars['onblur'] = ' onblur="' . $this->onblur . '"';
		} else {
			$fv_TemplateVars['onblur'] = '';
		}
		if ($this->onchange) {
			$fv_TemplateVars['onchange'] = ' onchange="' . $this->onchange . '"';
		} else {
			$fv_TemplateVars['onchange'] = '';
		}
		if ($this->onselect) {
			$fv_TemplateVars['onselect'] = ' onselect="' . $this->onselect . '"';
		} else {
			$fv_TemplateVars['onselect'] = '';
		}
		if ($this->onreset) {
			$fv_TemplateVars['onreset'] = ' onreset="' . $this->onreset . '"';
		} else {
			$fv_TemplateVars['onreset'] = '';
		}
		$this->echoTemplate(MOLLY_SKIN_DIRECTORY . 'templates/select.begin.tplt', $fv_TemplateVars);


		if (isset($gv_RecordToEdit)) {
			$gv_ChosenOption = $gv_RecordToEdit[$this->name];
		}
	}
	public function end() {
		global $gv_SchemaStart;

		$fv_TemplateVars['id'] = $this->id;
		$this->echoTemplate(MOLLY_SKIN_DIRECTORY . 'templates/select.end.tplt', $fv_TemplateVars);
		$gv_SchemaStart .= "   `$this->name` varchar(255),\r";
	}

}

/* -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+----- */

class maml_option extends prototype_tag {
	public $id;
	public $onclick;
	public $ondblclick;
	public $onmousedown;
	public $onmousemove;
	public $onmouseout;
	public $onmouseover;
	public $onmouseup;
	public $onkeydown;
	public $onkeypress;
	public $onkeyup;
	public $disabled;
	public $label;
	public $selected;
	public $value;


	public function begin() {
		global $gv_ChosenOption;

		$fv_TemplateVars['id'] = $this->id;
		if ($this->onclick) {
			$fv_TemplateVars['onclick'] = ' onclick="' . $this->onclick . '"';
		} else {
			$fv_TemplateVars['onclick'] = '';
		}
		if ($this->ondblclick) {
			$fv_TemplateVars['ondblclick'] = ' ondblclick="' . $this->ondblclick . '"';
		} else {
			$fv_TemplateVars['ondblclick'] = '';
		}
		if ($this->onmousedown) {
			$fv_TemplateVars['onmousedown'] = ' onmousedown="' . $this->onmousedown . '"';
		} else {
			$fv_TemplateVars['onmousedown'] = '';
		}
		if ($this->onmousemove) {
			$fv_TemplateVars['onmousemove'] = ' onmousemove="' . $this->onmousemove . '"';
		} else {
			$fv_TemplateVars['onmousemove'] = '';
		}
		if ($this->onmouseout) {
			$fv_TemplateVars['onmouseout'] = ' onmouseout="' . $this->onmouseout . '"';
		} else {
			$fv_TemplateVars['onmouseout'] = '';
		}
		if ($this->onmouseover) {
			$fv_TemplateVars['onmouseover'] = ' onmouseover="' . $this->onmouseover . '"';
		} else {
			$fv_TemplateVars['onmouseover'] = '';
		}
		if ($this->onmouseup) {
			$fv_TemplateVars['onmouseup'] = ' onmouseup="' . $this->onmouseup . '"';
		} else {
			$fv_TemplateVars['onmouseup'] = '';
		}
		if ($this->onkeydown) {
			$fv_TemplateVars['onkeydown'] = ' onkeydown="' . $this->onkeydown . '"';
		} else {
			$fv_TemplateVars['onkeydown'] = '';
		}
		if ($this->onkeypress) {
			$fv_TemplateVars['onkeypress'] = ' onkeypress="' . $this->onkeypress . '"';
		} else {
			$fv_TemplateVars['onkeypress'] = '';
		}
		if ($this->onkeyup) {
			$fv_TemplateVars['onkeyup'] = ' onkeyup="' . $this->onkeyup . '"';
		} else {
			$fv_TemplateVars['onkeyup'] = '';
		}
		if ($this->disabled) {
			$fv_TemplateVars['disabled'] = ' disabled="' . $this->disabled . '"';
		} else {
			$fv_TemplateVars['disabled'] = '';
		}
		if ($this->label) {
			$fv_TemplateVars['label'] = ' label="' . $this->label . '"';
		} else {
			$fv_TemplateVars['label'] = '';
		}
		if ($this->value) {
			$fv_TemplateVars['value'] = ' value="' . $this->value . '"';
		} else {
			$fv_TemplateVars['value'] = '';
		}
		if ($this->selected) {
			$fv_TemplateVars['selected'] = ' selected="' . $this->selected . '"';
		} else {
			if ($this->value == $gv_ChosenOption) {
				$fv_TemplateVars['selected'] = 'selected';
			} else {
				$fv_TemplateVars['selected'] = '';
			}
		}
		$this->echoTemplate(MOLLY_SKIN_DIRECTORY . 'templates/option.begin.tplt', $fv_TemplateVars);
	}

	public function end() {
		$this->echoTemplate(MOLLY_SKIN_DIRECTORY . 'templates/option.end.tplt', array());
	}

}


/* -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+----- */

	class maml_block extends prototype_tag { // Under Construction
		//public $permitted;
		public $blocknum;
		public $wiki;
		public $blockid;

		protected $block_id;
		protected $type = 'block';
		protected $doctext = <<<'DOCBLOCK'
<p><strong>Description:</strong> Allows the webmaster to designate an area of
the page as editable online by members of the permitted group. When those members
are logged in they will see an editor in place of the normally static content.</p>
<p>Molly automatically creates the link between blocks and the records in the molly_blocks
table (field: block_id) however it should be noted that these links are somewhat fragile as
they are based on the file name (and path relative to HTMLRoot), and the position (order) of the block on the page if there
are more than one block. Because of this, there is an optional blocknum attribute that can
be used if the order of blocks on a page must be changed after the records in the database
table exist. Alternatively the database record can be edited if neccessary to reflect a
relocated block or renamed/moved page.</p>
<p>If the blockid is set, this allows the same block to be used on multiple pages rather than tying it to a particular page.</p>
<p>The block tag can also be used to create a wiki. Setting the wiki attribute returns that
wiki page from the database and activates automatic wiki linking via putting {{<em>link name</em>}}
in the block&rsquo;s text. You can only have one wiki block per MAML page. To create a new wiki
page, create a wiki link then follow it.
Use of the wiki attribute overrides use of the blockid attribute.</p>
DOCBLOCK;

		protected function blockcount(){
			global $gv_BlockCount;

			if (!isset($gv_BlockCount)) {
				$gv_BlockCount=1;
			}

			if (!$this->blocknum){
				$this->blocknum = $gv_BlockCount;
				$gv_BlockCount++;
			}
			return $this->blocknum;
		}

		public function precheck() {
			// do nothing; <maml:block> uses for the permitted attribute for the editor
		}

		public function begin() {
			global $gv_Config;

			$fv_TemplateVars['id'] = $this->id;
			if (!isset($this->class)) {
				$this->class='block';
			}
			$fv_TemplateVars['class'] = $this->class;
			$fv_TemplateVars['style'] = $this->style;

			$fv_ThisFile = str_replace ($gv_Config['HTMLRoot'],'', $_SERVER["PHP_SELF"]);

			if (isset($this->wiki)) {
				$this->wiki = m_Interpolate($this->wiki, $_REQUEST);
				$this->type = 'wiki';
				$this->block_id = $this->wiki;
			} else {
				if (isset($this->blockid)) {
					$this->block_id = $this->blockid;
				} else {
					$this->block_id = $fv_ThisFile . '_' . $this->blockcount();
				}
			}

			$fv_TemplateVars['block_id'] = m_clean_params_for_query($this->block_id);

			if (!m_permitted($this->permitted)) {
				$this->echoTemplate(MOLLY_SKIN_DIRECTORY . 'templates/block.begin.tplt', $fv_TemplateVars);
			}
			$this->startCache();

		}

		public function end(){
			global $gv_SiteGlobals;

			$this->finishCache();



			$fv_Query = "SELECT * FROM `molly_blocks` WHERE block_id='$this->block_id'";
			$fv_Results = m_FetchDBHash($fv_Query);
			$fv_TemplateVars['id'] = $this->id;
			$fv_TemplateVars['block_id'] = $this->block_id;
			$fv_TemplateVars['type'] = $this->type;



//				$fv_TemplateVars['action'] = $gv_Config['HTMLRoot'] . $gv_Config['FormHandler'] . 'insert.html';



			if (!$fv_Results) {
				$fv_TemplateVars['block_contents'] = $this->tagCache;
			} else {
				$fv_TemplateVars['block_contents'] = $fv_Results[0]['contents'];
			}

			$fv_TemplateVars['script'] = 'block_insert.html';



			if (m_permitted($this->permitted)) {
				// m_AppendJavaScript($pv_Scripts, $pv_ScriptName, $pv_AllowDuplicates=FALSE); // Need to add Editor Script if editable

				//$fv_TemplateVars['block_editor'] = m_Interpolate($this->fetchTemplate(MOLLY_SYSTEM_DIRECTORY . 'templates/block.editor.tplt'), $fv_TemplateVars);

				$gv_currentForm = array_pop(explode('$', crypt(session_id() . array_shift(explode('?', $_SERVER['REQUEST_URI'])) . $this->id, '$5$1234567890123456'))); // the number after the second $ is supposed to be constant
				$fv_TemplateVars['formToken'] = $gv_currentForm;

				if(!isset($_SESSION['forms']) || !is_array($_SESSION['forms'])) {
					$_SESSION['forms'] = array();
				}
				$_SESSION['forms'][$gv_currentForm] = array();
				$_SESSION['forms'][$gv_currentForm]['permitted'] = $this->permitted;
				$_SESSION['forms'][$gv_currentForm]['response'] =  basename($_SERVER["PHP_SELF"]);
				$_SESSION['forms'][$gv_currentForm]['table'] = 'molly_blocks';
				$_SESSION['forms'][$gv_currentForm]['keyfield'] = 'block_id';
				$_SESSION['forms'][$gv_currentForm]['keyvalue'] = $this->block_id;
				$_SESSION['forms'][$gv_currentForm]['linkname'] = 'page';
				$_SESSION['forms'][$gv_currentForm]['linkfield'] = 'block_id';
				$_SESSION['forms'][$gv_currentForm]['request_override'] = array();
				$_SESSION['forms'][$gv_currentForm]['request_override']['t_FormData'] = array();
				$_SESSION['forms'][$gv_currentForm]['request_override']['t_FormData'][0] = array();
				$_SESSION['forms'][$gv_currentForm]['request_override']['t_FormData'][0]['block_id'] = $this->block_id;
				$_SESSION['forms'][$gv_currentForm]['request_override']['t_FormData'][0]['type'] = $this->type;
				$_SESSION['forms'][$gv_currentForm]['request_override']['t_FormData'][0]['language'] = 'en'; // TODO: multilingual blocks

				$fv_TemplateVars['block_contents'] = str_replace('&', '&amp;', $fv_TemplateVars['block_contents']); //added by Christian - not sure what impact is - rpv

				$this->echoTemplate(MOLLY_SKIN_DIRECTORY . 'templates/block.editor.tplt', $fv_TemplateVars);

				$fv_TinyMCEInit = <<<'SCRIPT'
$(document).ready(function(){tinymce.init({
        selector : ".molly_wysiwyg",
		plugins : 'anchor autolink charmap code colorpicker image link lists media paste preview searchreplace table textcolor wordcount',
		toolbar : [
			'undo redo | formatselect | bold italic | link image | bullist numlist | outdent indent',
		],
		menubar: 'edit insert format table view help',
		min_height: 500,
		browser_spellcheck : true,
		branding: false,
		forced_root_block: false
})});
SCRIPT;

				$fv_ScriptPath = '</script><script type="text/javascript" src="' . $gv_SiteGlobals['Paths']['HTMLRoot'] . 'utilities/scripts/tinymce/js/tinymce/tinymce.min.js"></script><script type="text/javascript">' . $fv_TinyMCEInit;
				m_AppendJavaScript($fv_ScriptPath,'tinymce');
			} else {
				if (isset($this->wiki)) {
				$fv_TemplateVars['page'] = $_REQUEST["page"];// for wiki functionality
					$fv_TemplateVars['block_contents'] = preg_replace("/\{\{(.+)\}\}/U",'<a href="' . $_SERVER['PHP_SELF'] . '?page=\1">\1</a>', $fv_TemplateVars['block_contents']);
				}
				$this->echoTemplate(MOLLY_SKIN_DIRECTORY . 'templates/block.end.tplt', $fv_TemplateVars);
			}
		}
	} // class maml_block

/* -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+----- */

class maml_textarea extends prototype_tag { // <input type="text" name="permissionGroupID" /> <input type="submit" value="Submit" />
	public $name;
	public $id;
	public $cols="75";
	public $rows="10";
	public $class;
	public $style;

	public $onclick;
	public $onfocus;
	public $onblur;
	public $onchange;
	public $onselect;
	public $onreset;

		protected $doctext = <<<'DOCBLOCK'
<p><strong>Description:</strong> The maml:textarea tag is used to specify a textbox for multiline plaintext editing on the user's end. Textareas can be used within the maml:form tag,
but are not required for use.
<ul>
    <li><strong>name:</strong> Specifies the name of the textarea; submitted alongside form data when used in maml:forms.</li>
    <li><strong>id:</strong> Specifies the ID of the textarea, and used to reference this input.</li>
    <li><strong>class:</strong> Required for use.</li>
    <li><strong>style:</strong> Specifies visibility and other style attributes for the textarea.</li>
    <li><strong>cols:</strong> Specifies the number of columns the textarea will display. By default, set to 75.</li>
    <li><strong>rows:</strong> Specifies the number of rows the textarea will display. By default, set to 10.</li>
</ul>
<strong>Example:</strong><br />
<maml:textarea name="text" id="text" class=""></maml:textarea></p>
DOCBLOCK;

	function __construct(){
		$this->id=$this->id();
	}

	public function begin(){
		global $gv_SiteGlobals, $gv_RecordToEdit;

		$fv_TemplateVars['id'] = $this->id;
		$fv_TemplateVars['cols'] = $this->cols;
		$fv_TemplateVars['rows'] = $this->rows;
		if (!isset($this->class)) {
			$this->class='molly_wysiwyg';
		}
		$fv_TemplateVars['class'] = $this->class;
		$fv_TemplateVars['name'] = $this->name;
//		$fv_TemplateVars['style'] = $this->style;

		if ($this->onclick) {
			$fv_TemplateVars['onclick'] = ' onclick="' . $this->onclick . '"';
		} else {
			$fv_TemplateVars['onclick'] = '';
		}
		if ($this->onfocus) {
			$fv_TemplateVars['onfocus'] = ' onfocus="' . $this->onfocus . '"';
		} else {
			$fv_TemplateVars['onfocus'] = '';
		}
		if ($this->onblur) {
			$fv_TemplateVars['onblur'] = ' onblur="' . $this->onblur . '"';
		} else {
			$fv_TemplateVars['onblur'] = '';
		}
		if ($this->onchange) {
			$fv_TemplateVars['onchange'] = ' onchange="' . $this->onchange . '"';
		} else {
			$fv_TemplateVars['onchange'] = '';
		}
		if ($this->onselect) {
			$fv_TemplateVars['onselect'] = ' onselect="' . $this->onselect . '"';
		} else {
			$fv_TemplateVars['onselect'] = '';
		}
		if ($this->onreset) {
			$fv_TemplateVars['onreset'] = ' onreset="' . $this->onreset . '"';
		} else {
			$fv_TemplateVars['onreset'] = '';
		}
		if ($this->style) {
			$fv_TemplateVars['style'] = ' style="' . $this->style . '"';
		} else {
			$fv_TemplateVars['style'] = '';
		}
		if (isset($gv_RecordToEdit)) {
			$fv_TemplateVars['value'] = $gv_RecordToEdit[$this->name];
		}

		$fv_TinyMCEInit = <<<'SCRIPT'
$(document).ready(function(){tinymce.init({
        selector : ".molly_wysiwyg",
		plugins : 'anchor autolink charmap code colorpicker image link lists media paste preview searchreplace table textcolor wordcount',
		toolbar : [
			'undo redo | formatselect | bold italic | link image | bullist numlist | outdent indent',
		],
		menubar: 'edit insert format table view help',
		min_height: 500,
		browser_spellcheck : true,
		branding: false,
		forced_root_block: false
})});
SCRIPT;

				$fv_ScriptPath = '</script><script type="text/javascript" src="' .  $gv_SiteGlobals['Paths']['HTMLRoot'] . 'utilities/scripts/tinymce/js/tinymce/tinymce.min.js"></script><script type="text/javascript">' . $fv_TinyMCEInit;
				m_AppendJavaScript($fv_ScriptPath,'tinymce');

		$this->echoTemplate(MOLLY_SKIN_DIRECTORY . 'templates/textarea.begin.tplt', $fv_TemplateVars);

	}
	public function end(){
		global $gv_SchemaStart;

		echo '</textarea>';
		$gv_SchemaStart .= "   `" . $this->name . "` text,\n";
	}

}

/* -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+----- */


	class maml_timeformat extends prototype_tag { // Under Construction
		public $format='unix';

		protected $doctext = <<<'DOCBLOCK'
<p><strong>Description:</strong> Converts a timestamp (as from a database) to either unix or javascript
timestamp format (i.e. second or miliseconds since January 1, 1970 00:00:00 UTC).</p>
DOCBLOCK;
		public function begin() {
			$this->startCache();
		}

		public function end() {
			$this->finishCache();
			date_default_timezone_set ('America/New_York');

			$fv_NewDateTime = strtotime("$fv_NewDateTime GMT");

			switch (strtolower($this->format)) {
				case 'javascript':
					echo $fv_NewDateTime * 1000;
				break;

				case 'unix':
				default:
					echo $fv_NewDateTime;
				break;

			}
		}

	}














?>
