<?php


/* -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+----- */

if(false) { // disabled for security - change to true to enable
	class maml_upload  extends prototype_tag {
		public $label='Upload Files';	
		public $maxsize="1048576"; // 1 kilobyte=1024 1 megabyte=1048576 1 gigabyte=1073741824
		public $destination="/uploads";
		public $response;
		public $process;
		public $type;
		public $callback;

	protected $doctext = <<<'DOCBLOCK'
<p>Creates a widget for uploading files via AJAX.</p>

	
DOCBLOCK;


/*
Some of this code was based on the filedrag.js HTML5 File Drag & Drop demonstration
	Featured on SitePoint.com
	Developed by Craig Buckler (@craigbuckler) of OptimalWorks.net
	
For more information, please refer to:
	http://www.sitepoint.com/html5-file-drag-and-drop/					How to Use HTML5 File Drag &amp Drop
	http://www.sitepoint.com/html5-javascript-open-dropped-files		How to Open Dropped Files Using HTML5 and JavaScript
	http://www.sitepoint.com/html5-ajax-file-upload						How to Asynchronously Upload Files Using HTML5 and Ajax
	http://www.sitepoint.com/html5-javascript-file-upload-progress-bar	How to Create File Upload Progress Bars in HTML5 and JavaScript
			if($this->path =='FilePath') {
				$this->path = $gv_Config['FileRoot'];
			}
*/
		public function begin() {
			global $gv_Config;
			
			$this->label =  m_Interpolate($this->label,$gv_Config);
			$this->maxsize =  m_Interpolate($this->maxsize,$gv_Config);
			$this->destination =  m_Interpolate($this->destination,$gv_Config);
			$this->response =  m_Interpolate($this->response,$gv_Config);
			$this->process =  m_Interpolate($this->process,$gv_Config);
			$this->type =  m_Interpolate($this->type,$gv_Config);
			$this->callback =  m_Interpolate($this->callback,$gv_Config); 
			
             // added multiple attribute. Default is set to single file.
			 // setting multiple="true" enable multiple file upload
			$this->multiple = m_Interpolate($this->multiple,$gv_Config);
			
			
			if(isset($_SESSION['tokens'])) {
				$this->label =  m_Interpolate($this->label,$_SESSION['tokens']);
				$this->maxsize =  m_Interpolate($this->maxsize,$_SESSION['tokens']);
				$this->destination =  m_Interpolate($this->destination,$_SESSION['tokens']);
				$this->response =  m_Interpolate($this->response,$_SESSION['tokens']);
				$this->process =  m_Interpolate($this->process,$_SESSION['tokens']);
				$this->type =  m_Interpolate($this->type,$_SESSION['tokens']);
				$this->callback =  m_Interpolate($this->callback,$_SESSION['tokens']);
				
				$this->multiple = m_Interpolate($this->multiple,$gv_Config,$_SESSION['tokens']);
			}
			$this->tagName = str_replace('maml_', '', get_class($this));
			
			if (isset($this->style)) {
				$fv_TemplateVars['style'] = ' style="' . $this->style .'"';
			}
			
			if (isset($this->destination)) {
				$_SESSION['s_file_upload_destination'] = $this->destination;
			} else {
				$_SESSION['s_file_upload_destination'] = $gv_Config['FileRoot'] . 'uploads/';
			}
			
			$fv_TemplateVars = array();
			$fv_TheTemplate = $this->fetchTemplate(MOLLY_SKIN_DIRECTORY . 'templates/' . $this->tagName . '.style.tplt');
			$fv_TheTemplate = m_Interpolate($fv_TheTemplate, $fv_TemplateVars);
			m_AppendStylesheet($fv_TheTemplate, 'upload', FALSE);

			$this->echoTemplate(MOLLY_SKIN_DIRECTORY . 'templates/' . $this->tagName . '.begin.tplt', $fv_TemplateVars);
			

		}
		
		public function end() {
			global $gv_Config;
			
			$fv_TemplateVars['label'] = $this->label;
			$fv_TemplateVars['scriptpath'] = $gv_Config['HTMLRoot'] . 'utilities/scripts/';			
			$fv_TemplateVars['action'] = $gv_Config['SystemRoot'] . 'forms/drag_drop_upload.html';	
			
			$fv_TemplateVars['multiple'] = (isset($this->multiple) && $this->multiple == "true")? "multiple" : null;			
			$fv_TemplateVars['type'] =     (isset($this->type) && ! empty($this->type))? "accept = '" . $this->type . "'": null;							 
			$fv_TemplateVars['process'] =  (! empty($this->process) && file_exists($this->process)) ? $this->process  : "";			
			$fv_TemplateVars['callback'] = (! empty($this->callback) && file_exists($this->callback)) ? $this->callback  : "";

			$this->echoTemplate(MOLLY_SKIN_DIRECTORY . 'templates/' . $this->tagName . '.end.tplt', $fv_TemplateVars);
		}


	}
}


/* -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+----- */

	class maml_filelist extends prototype_tag {
		public $path='FilePath';
		public $extension;
//		public $filetype;
		public $dateformat='d F Y H:i:s';
	
	protected $doctext = <<<'DOCBLOCK'
<pre class="maml"><span class="sc2">&lt;maml:filelist path<span class="sy0">=</span><span class="st0">&quot;/unix/&quot;</span> extension<span class="sy0">=</span><span class="st0">&quot;jpg&quot;</span> filetype<span class="sy0">=</span><span class="st0">&quot;dir | file&quot;</span> dateformat<span class="sy0">=</span><span class="st0">&quot;d F Y H:i:s&quot;</span>&gt;</span></pre>

<p>The maml:filelist tag, together with the associated maml:filename, maml:fileroot, maml:filesize, maml:permissions, maml:filetype, maml:modtime, and maml:extension tags allow
you to gather and use information about all of the files in a specified directory. This can be to display a simple list, like the example below, or to build a file picker
widget like the one used in the config administration tool. The maml:filelist tag pair repeats its contents for each file found in the directory. Using the extension attribute you
can limit the results to one or more file types.</p>

<p><strong>Example:</strong></p>
<pre class="maml"><span class="sc2">&lt;table&gt;</span>
    <span class="sc2">&lt;tr&gt;</span>
        <span class="sc2">&lt;th&gt;</span>filename<span class="sc2">&lt;<span class="sy0">/</span>th&gt;</span>
        <span class="sc2">&lt;th&gt;</span>fileroot<span class="sc2">&lt;<span class="sy0">/</span>th&gt;</span>
        <span class="sc2">&lt;th&gt;</span>filesize<span class="sc2">&lt;<span class="sy0">/</span>th&gt;</span>
        <span class="sc2">&lt;th&gt;</span>permissions<span class="sc2">&lt;<span class="sy0">/</span>th&gt;</span>
        <span class="sc2">&lt;th&gt;</span>filetype<span class="sc2">&lt;<span class="sy0">/</span>th&gt;</span>
        <span class="sc2">&lt;th&gt;</span>modtime<span class="sc2">&lt;<span class="sy0">/</span>th&gt;</span>
        <span class="sc2">&lt;th&gt;</span>extension<span class="sc2">&lt;<span class="sy0">/</span>th&gt;</span>
        <span class="sc2">&lt;th&gt;</span>fmd5<span class="sc2">&lt;<span class="sy0">/</span>th&gt;</span>
    <span class="sc2">&lt;<span class="sy0">/</span>tr&gt;</span>
    <span class="sc2">&lt;maml:filelist path<span class="sy0">=</span><span class="st0">&quot;*[FileRoot]*decor/skins/*[Skin]*/images/&quot;</span> extension<span class="sy0">=</span><span class="st0">&quot;gif jpg&quot;</span>&gt;</span>
        <span class="sc2">&lt;tr&gt;</span>
            <span class="sc2">&lt;th&gt;&lt;maml:filename <span class="sy0">/</span>&gt;&lt;<span class="sy0">/</span>th&gt;</span>
            <span class="sc2">&lt;td&gt;&lt;maml:fileroot <span class="sy0">/</span>&gt;&lt;<span class="sy0">/</span>td&gt;</span>
            <span class="sc2">&lt;td&gt;&lt;maml:filesize <span class="sy0">/</span>&gt;&lt;<span class="sy0">/</span>td&gt;</span>
            <span class="sc2">&lt;td&gt;&lt;maml:permissions <span class="sy0">/</span>&gt;&lt;<span class="sy0">/</span>td&gt;</span>
            <span class="sc2">&lt;td&gt;&lt;maml:filetype <span class="sy0">/</span>&gt;&lt;<span class="sy0">/</span>td&gt;</span>
            <span class="sc2">&lt;td&gt;&lt;maml:modtime <span class="sy0">/</span>&gt;&lt;<span class="sy0">/</span>td&gt;</span>
            <span class="sc2">&lt;td&gt;&lt;maml:extension <span class="sy0">/</span>&gt;&lt;<span class="sy0">/</span>td&gt;</span>
            <span class="sc2">&lt;td&gt;&lt;maml:fmd5 <span class="sy0">/</span>&gt;&lt;<span class="sy0">/</span>td&gt;</span>
        <span class="sc2">&lt;<span class="sy0">/</span>tr&gt;</span>
    <span class="sc2">&lt;<span class="sy0">/</span>maml:filelist&gt;</span>
<span class="sc2">&lt;<span class="sy0">/</span>table&gt;</span>
&nbsp;</pre>

<p><strong>Results:</strong></p>
<table>
	<tr>
		<th>filename</th><th>fileroot</th><th>filesize</th><th>permissions</th><th>filetype</th><th>modtime</th><th>extension</th><th>fmd5</th>
	</tr>
	
		<tr>
			<th>img01.tplt.jpg</th> <td>img01.tplt</td> <td>22804</td> <td>-rwxr-xr-x</td> <td>file</td> <td>20 January 2012 08:41:27</td> <td>jpg</td> <td>205e395db585dedab3c6c12422111d27</td>
		</tr>
	
		<tr>
			<th>img03.tplt.jpg</th> <td>img03.tplt</td> <td>8372</td> <td>-rwxr-xr-x</td> <td>file</td> <td>09 October 2014 13:27:26</td> <td>jpg</td> <td>e7c86bfef9850ff1b8d614ce35856a06</td>
		</tr>
	
		<tr>
			<th>mxhead-dark.tplt.jpg</th> <td>mxhead-dark.tplt</td> <td>42069</td> <td>-rw-r--r--</td> <td>file</td> <td>10 October 2014 10:39:34</td> <td>jpg</td> <td>b82a050f3400dd02a6246d32694d4ad7</td>
		</tr>
	
		<tr>
			<th>mxhead-light.tplt.jpg</th> <td>mxhead-light.tplt</td> <td>59228</td> <td>-rwxr-xr-x</td> <td>file</td> <td>10 October 2014 10:35:12</td> <td>jpg</td> <td>ae41ec7d7ec40c7960d2318676c451fa</td>
		</tr>
	
		<tr>
			<th>mxhead.tplt.jpg</th> <td>mxhead.tplt</td> <td>44546</td> <td>-rw-r--r--</td> <td>file</td> <td>10 October 2014 10:38:28</td> <td>jpg</td> <td>90e23346a3da304281e7125a8aa22113</td>
		</tr>
	
		<tr>
			<th>test_pattern_green.gif</th> <td>test_pattern_green</td> <td>23881</td> <td>-rw-r--r--</td> <td>file</td> <td>19 January 2012 09:25:11</td> <td>gif</td> <td>053d9b94bc96ae204d37676498ccda7e</td>
		</tr>
	
		<tr>
			<th>tinymolly.jpg</th> <td>tinymolly</td> <td>5543</td> <td>-rwxr-xr-x</td> <td>file</td> <td>03 February 2011 14:12:37</td> <td>jpg</td> <td>cad47d5ce2943b34103ca8e68e80d495</td>
		</tr>
	
</table>


DOCBLOCK;
		
		public function begin() {
			global $gv_Config;
			
			if($this->path =='FilePath') {
				$this->path = $gv_Config['FileRoot'];
			}
			$this->path =  m_Interpolate($this->path,$gv_Config);
			$this->DirectoryHash = m_DirectoryList($this->path, $this->dateformat);
			
			foreach ($this->DirectoryHash as $fv_index => $fv_CurrentFileInfoHash) {
				if ($fv_CurrentFileInfoHash['filename']!=='.DS_Store') {
					$this->DirectoryHash[$fv_index]['fmd5'] = md5_file($this->path . $fv_CurrentFileInfoHash['filename']);
				}
			}
			foreach ($this->DirectoryHash as $fv_index => $fv_CurrentFileInfoHash) {
				if ($fv_CurrentFileInfoHash['filename']!=='.DS_Store') {
					$this->DirectoryHash[$fv_index]['sha1'] = sha1_file($this->path . $fv_CurrentFileInfoHash['filename']);
				}
			}
			$this->startCache();
		}
		
		public function end() {
			$this->finishCache();

			if($this->DirectoryHash) { // results not empty
				foreach ($this->DirectoryHash as $fv_RecordHash) {
					if ($this->extension) {
						if (!(strpos ($this->extension, $fv_RecordHash['extension'])===FALSE)) {
							echo m_Interpolate($this->tagCache, $fv_RecordHash);
						}
					} else {
						echo m_Interpolate($this->tagCache, $fv_RecordHash);
					}
				}
			} else {
				echo $this->empty;
			}
		}
	}


	class maml_filename extends prototype_tag {
		public $name;
	
		protected $doctext = <<<'DOCBLOCK'
<p><strong>Description:</strong> Used in conjunction with &lt;maml:filelist&gt; tag to retrieve a list of files from a directory.</p>
<p>Replaces itself with the name of the file for each file found.</p>
<p>Alternatively you may use the <strong>*<span>[filename]</span>*</strong> token, for example if you wish to include the filename in an attribute of another tag.</p>
<p>See &lt;maml:filelist&gt; tag for example usage.</p>
DOCBLOCK;

		public function begin() {
			echo '*[filename]*';
		}
		
	} // class maml_filename

	class maml_fileroot extends prototype_tag {
		public $name;
	
		protected $doctext = <<<'DOCBLOCK'
<p><strong>Description:</strong> Used in conjunction with &lt;maml:filelist&gt; tag to retrieve a list of files from a directory.</p>
<p>Replaces itself with the name of the file sans the extension for each file found.</p>
<p>Alternatively you may use the <strong>*<span>[fileroot]</span>*</strong> token, for example if you wish to include the fileroot in an attribute of another tag.</p>
<p>See &lt;maml:filelist&gt; tag for example usage.</p>
DOCBLOCK;

		public function begin() {
			echo '*[fileroot]*';
		}
		
	} // class maml_fileroot

	class maml_filesize extends prototype_tag {
		public $name;
	
		protected $doctext = <<<'DOCBLOCK'
<p><strong>Description:</strong> Used in conjunction with &lt;maml:filelist&gt; tag to retrieve a list of files from a directory.</p>
<p>Replaces itself with the filesize of the file for each file found.</p>
<p>Alternatively you may use the <strong>*<span>[filesize]</span>*</strong> token, for example if you wish to include the filesize in an attribute of another tag.</p>
<p>See &lt;maml:filelist&gt; tag for example usage.</p>
DOCBLOCK;

		public function begin() {
			echo '*[filesize]*';
		}
		
	} // class maml_filesize

	class maml_permissions extends prototype_tag {
		public $name;
	
		protected $doctext = <<<'DOCBLOCK'
<p><strong>Description:</strong> Used in conjunction with &lt;maml:filelist&gt; tag to retrieve a list of files from a directory.</p>
<p>Replaces itself with the unix-style permissions string of the file for each file found.</p>
<p>Alternatively you may use the <strong>*<span>[permissions]</span>*</strong> token, for example if you wish to include the permissions in an attribute of another tag.</p>
<p>See &lt;maml:filelist&gt; tag for example usage.</p>
DOCBLOCK;

		public function begin() {
			echo '*[permissions]*';
		}
		
	} // class maml_permissions

	class maml_filetype extends prototype_tag {
		public $name;
	
		protected $doctext = <<<'DOCBLOCK'
<p><strong>Description:</strong> Used in conjunction with &lt;maml:filelist&gt; tag to retrieve a list of files from a directory.</p>
<p>Replaces itself with the filetype of the file for each file found.</p>
<p>Alternatively you may use the <strong>*<span>[filetype]</span>*</strong> token, for example if you wish to include the filetype in an attribute of another tag.</p>
<p>See &lt;maml:filelist&gt; tag for example usage.</p>
DOCBLOCK;

		public function begin() {
			echo '*[filetype]*';
		}
		
	} // class maml_filetype

	class maml_modtime extends prototype_tag {
		public $name;
	
		protected $doctext = <<<'DOCBLOCK'
<p><strong>Description:</strong> Used in conjunction with &lt;maml:filelist&gt; tag to retrieve a list of files from a directory.</p>
<p>Replaces itself with the modtime of the file for each file found.</p>
<p>Alternatively you may use the <strong>*<span>[modtime]</span>*</strong> token, for example if you wish to include the modtime in an attribute of another tag.</p>
<p>See &lt;maml:filelist&gt; tag for example usage.</p>
DOCBLOCK;

		public function begin() {
			echo '*[modtime]*';
		}
		
	} // class maml_modtime

	class maml_extension extends prototype_tag {
		public $name;
	
		protected $doctext = <<<'DOCBLOCK'
<p><strong>Description:</strong> Used in conjunction with &lt;maml:filelist&gt; tag to retrieve a list of files from a directory.</p>
<p>Replaces itself with the extension of the file for each file found.</p>
<p>Alternatively you may use the <strong>*<span>[extension]</span>*</strong> token, for example if you wish to include the extension in an attribute of another tag.</p>
<p>See &lt;maml:filelist&gt; tag for example usage.</p>
DOCBLOCK;

		public function begin() {
			echo '*[extension]*';
		}
		
	} // class maml_extension

	class maml_fmd5 extends prototype_tag {
		public $name;
	
		protected $doctext = <<<'DOCBLOCK'
<p><strong>Description:</strong> Used in conjunction with &lt;maml:filelist&gt; tag to retrieve a list of files from a directory.</p>
<p>Replaces itself with the md5 hash of the file for each file found.</p>
<p>Alternatively you may use the <strong>*<span>[fmd5]</span>*</strong> token, for example if you wish to include the extension in an attribute of another tag.</p>
<p>See &lt;maml:filelist&gt; tag for example usage.</p>
DOCBLOCK;

		public function begin() {
			echo '*[fmd5]*';
		}
		
	} // class maml_fmd5


	class maml_sha1 extends prototype_tag {
		public $name;
	
		protected $doctext = <<<'DOCBLOCK'
<p><strong>Description:</strong> Used in conjunction with &lt;maml:filelist&gt; tag to retrieve a list of files from a directory.</p>
<p>Replaces itself with the md5 hash of the file for each file found.</p>
<p>Alternatively you may use the <strong>*<span>[fmd5]</span>*</strong> token, for example if you wish to include the extension in an attribute of another tag.</p>
<p>See &lt;maml:filelist&gt; tag for example usage.</p>
DOCBLOCK;

		public function begin() {
			echo '*[sha1]*';
		}
		
	} // class maml_sha1


?>