<?php
	class maml_windoid extends prototype_tag {
		public $title;
		public $showMsg;
		public $hideMsg;

		
		protected $doctext = <<<'DOCBLOCK'
<p><strong>Description:</strong> Creates a window-like box around whatever it encloses based on the 
windoid.begin.tplt and windoid.end.tplt template files, the default.css styles, and values in the config 
database table. The title attribute is displayed in the titlebar
of the windoid.</p>
<p>In previous versions of Molly this tag had additional attributes, some of which we may wish to re-create or re-think:</p>
<ul>
	<li>frameColor: colorspec</li>
	<li>frameLeft: thickness (i.e. 2px)</li>
	<li>frameRight: thickness</li>
	<li>frameTop: thickness</li>
	<li>frameBottom: thickness</li>
	<li>fieldColor: colorspec</li>
	<li>titleAlign [left|center|right]</li>
	<li>titleStyle:  any style spec valid for text</li>
	<li>backLink:  URL, relative or absolute</li>
	<li>titleColor: color of windoid title</li>
	<li>titleFontFamily: font family of title</li>
	<li>titleFontSize: size of title</li>
	<li>titleFontWeight: [bold|bolder|normal], etc.</li>
	<li>borderStyle: [solid|dotted|dashed], etc.</li>
	<li>background: add an image to windoid background</li>
	<li>dragable: can user move the windoid around the page?</li>
</ul>
DOCBLOCK;
		
		public function begin() {
			$fv_TemplateVars['id'] = $this->id;
			if (!isset($this->class)) {
				$this->class='windoid';
			}
			$fv_TemplateVars['class'] = $this->class;
			$fv_TemplateVars['style'] = $this->style;
			$fv_TemplateVars['title'] = $this->title;
			
			
			if(isset($this->showMsg) && strlen(trim($this->showMsg)) > 0){
				//add the script
				$fv_TemplateVars['showMsg'] = "<script type='text/javascript'> function ". $this->showMsg . " (message, isError){ var ele = document.getElementById('". $this->id . "msg'); if(ele){ ele.setAttribute('display', 'inline'); ele.className = (isError)? 'windoidError' : 'windoidMsg' ; ele.innerHTML  = message;}} </script>";				
			}
			
			if(isset($this->hideMsg) && strlen(trim($this->hideMsg)) > 0){
				//add the script
				$fv_TemplateVars['hideMsg'] = "<script type='text/javascript'> function ". $this->hideMsg."()  { var ele = document.getElementById('". $this->id . "msg'); if(ele){ele.innerHTML = '';  ele.className = 'windoidMsgHide';  }} </script>";				
			}
			/*elseif(isset($this->showMsg) && strlen(trim($this->showMsg))> 0){
			   $fv_TemplateVars['hideMsg'] = "<script type='text/javascript'> function ". $this->showMsg."Hide()" . " { var ele = document.getElementById('". $this->id . "msg'); if(ele){ele.innerHTML = ''; ele.className = 'windoidMsgHide';}} </script>";				
			}*/

						
			$this->echoTemplate(MOLLY_SKIN_DIRECTORY . 'templates/windoid.begin.tplt', $fv_TemplateVars);
		}
	
		public function end(){
//			$fv_TemplateVars = array();
			$fv_TemplateVars['id'] = $this->id;

			
			$this->echoTemplate(MOLLY_SKIN_DIRECTORY . 'templates/windoid.end.tplt', $fv_TemplateVars);
		}
	} // class maml_windoid

/* -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+----- */

	class maml_menu extends prototype_tag { // http://www.welie.com/patterns/
		public $type = 'tabs'; // Implemented: [tabs] Not Yet Implemented: [stack|accordion|breadcrumbs|doubletab|flydown|flyout|outline]
		protected $menuTypes = array('tabs','stack','horizontal');
		
		public function begin() {
			$fv_lctype =  strtolower($this->type);
			if (in_array($fv_lctype, $this->menuTypes)) { //check to see if it's a defined type
				$fv_TemplateVars['class'] = 'maml_' . $fv_lctype;
			} else {
				$fv_TemplateVars['class'] = 'maml_tabs';
			}
			
			if (isset($this->class)) {
				$fv_TemplateVars['class'] .= ' ' . $this->class;
			}
			
			$fv_TemplateVars['style'] = ' style="' . $this->style .'"';

			$this->echoTemplate(MOLLY_SKIN_DIRECTORY . 'templates/' . $fv_lctype . '.begin.tplt', $fv_TemplateVars);
			
			$fv_TheTemplate = $this->fetchTemplate(MOLLY_SKIN_DIRECTORY . 'templates/' . $fv_lctype . '.style.tplt');
			$fv_TheTemplate = m_Interpolate($fv_TheTemplate, $fv_TemplateVars);
			
			m_AppendStylesheet($fv_TheTemplate, 'tabs', FALSE);
		}
		
		public function end(){
			$fv_lctype =  strtolower($this->type);
			$this->echoTemplate(MOLLY_SKIN_DIRECTORY . 'templates/' . $fv_lctype . '.end.tplt', array());
		}

	}

	class maml_item extends prototype_tag {
//		public $state = 'unselected'; // [unselected|selected]
		public $href;
		public $target='_self';
		public $selected;

		public function begin() {
			global $gv_Config;
		
			$this->href =  m_Interpolate($this->href, $gv_Config); // replace path variables in src attribute
			$this->target =  m_Interpolate($this->target, $gv_Config); // replace path variables in src attribute

			/* Commented by Gaurav 
			// changed the way to get current page and linked page for comparing
			$fv_Pieces = explode('?', $this->href);
			$v_LinkedPage = str_replace($gv_Config["HTMLRoot"],'',$this->href);
			$v_CurrentPage = str_replace($gv_Config["FileRoot"],'',$_SERVER['SCRIPT_FILENAME']);
			*/
			$v_LinkedPagePart =  explode( "/", $this->href );
			$v_LinkedPagePart =  explode("?", $v_LinkedPagePart[count($v_LinkedPagePart) - 1]);
			$v_LinkedPage = $v_LinkedPagePart[0];
			$v_CurrentPage = substr($_SERVER["SCRIPT_NAME"],strrpos($_SERVER["SCRIPT_NAME"],"/")+1);
			
			echo "<!-- Current Page: $v_CurrentPage | Linked Page: $v_LinkedPage -->";
			if ($v_CurrentPage === $v_LinkedPage || isset($this->selected)) {
				$fv_TemplateVars['class'] = 'selected';
			} else {
				$fv_TemplateVars['class'] = 'unselected';			
			}
			$fv_TemplateVars['href']=$this->href;
			$fv_TemplateVars['target']=$this->target;

			
/*			$fv_TemplateVars['state'] = $this->state;*/
			$this->echoTemplate(MOLLY_SKIN_DIRECTORY . 'templates/item.begin.tplt', $fv_TemplateVars);
		}
		
		public function end(){
			$this->echoTemplate(MOLLY_SKIN_DIRECTORY . 'templates/item.end.tplt', array());
		}

	}

/* -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+----- */

	class maml_box extends prototype_tag {
		public $title;

		protected $doctext = <<<'DOCBLOCK'
<p><strong>Description:</strong> Creates a round-cornered box around whatever it encloses based on the 
box.top.tplt and box.bottom.tplt template files, the default.css styles, and values in the config 
database table. The optional title attribute is displayed at the top of the box. The box itself is created from
two image files (decor/rounded-left-template.png and decor/rounded-right-template.png) which are colorized using 
Molly&rsquo;s image colorizing code. <strong>It would be nice to add a color attribute to allow override of the default
color BoxFrameColor from the config database table.</strong></p>

DOCBLOCK;
	
		function begin(){
			$fv_TemplateVars['id'] = $this->id;
			if (!isset($this->class)) {
				$this->class='box';
			}
			$fv_TemplateVars['class'] = $this->class;
			$fv_TemplateVars['title'] = $this->title;
			$this->echoTemplate(MOLLY_SKIN_DIRECTORY . 'templates/box.top.tplt', $fv_TemplateVars);
		}
		
		function end(){
			$fv_TemplateVars['id'] = $this->id;
			$this->echoTemplate(MOLLY_SKIN_DIRECTORY . 'templates/box.bottom.tplt', $fv_TemplateVars);
		}
	}

/*
	class maml_box extends prototype_template_tag {
	
	}
*/
/* -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+----- */
	
	class maml_include extends prototype_tag {
		public $src;
		public $parse="maml"; //[maml|html|xml|off|none|false]
		public $debug;
		
		protected $doctext = <<<'DOCBLOCK'
<p><strong>Description:</strong> Reads the file specified in the src attribute and inserts it into the document. If parse="maml" then it is
processed as a MAML file as it is being inserted. If parse="html" then only the portion of the file
between the &lt;body&gt; and &lt;/body&gt; tags is included. If src is a URL instead of a filespec, then this tag
will fetch the file from the specified server. parse="xml" is not yet implemented.</p>
DOCBLOCK;

		public function begin(){
		
		}
		
		public function end(){
			global $gv_Config;
		
			$this->src =  m_Interpolate($this->src, $gv_Config); // replace path variables in src attribute
		
			// let's try and work this with template methods
			$this->fv_IncludeText=$this->fetchTemplate($this->src);
			
			//echo "ID=$this->id and STYLE=$this->style";
			
//			echo "<span id=\"$this->id\" style=\"$this->style\">"; //removed 1/15/2011 by rpv
			switch ($this->parse) {
				case "maml":
					global $gv_PageEnded;
					$gv_PageEnded = FALSE;
					m_PullParse('<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" xmlns:maml="http://interpersonalnet.com/maml/">' . $this->fv_IncludeText . '</html>');
					$gv_PageEnded = TRUE;
				break;
				
				case "html":
					echo m_NakedHTML ($this->src);
				break;
					
				case "xml":
					// yeah, I forgot what we were going to do with this.
				
					//$v_TheDocument = getDocument ($this->src);
					//echo transformXML ($v_TheDocument);
				break;
				
				default:
					echo $this->fv_IncludeText;
				break;
			}
			
//			echo "</span>"; //removed 1/15/2011 by rpv
		}
		
		
		
	}


/* -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+----- */
	
	
	class maml_img extends prototype_tag {
		// Create "non-downloadable" images, optionally add watermark and/or custom message
		// Also hides actual location of the image
		
		protected $doctext = <<<'DOCBLOCK'
<p><strong>Description:</strong> This is a placeholder for a future &lt;maml:image /&gt; tag with the 
following features:</p>
<ul>
	<li>"non-downloadable" images (i.e. no right-click saving)</li>
	<li>optionally add watermark and/or custom message to the image</li>
	<li>hides actual server location of the image from the user</li>
</ul>
DOCBLOCK;

		public function begin(){
			echo "&lt;maml:image /&gt;";
		}
	}



/* -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+----- */
	
//	<maml:multiple count="1" button="none|before|after|beforeeach|aftereach" label="Clone it!">	


	class maml_multiple extends prototype_tag {
		public $count = 1;
		public $button = 'after';
		public $label = 'Add Another';
		protected $button_positions;

		protected $doctext = <<<'DOCBLOCK'
<p><strong>Description:</strong> This tag allows the user to replicate whatever it encloses using client-side
(JavaScript/DOM) code. This is particularly useful inside a &lt;maml:form&gt; to allow the user to create several
records at once when submitting a form. (This is actually what it is designed for, but we opened it up to be
used outside fo forms to see what other uses we might find for it.)</p>
<ul>
	<li>count: Positive integer. How many times to automatically replicate the contents on the client side (default is 1).</li>
	<li>button: Where to position the button(s) that the user clicks to replicate the contents. May be one or more of the following:
	<br /><em>none, before, after, beforeeach, aftereach</em></li>
	<li>label: What text to label the button(s) with.  Default is "Add Another"</li>
</ul>
<p><strong>Button value placements:</strong></p>
<table>
	<tr>
		<th style="text-align:left; width:6em;">before</th> <td>Before the section to be duplicated.</td>
	</tr>
	<tr>
		<th style="text-align:left;">after</th> <td>After the section to be duplicated.</td>
	</tr>
	<tr>
		<th style="text-align:left;">beforeeach</th> <td>At the beginning of the section to be duplicated. (Gets duplicated along with section.)</td>
	</tr>
	<tr>
		<th style="text-align:left;">aftereach</th> <td>At the end of the section to be duplicated. (Gets duplicated along with section.)</td>
	</tr>
</table>
DOCBLOCK;
		
		function __construct(){
			$this->id=$this->id();
		}
		
		public function begin(){
			global $gv_SiteGlobals;
			$this->button_positions = $this->splitAttribute($this->button);
			if (in_array('none', $this->button_positions)){ // 'none' overrides all other settings
				$this->button_positions = array();
			}
		
			$fv_TheJavaScript = m_GetDocument ($gv_SiteGlobals['Paths']['HTMLRoot'] . 'utilities/scripts/maml.multiple.js.inc');
			m_AppendJavaScript($fv_TheJavaScript, 'm_Duplicate');

			$fv_TemplateVars['id'] = $this->id;
			$fv_TemplateVars['label'] = $this->label;
			if (in_array('before', $this->button_positions)){
				$this->echoTemplate(MOLLY_SKIN_DIRECTORY . 'templates/multiple.button.tplt', $fv_TemplateVars);			
			}

			$this->echoTemplate(MOLLY_SKIN_DIRECTORY . 'templates/multiple.begin.tplt', $fv_TemplateVars);
			if (in_array('beforeeach', $this->button_positions)){
				$this->echoTemplate(MOLLY_SKIN_DIRECTORY . 'templates/multiple.button.tplt', $fv_TemplateVars);			
			}
		
		}
		
		public function end(){
			$fv_TemplateVars['id'] = $this->id;
			$fv_TemplateVars['label'] = $this->label;

			if (in_array('aftereach', $this->button_positions)){
				$this->echoTemplate(MOLLY_SKIN_DIRECTORY . 'templates/multiple.button.tplt', $fv_TemplateVars);			
			}

			$this->echoTemplate(MOLLY_SKIN_DIRECTORY . 'templates/multiple.end.tplt', $fv_TemplateVars);			

			$this->echoTemplate(MOLLY_SKIN_DIRECTORY . 'templates/multiple.placement.tplt', $fv_TemplateVars);
			
			if (in_array('after', $this->button_positions)){
				$this->echoTemplate(MOLLY_SKIN_DIRECTORY . 'templates/multiple.button.tplt', $fv_TemplateVars);			
			}
			if ($this->count > 1) {
				$this->echoTemplate(MOLLY_SKIN_DIRECTORY . 'templates/multiple.auto.tplt', $fv_TemplateVars);				
			}
			
		}	
	
	
	}





?>