<?php
/*		Security		*/

	class maml_login extends prototype_tag {

		public $response = '*[HTMLRoot]*';
		public $fail = 'Invalid Login';
		public $title = '';
		public $logout;
		
		protected $tagName;
		
		function __construct() {
			$this->tagName = str_replace('maml_', '', get_class($this));
		}

		public function begin() {
			global $gv_LoggedIn;
			
			$fv_TemplateVars['id'] = $this->id;
			if (!isset($this->class)) {
				$this->class='molly';
			}
			$fv_TemplateVars['class'] = $this->class;
			$fv_TemplateVars['style'] = $this->style;
			$fv_TemplateVars['title'] = $this->title;
			$fv_TemplateVars['response'] = $this->response;
			
			if ($gv_LoggedIn) {
				$_SESSION['logout_destination'] = $this->logout;
				$this->echoTemplate(MOLLY_SKIN_DIRECTORY . 'templates/logout.begin.tplt', $fv_TemplateVars);
			} else {
				if (isset($_SESSION['login_status']) && $_SESSION['login_status'] == "FAIL") {
					$fv_TemplateVars['login_status'] = $this->fail;
					$_SESSION['tokens']['login_status'] = $this->fail;
					unset($_SESSION['login_status']);
				} else {
					$_SESSION['tokens']['login_status'] = '';
				}
				
				$this->echoTemplate(MOLLY_SKIN_DIRECTORY . 'templates/' . $this->tagName . '.begin.tplt', $fv_TemplateVars);
			}
		}

		public function end(){
			$fv_TemplateVars['id'] = $this->id;

			global $gv_LoggedIn;
			
			if ($gv_LoggedIn) {
				$this->echoTemplate(MOLLY_SKIN_DIRECTORY . 'templates/logout.end.tplt', $fv_TemplateVars);
			} else {
				$this->echoTemplate(MOLLY_SKIN_DIRECTORY . 'templates/' . $this->tagName . '.end.tplt', $fv_TemplateVars);
			}
		}

	
	}
	
	class maml_protect extends prototype_tag {
		//public $permitted='all';
		public $denied;

		protected $doctext = <<<'DOCBLOCK'
<p><strong>Description:</strong> The &lt;maml:protect&gt; tag allows one to restrict access to/viewability 
of a portion of page based on the user&rsquo;s membership in a group specified in the <strong>permitted</strong> attribute.
(These groups are represented in the molly_permissions table in the database.) The special group <em>all</em> allows all 
logged in users access, but not users who have not logged in (it represents, therefore, &ldquo;all registered users&rdquo;).
Another special group <em>guest</em> allows only users who are not logged in to see the content.</p>
<p>The optional <strong>denied</strong> attribute specifies a string to be used to replace the protected section of the page.
in the absence of the <strong>denied</strong> attribute the area will be left empty.
Due to how Molly parses the file, even PHP code within the tag should be prevented from executing if the user is not permitted.</p>
DOCBLOCK;
		
		public function precheck() {
			global $gv_stopParse;
			
			// Run prototype_tag's precheck for permitted attribute & check result
			parent::precheck();
			if($gv_stopParse != "" && $this->denied != null && $this->denied != "") {
				// Not allowed, echo denied message
				echo $this->denied;
			}
		}
		
		public function begin() {
			// This tag is now a proxy for precheck in prototype_tag
			
			//$this->startCache();
		}
		
		public function end() {
			/*$this->finishCache();
			if(m_permitted($this->permitted)) { // user is allowed to see
				echo $this->tagCache;
			} else {
				if ($this->permitted=="guest" and !isset($_SESSION['s_UserID'])) {
					echo $this->tagCache;
				} else {
					echo $this->denied;
				}
			}*/
		
		}
	}


?>