<?php

/*
	Brings in core functionality for Molly
	Version 9 Revision 0 Development 2
	Copyright 2009-2011 by Ronald P. Vullo, Ph.D. 
	
	DO NOT EDIT THIS FILE (unless you really know what you're doing)
	Configure with molly.ini

*/

//ini_set ( "memory_limit", "20M");

$gv_CurrentFile = basename($_SERVER["PHP_SELF"]); // File to which this loader.php has been prepended
$gv_CurrentFilePathInfo = pathinfo($gv_CurrentFile);
$gv_CurrentFileExtension = strtolower($gv_CurrentFilePathInfo['extension']);
$gv_MollySystemDirectory = pathinfo(__FILE__); // this loader.php file
$gv_MollySystemDirectory = $gv_MollySystemDirectory['dirname'] . '/';


if (isset($_SERVER['MOLLY_INI'])) {
	if($_SERVER['MOLLY_INI'][0] == '/') {
		$gv_SiteGlobals = parse_ini_file($_SERVER['MOLLY_INI'], true);
	} else {
		$gv_SiteGlobals = parse_ini_file($gv_MollySystemDirectory . $_SERVER['MOLLY_INI'], true);
	}
} else {
	$gv_SiteGlobals = parse_ini_file($gv_MollySystemDirectory . 'molly.ini', true);
}


// Check if HTTPS is enabled - requires certificate and server configuration
if (strtolower($gv_SiteGlobals['Site']['Secure']) == 'on') {
	if($_SERVER['HTTPS']!="on"){
		$redirect= "https://".$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
		header("Location:$redirect");
	}
}

if ($gv_CurrentFileExtension == 'php') { // Not a Molly File so get out of the way
	// Clean up before continuing with normal script operation
	unset($gv_CurrentFile);
	unset($gv_CurrentFilePathInfo);
	unset($gv_MollySystemDirectory);
//	unset($gv_CurrentFileExtension);
//	unset($gv_MollyINI);
	
} else { // This is a Molly File
	function m_Interpolate($template, $hash, $prefix = '*[', $postfix = ']*') {/* New Template Functionality without eval */
		global $gv_TokenVariables;
		
		if ($gv_TokenVariables) {
			$hash=array_merge($gv_TokenVariables, $hash);
		}
		$tmp = array();
		
		foreach($hash as $k => $v) {
			$tmp[$prefix . $k . $postfix] = $v;
		}
	
		return str_replace(array_keys($tmp), array_values($tmp), $template);
	} // m_Interpolate

	function m_ParentDir($pv_Path) {
		$fv_Path=pathinfo($pv_Path);
		return $fv_Path['dirname'] . '/';
	} // m_ParentDir
	
	
	function m_AutoInclude($pv_PathToIncludesDirectory, $pv_FileExtension){
		$fv_CoreDirectory = opendir($pv_PathToIncludesDirectory);
		$fv_IncludeList = array();
		while ($fv_FileName = readdir($fv_CoreDirectory)) {
			if (!($fv_FileName=="."||$fv_FileName=="..") && is_file($pv_PathToIncludesDirectory . $fv_FileName)){
				$fv_CurrentFilePathInfo = pathinfo($pv_PathToIncludesDirectory . $fv_FileName);
				$fv_CurrentFileExtension = strtolower($fv_CurrentFilePathInfo['extension']);
				if ($fv_CurrentFileExtension == $pv_FileExtension) {
//					echo $pv_PathToIncludesDirectory . $fv_FileName . '<br />';
//					include ($pv_PathToIncludesDirectory . $fv_FileName);
					$fv_IncludeList[] = $pv_PathToIncludesDirectory . $fv_FileName;
				}
			} 
		}
		closedir($fv_CoreDirectory);
		sort($fv_IncludeList);
		foreach ($fv_IncludeList as $fv_IncludeFile) {
//			echo $fv_IncludeFile . '<br />';
			include($fv_IncludeFile);
		}
	} 
	

	// Set up some constants and unset the temporary globals used while checking for this being a PHP file
	define ('MOLLY_SYSTEM_DIRECTORY',$gv_MollySystemDirectory);
	unset($gv_MollySystemDirectory);
//	unset($gv_MollyINI);

	$gv_IDNum=0; //initialize unique IDs

	//$gv_CurrentFileExtension = strtolower($gv_CurrentFilePathInfo['extension']);
	$gv_CurrentQueryString = $_SERVER['QUERY_STRING'];

	global $gv_Config, $gv_TokenVariables;
	// Load Config Values
	$gv_Config = array();
	$gv_TokenVariables = array();
	$gv_Config['BackgroundColor'] = 'FF0000'; // for debugging - if config table doesn't load from database, background color is red as a warning
	$gv_Config['HTMLRoot'] = $gv_SiteGlobals['Paths']['HTMLRoot'];
	$gv_Config['FormHandler'] = $gv_SiteGlobals['Paths']['FormHandler'];
	$gv_Config['SystemFileRoot'] = MOLLY_SYSTEM_DIRECTORY;
	$gv_Config['SkinDirectory'] = $gv_SiteGlobals['Paths']['SkinDirectory'];
	$gv_Config['Skin'] = $gv_SiteGlobals['Site']['Skin'];
	$gv_Config['SystemRoot'] = $gv_SiteGlobals['Paths']['SystemRoot'];
	$gv_Config['FileRoot'] = $gv_SiteGlobals['Paths']['FileRoot'];
	$gv_Config['AttachmentsDirectory'] = $gv_SiteGlobals['Paths']['AttachmentsDirectory'];
	$gv_Config['QueryString'] = $gv_CurrentQueryString;
	define ('MOLLY_SKIN_DIRECTORY',($gv_Config['FileRoot'] . $gv_Config['SkinDirectory'] . $gv_Config['Skin'] . '/'));
	$gv_Config['SkinScripts'] =  m_Interpolate(file_get_contents(MOLLY_SKIN_DIRECTORY .'/main.js.htmf'),$gv_Config);
	$gv_Config['stylesheet'] = '';
	$gv_StyleList = array();
	$gv_Config['javascript'] = '';
	$gv_JavaScriptList = array();

	// Include Molly's Core Functionality
	m_AutoInclude(MOLLY_SYSTEM_DIRECTORY . 'core/', 'inc');
	
	// Session vars
	if(!isset($_SESSION['tokens']) || !is_array($_SESSION['tokens'])) {
		$_SESSION['tokens'] = array();
	}
	$_SESSION['tokens']['ConfigTable'] = $gv_SiteGlobals['Config']['ConfigTableName'];
	
	$gv_ConfigResults = m_FetchDBHash('select * from ' . $gv_SiteGlobals['Config']['ConfigTableName'], $gv_SiteGlobals['Config']['ConfigDBHost'], $gv_SiteGlobals['Config']['ConfigDBUserName'], $gv_SiteGlobals['Config']['ConfigDBPassword'], $gv_SiteGlobals['Config']['ConfigDatabase']);
	foreach ($gv_ConfigResults as $gv_ConfigRecord) {
		$gv_Setting = $gv_ConfigRecord['setting'];
		$gv_Config[$gv_Setting] = $gv_ConfigRecord['value'];
	}
	$gv_Config['CurrentYear'] =  strftime('%Y');

	unset($gv_ConfigResults);
	unset($gv_ConfigRecord);
	unset($gv_Setting);

	/*	Set up a global so we can check if someone is logged in and add user info to interpolated values array */
	
	global $gv_LoggedIn;
	
	if (isset($_SESSION['s_UserID'])) {
		$gv_LoggedIn = TRUE;
	} else {
		$gv_LoggedIn = FALSE;
	}
	
	
	ob_start(); // Start buffering the output so that Molly can parse it

	switch ($gv_CurrentFileExtension) {
	
		case 'maml':
		case 'html':
		// make token variables available to templating calls
		// Do GETs first so users can't override POSTS, and SESSIONS last so they are hardest to override
		// Only t_ molly tokens are allowed, i.e. *[t_Link]*
		foreach ($_GET as $gv_TokenKey=>$gv_TokenVal) {
			if (substr ($gv_TokenKey, 0, 2) == 't_') {
				$gv_TokenVariables[$gv_TokenKey]=$gv_TokenVal;
			}
		}
		foreach ($_POST as $gv_TokenKey=>$gv_TokenVal) {
			if (substr ($gv_TokenKey, 0, 2) == 't_') {
				$gv_TokenVariables[$gv_TokenKey]=$gv_TokenVal;
			}
		}
		foreach ($_SESSION as $gv_TokenKey=>$gv_TokenVal) {
			if (substr ($gv_TokenKey, 0, 2) == 's_') {
				$gv_TokenVariables[$gv_TokenKey]=$gv_TokenVal;
			}
		}
		// Convert all Token IDs to integers to thwart SQL Injection
		if (isset($gv_TokenVariables['t_Link'])){ // t_Link is used as a generic link ID by Molly Forms
			$gv_TokenVariables['t_Link'] = intval($gv_TokenVariables['t_Link']);
		}
		foreach ($gv_TokenVariables as $gv_TokenKey=>$gv_TokenVal) {
			if (strtoupper (substr ($gv_TokenKey, -2)) == 'ID') { // if last two characters of token indicate it's an ID
				$gv_TokenVariables[$gv_TokenKey] = intval($gv_TokenVariables[$gv_TokenKey]);
			}
		}
		unset($gv_TokenKey);
		unset($gv_TokenVal);



		break;
	
	
		case 'css':
			header('Content-type: text/css');			
		break;

		
		case 'inc': // don't let these files get served to the web
			header ("Location:{$gv_SiteGlobals['Paths']['HTMLRoot']}{$gv_SiteGlobals['Paths']['ErrorDir']}404.maml");
		break;
	
	
		case 'tplt': // don't let these files get served to the web
			header ("Location:{$gv_SiteGlobals['Paths']['HTMLRoot']}{$gv_SiteGlobals['Paths']['ErrorDir']}404.maml");		
		break;
	
	
		case 'ini': // don't let these files get served to the web
			header ("Location:{$gv_SiteGlobals['Paths']['HTMLRoot']}{$gv_SiteGlobals['Paths']['ErrorDir']}404.maml");
		break;
	
	
		default:
		
		break;
	
	}	
		
	
} // end Check for plain PHP files

?>