SET SQL_MODE="NO_AUTO_VALUE_ON_ZERO";
SET time_zone = "+00:00";

--
-- Database: `molly`
--
-- Version: 19
-- Revision: 5.22

-- --------------------------------------------------------

--
-- Table structure for table `molly_blocks`
--

CREATE TABLE IF NOT EXISTS `molly_blocks` (
  `block_id` varchar(255) NOT NULL DEFAULT 'index.maml_0',
  `type` varchar(40) NOT NULL,
  `contents` text,
  `language` varchar(6) NOT NULL DEFAULT 'en',
  PRIMARY KEY (`block_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `molly_blocks`
--

INSERT INTO `molly_blocks` (`block_id`, `type`, `contents`, `language`) VALUES('index.maml_1', 'block', '<p>This page has a &lt;maml:block&gt; on it and has been edited, so there is now a record in the molly_blocks table in the database with the edited text that is rendered in place of the default placeholder text (below).</p>\r\n<div class="anyipsum-output">\r\n<p>Bacon ipsum dolor amet chuck salami corned beef t-bone pork belly venison, strip steak chicken ham pork chop. Sausage beef brisket, pork chop kielbasa spare ribs boudin kevin tongue alcatra chicken bresaola. Doner meatball rump, t-bone leberkas pork porchetta corned beef filet mignon salami sausage. Tri-tip kielbasa doner, pork belly frankfurter strip steak pork cupim beef ham hock flank tenderloin alcatra turkey bresaola. Bacon meatball filet mignon, prosciutto hamburger kielbasa salami strip steak pork belly meatloaf bresaola andouille fatback chicken brisket. Bresaola capicola kevin, shoulder short ribs cow porchetta cupim ground round turducken beef ribs.</p>\r\n<p>Capicola alcatra pastrami, rump frankfurter cow short ribs sirloin pork loin ground round ball tip turkey meatball tenderloin. Picanha biltong pork short ribs tail shankle filet mignon, ham hock t-bone capicola brisket venison. Leberkas shank tenderloin, ham cupim short ribs frankfurter alcatra porchetta pork ribeye shoulder chicken beef ribs. Landjaeger tri-tip burgdoggen venison t-bone prosciutto shoulder frankfurter leberkas porchetta. Venison tongue ground round burgdoggen chicken salami doner, filet mignon chuck jerky.</p>\r\n</div>', 'en');
INSERT INTO `molly_blocks` (`block_id`, `type`, `contents`, `language`) VALUES('faq.maml_1', 'block', '<dl> \r\n	<dt>What are the operating requirements for running Molly?</dt>\r\n	<dd>Molly has been tested successfully against the following:\r\n		<div style="padding-left:3em;">\r\n			<ul>\r\n				<li>Debian 8, 9</li>\r\n				<li>CentOS 6, 7</li>\r\n				<li>Windows Server 2016</li>\r\n				<li>Apache</li>\r\n				<li>Nginx w/ PHP-FPM</li>\r\n				<li>XAMPP (on Windows Server)</li>\r\n				<li>IIS (Windows Server)</li>\r\n				<li>MySQL</li>\r\n				<li>MariaDB 10 (approximately equivalent to MySQL 8)</li>\r\n				<li>PHP 5.3, 5.6, 7.2</li>\r\n			</ul>\r\n		</div>\r\n		Standard installation of Molly requires configuration via Apache''s .htaccess mechanism, however experienced web developers can use alternate configuration techniques.\r\n	</dd>\r\n	<dt>Is there an installer for Molly?</dt>\r\n	<dd>Yes, we now include a new installer script: install.php. Installation is relatively simple without an installer as well, as explained in the <a href="*[HTMLRoot]*docs/#installing" target="_blank">Webmaster Manual</a>.</dd>\r\n	\r\n	<dt>Is Molly still used used in Health Care?</dt>\r\n	<dd>Molly is currently being used in <a href="https://www.nih.gov" target="_blank">National Institutes of Health (NIH)</a> grant-supported development of <a href="http://cbl.rit.edu" target="_blank">online learning materials</a>.</dd>\r\n	\r\n	<dt>Can I use Molly to build commercial sites?</dt>\r\n	<dd>Yes. Molly is open source and free and has no restrictions on use.</dd>\r\n	\r\n	<dt>Can I pay you to build and/or support a Molly site?</dt>\r\n	<dd>Yes. Dr. Vullo is available on a consulting basis. He also often has student workers available as well.</dd>\r\n	<dt></dt>\r\n	<dd></dd>\r\n</dl>\r\n', 'en');

-- --------------------------------------------------------

--
-- Table structure for table `molly_config`
--

CREATE TABLE IF NOT EXISTS `molly_config` (
  `configid` mediumint(9) NOT NULL AUTO_INCREMENT,
  `description` varchar(255) NOT NULL DEFAULT '',
  `setting` varchar(255) NOT NULL DEFAULT '',
  `value` varchar(255) DEFAULT NULL,
  `whichpicker` varchar(255) DEFAULT 'color',
  PRIMARY KEY (`configid`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=33 ;

--
-- Dumping data for table `molly_config`
--

INSERT INTO `molly_config` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(1, 'Web Site Name', 'SiteName', 'Molly', 'text');
INSERT INTO `molly_config` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(2, 'Tab Background Color - Hover', 'TabColorHover', 'e8e8a7', 'color');
INSERT INTO `molly_config` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(3, 'Tab Background Color - Selected', 'SelectedTabColor', 'CFD0F0', 'color');
INSERT INTO `molly_config` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(4, 'Tab Background Color - Unselected', 'UnselectedTabColor', '9194e1', 'color');
INSERT INTO `molly_config` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(5, 'Text Color', 'TextColor', '212121', 'color');
INSERT INTO `molly_config` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(6, 'Link Color', 'LinkColor', '0000EE', 'color');
INSERT INTO `molly_config` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(7, 'Visited Link Color', 'VisitedLinkColor', '33271b', 'color');
INSERT INTO `molly_config` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(8, 'Form Dark Area Color', 'FormDark', 'BBC0D0', 'color');
INSERT INTO `molly_config` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(9, 'Form Medium Area Color', 'FormMedium', 'b9bbe5', 'color');
INSERT INTO `molly_config` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(10, 'Form Light Area Color', 'FormLight', 'FFFFFF', 'color');
INSERT INTO `molly_config` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(11, 'Menu Windoid Text Color', 'MenuTextColor', 'FFFFFF', 'color');
INSERT INTO `molly_config` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(12, 'Page Background Color', 'PageColor', 'FFFFFF', 'color');
INSERT INTO `molly_config` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(13, 'Menu Windoid Frame Color', 'MenuColor', '494978', 'color');
INSERT INTO `molly_config` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(14, 'Active Link Color', 'ActiveLinkColor', 'b5b5e2', 'color');
INSERT INTO `molly_config` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(15, 'Menu Rollover Background Color', 'MenuRolloverBackgroundColor', '6d85a3', 'color');
INSERT INTO `molly_config` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(16, 'Menu Rollover Text Color', 'MenuRolloverTextColor', 'FFFFFF', 'color');
INSERT INTO `molly_config` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(17, 'Menu Selected Background Color was 3D3D67', 'MenuSelectedBackgroundColor', '6d85a3', 'color');
INSERT INTO `molly_config` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(18, 'Box default frame color', 'BoxFrameColor', '7679ad', 'color');
INSERT INTO `molly_config` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(19, 'If there''s a tagline/motto for your site, it goes here.', 'tagline', 'Dynamic web site architecture &amp; content management', 'color');
INSERT INTO `molly_config` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(20, 'Copyright Notice', 'copyright', '<a href="https://molly.rit.edu/" target="_blank">Molly Web Framework</a> &copy; 2000-*[CurrentYear]* by Ronald P. Vullo, Ph.D. All Rights Reserved', 'text');
INSERT INTO `molly_config` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(21, 'Page Background Color', 'BackgroundColor', '06061f', 'color');
INSERT INTO `molly_config` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(22, 'Color of link on mouse hover', 'HoverLinkColor', '393939', 'color');
INSERT INTO `molly_config` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(23, 'Menu Text Color', 'MenuLinkColor', 'FFFFFF', 'color');
INSERT INTO `molly_config` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(24, 'Sidebar Heading Background Color', 'SidebarHeadingBackgroundColor', '3D3D67', 'color');
INSERT INTO `molly_config` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(25, 'Sidebar Heading Text Color', 'SidebarHeadingTextColor', 'FFFFFF', 'color');
INSERT INTO `molly_config` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(26, 'Sidebar Link Color', 'SidebarLinkColor', '232F01', 'color');
INSERT INTO `molly_config` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(27, 'Background image for the site', 'BackgroundImage', 'background_image.tplt.jpg', 'image');
INSERT INTO `molly_config` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(28, 'Windoid Field Color', 'WindoidFieldColor', 'f6f6ff', 'color');
INSERT INTO `molly_config` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(29, 'Windoid Frame Color', 'WindoidFrameColor', '0A0F61', 'color');
INSERT INTO `molly_config` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(30, 'Selected Menu Item Text Color', 'MenuSelectedTextColor', 'FFFFFF', 'color');
INSERT INTO `molly_config` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(31, '[DO NOT EDIT] Last run of web cron (Unix Time)', 'WebCronLastRun', '1531592936', 'none');
INSERT INTO `molly_config` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(32, 'Site logo', 'SiteLogo', 'logo_1.gif', 'image');

-- --------------------------------------------------------

--
-- Table structure for table `molly_config_green`
--

CREATE TABLE IF NOT EXISTS `molly_config_green` (
  `configid` mediumint(9) NOT NULL AUTO_INCREMENT,
  `description` varchar(255) NOT NULL DEFAULT '',
  `setting` varchar(255) NOT NULL DEFAULT '',
  `value` varchar(255) DEFAULT NULL,
  `whichpicker` varchar(255) DEFAULT 'color',
  PRIMARY KEY (`configid`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=33 ;

--
-- Dumping data for table `molly_config_green`
--

INSERT INTO `molly_config_green` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(1, 'Web Site Name', 'SiteName', 'Molly', 'text');
INSERT INTO `molly_config_green` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(2, 'Tab Background Color - Hover', 'TabColorHover', 'e8e8a7', 'color');
INSERT INTO `molly_config_green` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(3, 'Tab Background Color - Selected', 'SelectedTabColor', 'CFF0D0', 'color');
INSERT INTO `molly_config_green` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(4, 'Tab Background Color -Unselected', 'UnselectedTabColor', '85ce88', 'color');
INSERT INTO `molly_config_green` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(5, 'Text Color', 'TextColor', '212121', 'color');
INSERT INTO `molly_config_green` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(6, 'Link Color', 'LinkColor', '0000EE', 'color');
INSERT INTO `molly_config_green` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(7, 'Visited Link Color', 'VisitedLinkColor', '33271b', 'color');
INSERT INTO `molly_config_green` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(8, 'Form Dark Area Color', 'FormDark', '497849', 'color');
INSERT INTO `molly_config_green` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(9, 'Form Medium Area Color', 'FormMedium', 'bde2bd', 'color');
INSERT INTO `molly_config_green` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(10, 'Form Light Area Color', 'FormLight', 'F1FFED', 'color');
INSERT INTO `molly_config_green` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(11, 'Menu Windoid Text Color', 'MenuTextColor', 'FFFFFF', 'color');
INSERT INTO `molly_config_green` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(12, 'Page Background Color', 'PageColor', 'FFFFFF', 'color');
INSERT INTO `molly_config_green` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(13, 'Menu Windoid Frame Color', 'MenuColor', '497849', 'color');
INSERT INTO `molly_config_green` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(14, 'Active Link Color', 'ActiveLinkColor', 'FF33CC', 'color');
INSERT INTO `molly_config_green` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(15, 'Menu Rollover Background Color', 'MenuRolloverBackgroundColor', '3D673D', 'color');
INSERT INTO `molly_config_green` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(16, 'Menu Rollover Text Color', 'MenuRolloverTextColor', 'ffffff', 'color');
INSERT INTO `molly_config_green` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(17, 'Menu Selected Background Color', 'MenuSelectedBackgroundColor', '6da385', 'color');
INSERT INTO `molly_config_green` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(18, 'Box default frame color', 'BoxFrameColor', '7679ad', 'color');
INSERT INTO `molly_config_green` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(19, 'If there''s a tagline/motto for your site, it goes here.', 'tagline', 'Dynamic web site architecture &amp; content management', 'color');
INSERT INTO `molly_config_green` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(20, 'Copyright Notice', 'copyright', '<a href="https://molly.rit.edu/" target="_blank">Molly Web Framework</a> &copy; 2000-*[CurrentYear]* by Ronald P. Vullo, Ph.D. All Rights Reserved', 'text');
INSERT INTO `molly_config_green` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(21, 'Page Background Color', 'BackgroundColor', '061f06', 'color');
INSERT INTO `molly_config_green` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(22, 'Color of link on mouse hover', 'HoverLinkColor', '393939', 'color');
INSERT INTO `molly_config_green` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(23, 'Menu Text Color', 'MenuLinkColor', 'FFFFFF', 'color');
INSERT INTO `molly_config_green` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(24, 'Sidebar Heading Background Color', 'SidebarHeadingBackgroundColor', '3D673D', 'color');
INSERT INTO `molly_config_green` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(25, 'Sidebar Heading Text Color', 'SidebarHeadingTextColor', 'FFFFFF', 'color');
INSERT INTO `molly_config_green` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(26, 'Sidebar Link Color', 'SidebarLinkColor', '23012F', 'color');
INSERT INTO `molly_config_green` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(27, 'Background image for the site', 'BackgroundImage', 'background_image.tplt.jpg', 'image');
INSERT INTO `molly_config_green` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(28, 'Windoid Field Color', 'WindoidFieldColor', 'F1FFED', 'color');
INSERT INTO `molly_config_green` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(29, 'Windoid Frame Color', 'WindoidFrameColor', 'A1CCA1', 'color');
INSERT INTO `molly_config_green` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(30, 'Selected Menu Item Text Color', 'MenuSelectedTextColor', 'FFFFFF', 'color');
INSERT INTO `molly_config_green` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(31, '[DO NOT EDIT] Last run of web cron (Unix Time)', 'WebCronLastRun', '1531587730', 'none');
INSERT INTO `molly_config_green` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(32, 'Site logo', 'SiteLogo', 'logo_1.gif', 'image');

-- --------------------------------------------------------

--
-- Table structure for table `molly_config_grey`
--

CREATE TABLE IF NOT EXISTS `molly_config_grey` (
  `configid` mediumint(9) NOT NULL AUTO_INCREMENT,
  `description` varchar(255) NOT NULL DEFAULT '',
  `setting` varchar(255) NOT NULL DEFAULT '',
  `value` varchar(255) DEFAULT NULL,
  `whichpicker` varchar(255) DEFAULT 'color',
  PRIMARY KEY (`configid`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=33 ;

--
-- Dumping data for table `molly_config_grey`
--

INSERT INTO `molly_config_grey` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(1, 'Web Site Name', 'SiteName', 'Molly', 'text');
INSERT INTO `molly_config_grey` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(2, 'Tab Background Color - Hover', 'TabColorHover', 'e8e8e8', 'color');
INSERT INTO `molly_config_grey` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(3, 'Tab Background Color - Selected', 'SelectedTabColor', 'f0f0f0', 'color');
INSERT INTO `molly_config_grey` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(4, 'Tab Background Color - Unselected', 'UnselectedTabColor', 'e0e0e0', 'color');
INSERT INTO `molly_config_grey` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(5, 'Text Color', 'TextColor', '212121', 'color');
INSERT INTO `molly_config_grey` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(6, 'Link Color', 'LinkColor', '303030', 'color');
INSERT INTO `molly_config_grey` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(7, 'Visited Link Color', 'VisitedLinkColor', '333333', 'color');
INSERT INTO `molly_config_grey` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(8, 'Form Dark Area Color', 'FormDark', '3e3e3e', 'color');
INSERT INTO `molly_config_grey` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(9, 'Form Medium Area Color', 'FormMedium', 'aeaeae', 'color');
INSERT INTO `molly_config_grey` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(10, 'Form Light Area Color', 'FormLight', 'FFFFFF', 'color');
INSERT INTO `molly_config_grey` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(11, 'Menu Windoid Text Color', 'MenuTextColor', 'FFFFFF', 'color');
INSERT INTO `molly_config_grey` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(12, 'Page Background Color', 'PageColor', 'FFFFFF', 'color');
INSERT INTO `molly_config_grey` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(13, 'Menu Windoid Frame Color', 'MenuColor', '686868', 'color');
INSERT INTO `molly_config_grey` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(14, 'Active Link Color', 'ActiveLinkColor', 'c1c1c1', 'color');
INSERT INTO `molly_config_grey` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(15, 'Menu Rollover Background Color', 'MenuRolloverBackgroundColor', '929292', 'color');
INSERT INTO `molly_config_grey` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(16, 'Menu Rollover Text Color', 'MenuRolloverTextColor', 'FFFFFF', 'color');
INSERT INTO `molly_config_grey` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(17, 'Menu Selected Background Color was 3D3D67', 'MenuSelectedBackgroundColor', '858585', 'color');
INSERT INTO `molly_config_grey` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(18, 'Box default frame color', 'BoxFrameColor', '969696', 'color');
INSERT INTO `molly_config_grey` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(19, 'If there''s a tagline/motto for your site, it goes here.', 'tagline', 'Dynamic web site architecture &amp; content management', 'color');
INSERT INTO `molly_config_grey` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(20, 'Copyright Notice', 'copyright', '<a href="https://molly.rit.edu/" target="_blank">Molly Web Framework</a> &copy; 2000-*[CurrentYear]* by Ronald P. Vullo, Ph.D. All Rights Reserved', 'text');
INSERT INTO `molly_config_grey` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(21, 'Page Background Color', 'BackgroundColor', '1f1f1f', 'color');
INSERT INTO `molly_config_grey` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(22, 'Color of link on mouse hover', 'HoverLinkColor', '393939', 'color');
INSERT INTO `molly_config_grey` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(23, 'Menu Text Color', 'MenuLinkColor', 'FFFFFF', 'color');
INSERT INTO `molly_config_grey` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(24, 'Sidebar Heading Background Color', 'SidebarHeadingBackgroundColor', '4c4c4c', 'color');
INSERT INTO `molly_config_grey` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(25, 'Sidebar Heading Text Color', 'SidebarHeadingTextColor', 'FFFFFF', 'color');
INSERT INTO `molly_config_grey` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(26, 'Sidebar Link Color', 'SidebarLinkColor', '2e2e2e', 'color');
INSERT INTO `molly_config_grey` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(27, 'Background image for the site', 'BackgroundImage', 'background_image.tplt.jpg', 'image');
INSERT INTO `molly_config_grey` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(28, 'Windoid Field Color', 'WindoidFieldColor', 'f7f7f7', 'color');
INSERT INTO `molly_config_grey` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(29, 'Windoid Frame Color', 'WindoidFrameColor', '373737', 'color');
INSERT INTO `molly_config_grey` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(30, 'Selected Menu Item Text Color', 'MenuSelectedTextColor', 'FFFFFF', 'color');
INSERT INTO `molly_config_grey` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(31, '[DO NOT EDIT] Last run of web cron (Unix Time)', 'WebCronLastRun', '1531592329', 'none');
INSERT INTO `molly_config_grey` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(32, 'Site logo', 'SiteLogo', 'logo_1.gif', 'image');

-- --------------------------------------------------------

--
-- Table structure for table `molly_config_purple`
--

CREATE TABLE IF NOT EXISTS `molly_config_purple` (
  `configid` mediumint(9) NOT NULL AUTO_INCREMENT,
  `description` varchar(255) NOT NULL DEFAULT '',
  `setting` varchar(255) NOT NULL DEFAULT '',
  `value` varchar(255) DEFAULT NULL,
  `whichpicker` varchar(255) DEFAULT 'color',
  PRIMARY KEY (`configid`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=74 ;

--
-- Dumping data for table `molly_config_purple`
--

INSERT INTO `molly_config_purple` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(1, 'Web Site Name', 'SiteName', 'Molly', 'text');
INSERT INTO `molly_config_purple` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(2, 'Tab Background Color - Hover', 'TabColorHover', 'e8e8a7', 'color');
INSERT INTO `molly_config_purple` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(3, 'Tab Background Color - Selected', 'SelectedTabColor', 'E3D2F2', 'color');
INSERT INTO `molly_config_purple` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(4, 'Tab Background Color - Unselected', 'UnselectedTabColor', 'bb90e0', 'color');
INSERT INTO `molly_config_purple` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(5, 'Text Color', 'TextColor', '212121', 'color');
INSERT INTO `molly_config_purple` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(6, 'Link Color', 'LinkColor', '0000EE', 'color');
INSERT INTO `molly_config_purple` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(7, 'Visited Link Color', 'VisitedLinkColor', '33271b', 'color');
INSERT INTO `molly_config_purple` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(8, 'Form Dark Area Color', 'FormDark', '713E77', 'color');
INSERT INTO `molly_config_purple` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(9, 'Form Medium Area Color', 'FormMedium', 'DEB9E5', 'color');
INSERT INTO `molly_config_purple` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(10, 'Form Light Area Color', 'FormLight', 'FCEFFF', 'color');
INSERT INTO `molly_config_purple` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(11, 'Menu Windoid Text Color', 'MenuTextColor', 'FFFFFF', 'color');
INSERT INTO `molly_config_purple` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(12, 'Page Background Color', 'PageColor', 'FFFFFF', 'color');
INSERT INTO `molly_config_purple` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(13, 'Menu Windoid Frame Color', 'MenuColor', '824A89', 'color');
INSERT INTO `molly_config_purple` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(14, 'Active Link Color', 'ActiveLinkColor', 'a845ac', 'color');
INSERT INTO `molly_config_purple` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(15, 'Menu Rollover Background Color', 'MenuRolloverBackgroundColor', 'A857A5', 'color');
INSERT INTO `molly_config_purple` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(16, 'Menu Rollover Text Color', 'MenuRolloverTextColor', 'FFFFFF', 'color');
INSERT INTO `molly_config_purple` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(17, 'Menu Selected Background Color was 3D3D67', 'MenuSelectedBackgroundColor', '623666', 'color');
INSERT INTO `molly_config_purple` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(18, 'Box default frame color', 'BoxFrameColor', '7679ad', 'color');
INSERT INTO `molly_config_purple` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(19, 'If there''s a tagline/motto for your site, it goes here.', 'tagline', 'Dynamic web site architecture &amp; content management', 'color');
INSERT INTO `molly_config_purple` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(20, 'Copyright Notice', 'copyright', '<a href="https://molly.rit.edu/" target="_blank">Molly Web Framework</a> &copy; 2000-*[CurrentYear]* by Ronald P. Vullo, Ph.D. All Rights Reserved', 'text');
INSERT INTO `molly_config_purple` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(21, 'Page Background Color', 'BackgroundColor', '680C62', 'color');
INSERT INTO `molly_config_purple` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(22, 'Color of link on mouse hover', 'HoverLinkColor', '393939', 'color');
INSERT INTO `molly_config_purple` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(23, 'Menu Text Color', 'MenuLinkColor', 'FFFFFF', 'color');
INSERT INTO `molly_config_purple` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(24, 'Sidebar Heading Background Color', 'SidebarHeadingBackgroundColor', '713E77', 'color');
INSERT INTO `molly_config_purple` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(25, 'Sidebar Heading Text Color', 'SidebarHeadingTextColor', 'FFFFFF', 'color');
INSERT INTO `molly_config_purple` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(26, 'Sidebar Link Color', 'SidebarLinkColor', '11232F', 'color');
INSERT INTO `molly_config_purple` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(27, 'Background image for the site', 'BackgroundImage', 'background_image.tplt.jpg', 'image');
INSERT INTO `molly_config_purple` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(28, 'Windoid Field Color', 'WindoidFieldColor', 'FAF4FC', 'color');
INSERT INTO `molly_config_purple` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(29, 'Windoid Frame Color', 'WindoidFrameColor', 'F1E1F7', 'color');
INSERT INTO `molly_config_purple` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(30, 'Selected Menu Item Text Color', 'MenuSelectedTextColor', 'FFFFFF', 'color');
INSERT INTO `molly_config_purple` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(31, '[DO NOT EDIT] Last run of web cron (Unix Time)', 'WebCronLastRun', '1531609339', 'none');
INSERT INTO `molly_config_purple` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(32, 'Site logo', 'SiteLogo', 'logo_1.gif', 'image');

-- --------------------------------------------------------

--
-- Table structure for table `molly_config_red`
--

CREATE TABLE IF NOT EXISTS `molly_config_red` (
  `configid` mediumint(9) NOT NULL AUTO_INCREMENT,
  `description` varchar(255) NOT NULL DEFAULT '',
  `setting` varchar(255) NOT NULL DEFAULT '',
  `value` varchar(255) DEFAULT NULL,
  `whichpicker` varchar(255) DEFAULT 'color',
  PRIMARY KEY (`configid`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=91 ;

--
-- Dumping data for table `molly_config_red`
--

INSERT INTO `molly_config_red` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(1, 'Web Site Name', 'SiteName', 'Molly', 'none');
INSERT INTO `molly_config_red` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(2, 'Tab Background Color - Hover', 'TabColorHover', 'a7e8e8', 'color');
INSERT INTO `molly_config_red` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(3, 'Tab Background Color - Selected', 'SelectedTabColor', 'F0CFD0', 'color');
INSERT INTO `molly_config_red` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(4, 'Tab Background Color -Unselected', 'UnselectedTabColor', 'e19194', 'color');
INSERT INTO `molly_config_red` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(5, 'Text Color', 'TextColor', '212121', 'color');
INSERT INTO `molly_config_red` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(6, 'Link Color', 'LinkColor', '393939', 'color');
INSERT INTO `molly_config_red` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(7, 'Visited Link Color', 'VisitedLinkColor', '1b3327', 'color');
INSERT INTO `molly_config_red` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(8, 'Form Dark Area Color', 'FormDark', 'D0BBC0', 'color');
INSERT INTO `molly_config_red` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(9, 'Form Medium Area Color', 'FormMedium', 'e5b9bb', 'color');
INSERT INTO `molly_config_red` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(10, 'Form Light Area Color', 'FormLight', 'FFE0E1', 'color');
INSERT INTO `molly_config_red` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(11, 'Menu Windoid Text Color', 'MenuTextColor', 'FFFFFF', 'color');
INSERT INTO `molly_config_red` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(12, 'Page Background Color', 'PageColor', 'FFFFFF', 'color');
INSERT INTO `molly_config_red` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(13, 'Menu Windoid Frame Color', 'MenuColor', '884949', 'color');
INSERT INTO `molly_config_red` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(14, 'Active Link Color', 'ActiveLinkColor', 'FFFFFF', 'color');
INSERT INTO `molly_config_red` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(15, 'Menu Rollover Background Color', 'MenuRolloverBackgroundColor', '773D3D', 'color');
INSERT INTO `molly_config_red` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(16, 'Menu Rollover Text Color', 'MenuRolloverTextColor', 'dfb2b2', 'color');
INSERT INTO `molly_config_red` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(17, 'Menu Selected Background Color', 'MenuSelectedBackgroundColor', 'a34f4f', 'color');
INSERT INTO `molly_config_red` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(18, 'Box default frame color', 'BoxFrameColor', 'ad7679', 'color');
INSERT INTO `molly_config_red` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(19, 'If there''s a tagline/motto for your site, it goes here.', 'tagline', 'Dynamic web site architecture &amp; content management', 'none');
INSERT INTO `molly_config_red` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(20, 'Copyright Notice', 'copyright', '<a href="https://molly.rit.edu/" target="_blank">Molly Web Framework</a> &copy; 2000-*[CurrentYear]* by Ronald P. Vullo, Ph.D. All Rights Reserved', 'none');
INSERT INTO `molly_config_red` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(21, 'Page Background Color', 'BackgroundColor', '2A1A1A', 'color');
INSERT INTO `molly_config_red` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(22, 'Color of link on mouse hover', 'HoverLinkColor', '543232', 'color');
INSERT INTO `molly_config_red` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(23, 'Menu Text Color', 'MenuLinkColor', 'FFFFFF', 'color');
INSERT INTO `molly_config_red` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(24, 'Sidebar Heading Background Color', 'SidebarHeadingBackgroundColor', '773D3D', 'color');
INSERT INTO `molly_config_red` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(25, 'Sidebar Heading Text Color', 'SidebarHeadingTextColor', 'FFFFFF', 'color');
INSERT INTO `molly_config_red` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(26, 'Sidebar Link Color', 'SidebarLinkColor', '11232F', 'color');
INSERT INTO `molly_config_red` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(27, 'Background image for the site', 'BackgroundImage', 'background_image.tplt.jpg', 'image');
INSERT INTO `molly_config_red` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(28, 'Windoid Field Color', 'WindoidFieldColor', 'd9c5c6', 'color');
INSERT INTO `molly_config_red` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(29, 'Windoid Frame Color', 'WindoidFrameColor', 'C1ACA1', 'color');
INSERT INTO `molly_config_red` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(30, 'Selected Menu Item Text Color', 'MenuSelectedTextColor', 'FFFFFF', 'color');
INSERT INTO `molly_config_red` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(31, '[DO NOT EDIT] Last run of web cron (Unix Time)', 'WebCronLastRun', '1531611127', 'none');
INSERT INTO `molly_config_red` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(32, 'Site logo', 'SiteLogo', 'logo_1.gif', 'color');

-- --------------------------------------------------------

--
-- Table structure for table `molly_config_retroblue`
--

CREATE TABLE IF NOT EXISTS `molly_config_retroblue` (
  `configid` mediumint(9) NOT NULL AUTO_INCREMENT,
  `description` varchar(255) NOT NULL DEFAULT '',
  `setting` varchar(255) NOT NULL DEFAULT '',
  `value` varchar(255) DEFAULT NULL,
  `whichpicker` varchar(255) DEFAULT 'color',
  PRIMARY KEY (`configid`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=74 ;

--
-- Dumping data for table `molly_config_retroblue`
--

INSERT INTO `molly_config_retroblue` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(1, 'Web Site Name', 'SiteName', 'Molly', 'text');
INSERT INTO `molly_config_retroblue` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(2, 'Tab Background Color - Hover', 'TabColorHover', 'e8e8a7', 'color');
INSERT INTO `molly_config_retroblue` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(3, 'Tab Background Color - Selected', 'SelectedTabColor', 'CFD0F0', 'color');
INSERT INTO `molly_config_retroblue` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(4, 'Tab Background Color - Unselected', 'UnselectedTabColor', '9194e1', 'color');
INSERT INTO `molly_config_retroblue` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(5, 'Text Color', 'TextColor', '0e125d', 'color');
INSERT INTO `molly_config_retroblue` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(6, 'Link Color', 'LinkColor', '282c87', 'color');
INSERT INTO `molly_config_retroblue` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(7, 'Visited Link Color', 'VisitedLinkColor', '33271b', 'color');
INSERT INTO `molly_config_retroblue` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(8, 'Form Dark Area Color', 'FormDark', '0e125d', 'color');
INSERT INTO `molly_config_retroblue` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(9, 'Form Medium Area Color', 'FormMedium', '9194e1', 'color');
INSERT INTO `molly_config_retroblue` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(10, 'Form Light Area Color', 'FormLight', 'dbdeff', 'color');
INSERT INTO `molly_config_retroblue` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(11, 'Menu Windoid Text Color', 'MenuTextColor', '222277', 'color');
INSERT INTO `molly_config_retroblue` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(12, 'Page Background Color', 'PageColor', 'e9eaf4', 'color');
INSERT INTO `molly_config_retroblue` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(13, 'Menu Windoid Frame Color', 'MenuColor', '282c87', 'color');
INSERT INTO `molly_config_retroblue` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(14, 'Active Link Color', 'ActiveLinkColor', '0e125d', 'color');
INSERT INTO `molly_config_retroblue` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(15, 'Menu Rollover Background Color', 'MenuRolloverBackgroundColor', '9295e2', 'color');
INSERT INTO `molly_config_retroblue` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(16, 'Menu Rollover Text Color', 'MenuRolloverTextColor', '302D5B', 'color');
INSERT INTO `molly_config_retroblue` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(17, 'Menu Selected Background Color was 3D3D67', 'MenuSelectedBackgroundColor', '9295e2', 'color');
INSERT INTO `molly_config_retroblue` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(18, 'Box default frame color', 'BoxFrameColor', 'd9eaf4', 'color');
INSERT INTO `molly_config_retroblue` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(19, 'If there''s a tagline/motto for your site, it goes here.', 'tagline', 'Dynamic web site architecture &amp; content management', 'text');
INSERT INTO `molly_config_retroblue` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(20, 'Copyright Notice', 'copyright', '<a href="https://molly.rit.edu/" target="_blank">Molly Web Framework</a> &copy; 2000-*[CurrentYear]* by Ronald P. Vullo, Ph.D. All Rights Reserved', 'text');
INSERT INTO `molly_config_retroblue` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(21, 'Page Background Color', 'BackgroundColor', '0e125d', 'color');
INSERT INTO `molly_config_retroblue` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(22, 'Color of link on mouse hover', 'HoverLinkColor', '393939', 'color');
INSERT INTO `molly_config_retroblue` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(23, 'Menu Text Color', 'MenuLinkColor', 'FFFFFF', 'color');
INSERT INTO `molly_config_retroblue` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(24, 'Sidebar Heading Background Color', 'SidebarHeadingBackgroundColor', '382c87', 'color');
INSERT INTO `molly_config_retroblue` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(25, 'Sidebar Heading Text Color', 'SidebarHeadingTextColor', 'FFFFFF', 'color');
INSERT INTO `molly_config_retroblue` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(26, 'Sidebar Link Color', 'SidebarLinkColor', '232F01', 'color');
INSERT INTO `molly_config_retroblue` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(27, 'Background image for the site', 'BackgroundImage', 'background_image.tplt.jpg', 'image');
INSERT INTO `molly_config_retroblue` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(28, 'Windoid Field Color', 'WindoidFieldColor', 'e9eaf4', 'color');
INSERT INTO `molly_config_retroblue` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(29, 'Windoid Frame Color', 'WindoidFrameColor', '9b9fea', 'color');
INSERT INTO `molly_config_retroblue` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(30, 'Selected Menu Item Text Color', 'MenuSelectedTextColor', '38040e', 'color');
INSERT INTO `molly_config_retroblue` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(31, '[DO NOT EDIT] Last run of web cron (Unix Time)', 'WebCronLastRun', '1531616323', 'none');
INSERT INTO `molly_config_retroblue` (`configid`, `description`, `setting`, `value`, `whichpicker`) VALUES(32, 'Site logo', 'SiteLogo', 'logo_1.gif', 'color');

-- --------------------------------------------------------

--
-- Table structure for table `molly_login`
--

CREATE TABLE IF NOT EXISTS `molly_login` (
  `user_id` mediumint(10) NOT NULL AUTO_INCREMENT,
  `loginname` varchar(20) NOT NULL DEFAULT '',
  `password` varchar(512) CHARACTER SET latin1 COLLATE latin1_bin NOT NULL DEFAULT '',
  `login_time` datetime NOT NULL,
  PRIMARY KEY (`user_id`),
  UNIQUE KEY `LoginName` (`loginname`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=4 ;

ALTER TABLE `molly_login` CHANGE `password` `password` VARCHAR( 512 ) CHARACTER SET latin1 COLLATE latin1_bin NOT NULL DEFAULT ''

--
-- Dumping data for table `molly_login`
--

INSERT INTO `molly_login` (`user_id`, `loginname`, `password`, `login_time`) VALUES(1, 'Admin', 'clear', '2017-08-01 00:57:06');
INSERT INTO `molly_login` (`user_id`, `loginname`, `password`, `login_time`) VALUES(2, 'rvullo', 'clear', '2018-07-15 08:16:21');

-- --------------------------------------------------------

--
-- Table structure for table `molly_login_history`
--

CREATE TABLE IF NOT EXISTS `molly_login_history` (
  `user_id` mediumint(10) NOT NULL DEFAULT '0',
  `login_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  KEY `user_id` (`user_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `molly_permissions`
--

CREATE TABLE IF NOT EXISTS `molly_permissions` (
  `permission_id` mediumint(10) NOT NULL AUTO_INCREMENT,
  `user_id` mediumint(10) NOT NULL DEFAULT '0',
  `group_name` varchar(80) NOT NULL DEFAULT 'all',
  `permitted` tinyint(4) NOT NULL DEFAULT '0',
  `group_type` enum('shared','independent','exclusive') NOT NULL DEFAULT 'independent' COMMENT 'shared: Users can grant and revoke permissions for each other independent: multiple users in group but can''t grant/revoke exclusive: one member allowed in group',
  PRIMARY KEY (`permission_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=8 ;

--
-- Dumping data for table `molly_permissions`
--

INSERT INTO `molly_permissions` (`permission_id`, `user_id`, `group_name`, `permitted`, `group_type`) VALUES(1, 2, 'admin', 1, 'independent');
INSERT INTO `molly_permissions` (`permission_id`, `user_id`, `group_name`, `permitted`, `group_type`) VALUES(2, 1, 'admin', 1, 'independent');
INSERT INTO `molly_permissions` (`permission_id`, `user_id`, `group_name`, `permitted`, `group_type`) VALUES(3, 2, 'editor', 1, 'independent');
INSERT INTO `molly_permissions` (`permission_id`, `user_id`, `group_name`, `permitted`, `group_type`) VALUES(4, 2, 'config', 1, 'independent');
INSERT INTO `molly_permissions` (`permission_id`, `user_id`, `group_name`, `permitted`, `group_type`) VALUES(5, 3, 'editor', 1, 'independent');
INSERT INTO `molly_permissions` (`permission_id`, `user_id`, `group_name`, `permitted`, `group_type`) VALUES(7, 2, 'teacher', 1, 'independent');

-- --------------------------------------------------------

--
-- Table structure for table `molly_sessions`
--

CREATE TABLE IF NOT EXISTS `molly_sessions` (
  `sesskey` varchar(64) NOT NULL DEFAULT '',
  `expiry` int(10) unsigned NOT NULL DEFAULT '0',
  `value` longtext,
  `loginname` varchar(255) NOT NULL DEFAULT '',
  `user_id` mediumint(9) DEFAULT '0',
  PRIMARY KEY (`sesskey`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `molly_test`
--

CREATE TABLE IF NOT EXISTS `molly_test` (
  `test_id` mediumint(9) NOT NULL AUTO_INCREMENT,
  `name` varchar(30) DEFAULT NULL,
  `eyecolor` varchar(30) DEFAULT NULL,
  `age` mediumint(9) DEFAULT NULL,
  `file_token` varchar(255) NOT NULL,
  PRIMARY KEY (`test_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=53 ;

--
-- Dumping data for table `molly_test`
--

INSERT INTO `molly_test` (`test_id`, `name`, `eyecolor`, `age`, `file_token`) VALUES(1, 'Michelle', 'brown', 14, '');
INSERT INTO `molly_test` (`test_id`, `name`, `eyecolor`, `age`, `file_token`) VALUES(2, 'Ron', 'Brown', 48, '');
INSERT INTO `molly_test` (`test_id`, `name`, `eyecolor`, `age`, `file_token`) VALUES(3, 'Tim', 'brown', 22, '');
INSERT INTO `molly_test` (`test_id`, `name`, `eyecolor`, `age`, `file_token`) VALUES(4, 'Heather', 'Blue', 28, '');
INSERT INTO `molly_test` (`test_id`, `name`, `eyecolor`, `age`, `file_token`) VALUES(5, 'Genny', 'Brown', 6, '');
INSERT INTO `molly_test` (`test_id`, `name`, `eyecolor`, `age`, `file_token`) VALUES(6, 'Jane', 'hazel', 44, '2');
INSERT INTO `molly_test` (`test_id`, `name`, `eyecolor`, `age`, `file_token`) VALUES(7, 'Zeus', 'black', 3000, '');
INSERT INTO `molly_test` (`test_id`, `name`, `eyecolor`, `age`, `file_token`) VALUES(8, 'Juan', 'Pink', 5, '1');
INSERT INTO `molly_test` (`test_id`, `name`, `eyecolor`, `age`, `file_token`) VALUES(9, 'Alfonso', 'Blue', 88, '');
INSERT INTO `molly_test` (`test_id`, `name`, `eyecolor`, `age`, `file_token`) VALUES(10, 'Sam', 'Green', 99, '');
INSERT INTO `molly_test` (`test_id`, `name`, `eyecolor`, `age`, `file_token`) VALUES(11, 'Paco', 'Brown', 22, '');
INSERT INTO `molly_test` (`test_id`, `name`, `eyecolor`, `age`, `file_token`) VALUES(12, 'Jose', 'purple', 128, '');

-- --------------------------------------------------------

--
-- Table structure for table `molly_username`
--

CREATE TABLE IF NOT EXISTS `molly_username` (
  `user_id` mediumint(10) NOT NULL DEFAULT '0',
  `lastname` varchar(20) DEFAULT NULL,
  `firstname` varchar(20) DEFAULT NULL,
  `middlename` varchar(20) DEFAULT NULL,
  `salutation` varchar(30) DEFAULT NULL,
  `suffix` varchar(20) DEFAULT NULL,
  `email` varchar(255) DEFAULT NULL,
  `login_time` datetime NOT NULL,
  `first_login` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `preferredlanguage` varchar(6) DEFAULT NULL,
  PRIMARY KEY (`user_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `molly_username`
--

INSERT INTO `molly_username` (`user_id`, `lastname`, `firstname`, `middlename`, `salutation`, `suffix`, `email`, `login_time`, `first_login`, `preferredlanguage`) VALUES(1, 'Administrator', 'System', '', 'Dr.', NULL, NULL, '2017-08-01 00:57:06', '0000-00-00 00:00:00', 'en');
INSERT INTO `molly_username` (`user_id`, `lastname`, `firstname`, `middlename`, `salutation`, `suffix`, `email`, `login_time`, `first_login`, `preferredlanguage`) VALUES(2, 'Vullo', 'Ronald', 'P.', 'Dr', NULL, NULL, '2018-07-15 08:16:21', '0000-00-00 00:00:00', 'en');
