<?php
	// Check if session is valid / has forms existing within it
	if(!isset($_SESSION['forms'])) {
		header("Location:" . $_SERVER['HTTP_REFERER'] . '?t_error=' . urlencode("Session expired/invalid, please try again:"));
		die();
	}

	// Find form in session
	$fv_form = null;
	foreach($_SESSION['forms'] as $fv_sessform => $fv_formdata) {
		if($fv_sessform == $_REQUEST['formToken']) {
			$fv_form = $fv_formdata;
		}
	}

	// If form couldn't be found, invalidate the data & tell the user
	if(!isset($fv_form)) {
		header("Location:" . $_SERVER['HTTP_REFERER'] . '?t_error=' . urlencode("Session expired/invalid, please try again:"));
		die();
	}

	// If form has a permitted attribute, validate group
	// TODO: Expand to allow IP ranges, etc.
	if(isset($fv_form['permitted'])) {
		if(!m_permitted($fv_form['permitted'])) {
			header("Location:" . $_SERVER['HTTP_REFERER'] . '?t_error=' . urlencode("You do not have permission to use this form."));
			die();
		}
	}

	// If the form has a captcha, validate it
	if(isset($fv_form['captcha'])) {
		// check to see if capcha matches
		if ($_REQUEST['molly_captcha'] != $_SESSION['m_captchacode']) {
			$captcha_error = "You did not enter the letters shown in the image. Please try again:";
			if (strpos($_SERVER['HTTP_REFERER'],'t_error') === FALSE) {
				header("Location:" . $_SERVER['HTTP_REFERER'] . '?t_error=' . urlencode($captcha_error));
			} else {
				header("Location:" . $_SERVER['HTTP_REFERER']);
			}
			exit();
		} else {
			m_captchadone();
		}
	}

	// If there's hidden/enforced input, inject it (note: $_GET & $_POST are not used here)
	if(isset($fv_form['request_override'])) {
		$_REQUEST = injectRecursive($_REQUEST, $fv_form['request_override']);
	}

	if(isset($fv_form['hash'])) {
		function hashRecursive($fv_array_base, $fv_array_data) {
			foreach($fv_array_base as $fv_array_key => $fv_array_value) {
				if(array_key_exists($fv_array_key, $fv_array_data)) {
					if(is_array($fv_array_data[$fv_array_key])) {
						$fv_array_base[$fv_array_key] = hashRecursive($fv_array_value, $fv_array_data[$fv_array_key]);
					} else {
						if($fv_array_data[$fv_array_key] == 'true') {
							$fv_array_base[$fv_array_key] = m_HashPassword($fv_array_value);
						}
					}
				}
			}
			return $fv_array_base;
		}
		$_REQUEST['t_FormData']['0'] = injectRecursive($_REQUEST['t_FormData']['0'], hashRecursive($_REQUEST['t_FormData']['0'], $fv_form['hash']));
	}

	//echo('<pre>'.var_export($fv_form).'</pre>');
	if(isset($fv_form['match'])) {
		foreach($fv_form['match'] as $fv_key => $fv_matched) {
			/*echo(
				$fv_key.' ('.$_REQUEST['t_FormData']['0'][$fv_key].')'.
				' == '.
				$fv_matched.' ('.$_REQUEST['t_FormData']['0'][$fv_matched].')'.
				': '.($_REQUEST['t_FormData']['0'][$fv_key] == $_REQUEST['t_FormData']['0'][$fv_matched] ? 'TRUE' : 'FALSE')
			);*/
			if($_REQUEST['t_FormData']['0'][$fv_key] != $_REQUEST['t_FormData']['0'][$fv_matched]) {
				if (strpos($_SERVER['HTTP_REFERER'],'t_error') === FALSE) {
					header("Location:" . $_SERVER['HTTP_REFERER'] . '?t_error=' . urlencode('Verification of a field failed'));
				} else {
					header("Location:" . $_SERVER['HTTP_REFERER']);
				}
			}
		}
	}
	//die();

	// If requested (in <maml:form>), email webmaster
	if(isset($fv_form['emailOnSubmit']) && $fv_form['emailOnSubmit'] == "true") {
		global $gv_Config, $gv_TokenVariables;

		$tokens = array_merge($gv_Config, $_SESSION['tokens']);
		if(isset($fv_form['emailTokens'])) {
			$tokens = array_merge($tokens, $fv_form['emailTokens']);
		}
		$tokens['f_Page'] = $fv_form['page'];

		foreach($gv_TokenVariables as $fv_key=>$fv_val) {
			if(substr($fv_key, 0, 2) == 't_') {
				$tokens[$fv_key] = '';
			}
		}

		/*$headers = 'Mime-Version: 1.0' . "\r\n" . 'Content-type: text/html; charset=iso-8859-1';
		if(isset($fv_form['emailOptions']['replyTo'])) {
			$headers .= "\r\n" . 'Reply-To: ' . $fv_form['emailOptions']['replyTo'];
		}*/

		mail($fv_form['emailOptions']['to'], m_Interpolate($fv_form['emailOptions']['subject'], $tokens), wordwrap(m_Interpolate($fv_form['emailOptions']['body'], $tokens), 70, "\r\n")); //, $headers);
	}

	// If there's hidden/enforced input, inject it (note: $_GET & $_POST are not used here)
	if(isset($fv_form['noquery'])) {
		foreach($fv_form['noquery'] as $key) {
			unset($_REQUEST['t_FormData']['0'][$key]);
		}
	}
?>
